<?php /* Backup settings */
add_action("discy_options_page","discy_backup_settings");
function discy_backup_settings() {
	if (isset($_GET['backup']) && $_GET['backup'] == 'settings') {
		$json = "backup-".date('Y-m-d',time()).".txt";
		$file = fopen($json,'w');
		$export = array(discy_options);
		$current_options = array();
		foreach ($export as $option) {
			$get_option_ = get_option($option);
			if ($get_option_) {
				$current_options[$option] = $get_option_;
			}else {
				$current_options[$option] = array();
			}
		}
		$array_json = json_encode($current_options);
		$array_json = base64_encode($array_json);
		fwrite($file,$array_json);
		fclose($file);
		header('Content-disposition: attachment; filename='.$json);
		header('Content-type: text/xml');
		ob_clean();
		flush();
		readfile($json);
		exit();
	}
}
/* Admin options */
function discy_admin_options() {
	$activate_currencies = discy_options("activate_currencies");
	$multi_currencies = discy_options("multi_currencies");
	$wp_editor_settings = array("media_buttons" => true,"textarea_rows" => 10);
	// Background Defaults
	$background_defaults = array(
		'color'      => '',
		'image'      => '',
		'repeat'     => 'repeat',
		'position'   => 'top center',
		'attachment' =>'scroll' 
	);

	// Pull all the pages into an array
	$options_pages = array();
	$options_pages_obj = get_pages('sort_column=post_parent,menu_order');
	$options_pages[''] = 'Select a page:';
	foreach ($options_pages_obj as $page) {
		$options_pages[$page->ID] = $page->post_title;
	}
	
	// Pull all the sidebars into an array
	$new_sidebars = array('default'=> 'Default');
	foreach ($GLOBALS['wp_registered_sidebars'] as $sidebar) {
		$new_sidebars[$sidebar['id']] = $sidebar['name'];
	}
	
	// Menus
	$menus = array();
	$all_menus = get_terms('nav_menu',array('hide_empty' => true));
	foreach ($all_menus as $menu) {
	    $menus[$menu->term_id] = $menu->name;
	}
	
	// Pull all the roles into an array
	global $wp_roles;
	$new_roles = array();
	foreach ($wp_roles->roles as $key => $value) {
		$new_roles[$key] = $value['name'];
	}
	
	// Share
	$share_array = array(
		"share_facebook" => array("sort" => "Facebook","value" => "share_facebook"),
		"share_twitter"  => array("sort" => "Twitter","value" => "share_twitter"),
		"share_linkedin" => array("sort" => "LinkedIn","value" => "share_linkedin"),
		"share_whatsapp" => array("sort" => "WhatsApp","value" => "share_whatsapp"),
	);

	$currencies = array(
		'USD' => 'USD',
		'EUR' => 'EUR',
		'GBP' => 'GBP',
		'JPY' => 'JPY',
		'CAD' => 'CAD',
		'INR' => 'INR',
		'TRY' => 'TRY',
		'BRL' => 'BRL',
		'HUF' => 'HUF',
		'BDT' => 'BDT',
		'AUD' => 'AUD',
		'IDR' => 'IDR'
	);

	$currencies = apply_filters("wpqa_currencies",$currencies);
	
	// Export
	$export = array(discy_options);
	$current_options = array();
	foreach ($export as $option) {
		$get_option_ = get_option($option);
		if ($get_option_) {
			$current_options[$option] = $get_option_;
		}else {
			$current_options[$option] = array();
		}
	}
	$current_options_e = json_encode($current_options);
	$current_options_e = base64_encode($current_options_e);
	
	// If using image radio buttons, define a directory path
	$imagepath =  get_template_directory_uri().'/admin/images/';
	$imagepath_theme =  get_template_directory_uri().'/images/';

	$options = array();
	
	$options[] = array(
		'name' => esc_html__('General settings','discy'),
		'id'   => 'general',
		'icon' => 'admin-site',
		'type' => 'heading'
	);
	
	$options[] = array(
		'type' => 'heading-2'
	);

	$options = apply_filters('discy_options_before_general_setting',$options);
	
	$options[] = array(
		'name' => esc_html__('Activate the lightbox at the site','discy'),
		'desc' => esc_html__('Select ON if you want to active the lightbox at the site.','discy'),
		'id'   => 'active_lightbox',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate scroll to up button at the site','discy'),
		'desc' => esc_html__('Select ON if you want to activate scroll to top button at the site.','discy'),
		'id'   => 'go_up_button',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the ask question button at the site','discy'),
		'desc' => esc_html__('Select ON if you want to activate the ask question button at the site next to scroll to top button.','discy'),
		'id'   => 'ask_button',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the font awesome at the site','discy'),
		'desc' => esc_html__('Select ON if you want to active the font awesome at the site.','discy'),
		'id'   => 'active_awesome',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Enable loader','discy'),
		'desc' => esc_html__('Select ON to enable loader.','discy'),
		'id'   => 'loader',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => sprintf(esc_html__('Type the date format %1$s see this link %2$s.','discy'),'<a href="https://codex.wordpress.org/Formatting_Date_and_Time" target="_blank">','</a>'),
		'desc' => esc_html__('Type here your date format.','discy'),
		'id'   => 'date_format',
		'std'  => 'F j, Y',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => sprintf(esc_html__('Type the time format %1$s see this link %2$s.','discy'),'<a href="https://codex.wordpress.org/Formatting_Date_and_Time" target="_blank">','</a>'),
		'desc' => esc_html__('Type here your time format.','discy'),
		'id'   => 'time_format',
		'std'  => 'g:i a',
		'type' => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('Excerpt type ','discy'),
		'desc'    => esc_html__('Choose form here the excerpt type.','discy'),
		'id'      => 'excerpt_type',
		'std'     => 'words',
		'type'    => "select",
		'options' => array(
			'words'      => esc_html__('Words','discy'),
			'characters' => esc_html__('Characters','discy')
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Hide the top bar for WordPress','discy'),
		'desc' => esc_html__('Select ON if you want to hide the top bar for WordPress.','discy'),
		'id'   => 'top_bar_wordpress',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$roles_no_admin = $new_roles;
	unset($roles_no_admin["administrator"]);
	
	$options[] = array(
		'name'      => esc_html__("Choose the roles you don't want to show the WordPress admin top bar.","discy"),
		'id'        => 'top_bar_groups',
		'type'      => 'multicheck',
		'options'   => $roles_no_admin,
		'condition' => 'top_bar_wordpress:not(0)',
		'std'       => array('wpqa_under_review' => 'wpqa_under_review','ban_group' => 'ban_group','activation' => 'activation','subscriber' => 'subscriber','author' => 'author'),
	);
	
	$options[] = array(
		'name' => esc_html__('Do you like to redirect unlogged users from WordPress admin?','discy'),
		'desc' => esc_html__('Select ON if you want to redirect the unlogged users from the WordPress admin to the theme login page.','discy'),
		'id'   => 'redirect_wp_admin_unlogged',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Do you need to redirect user from WordPress admin?','discy'),
		'desc' => esc_html__('Select ON if you want to redirect the user from the WordPress admin.','discy'),
		'id'   => 'redirect_wp_admin',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__("Choose the roles you don't want to show the WordPress admin.","discy"),
		'id'        => 'redirect_groups',
		'type'      => 'multicheck',
		'options'   => $roles_no_admin,
		'condition' => 'redirect_wp_admin:not(0)',
		'std'       => array('wpqa_under_review' => 'wpqa_under_review','ban_group' => 'ban_group','activation' => 'activation','subscriber' => 'subscriber','author' => 'author'),
	);
	
	$options[] = array(
		'name' => esc_html__('Enable SEO options','discy'),
		'desc' => esc_html__('Select ON to enable SEO options.','discy'),
		'id'   => 'seo_active',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Share image','discy'),
		'desc'      => esc_html__('This is the share image','discy'),
		'id'        => 'fb_share_image',
		'condition' => 'seo_active:not(0)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name' => esc_html__('Head code','discy'),
		'desc' => esc_html__('Paste your Google analytics code in the box','discy'),
		'id'   => 'head_code',
		'type' => 'textarea'
	);

	$options[] = array(
		'name' => esc_html__('Footer code','discy'),
		'desc' => esc_html__('Paste footer code in the box','discy'),
		'id'   => 'footer_code',
		'type' => 'textarea'
	);
	
	$options[] = array(
		'name' => esc_html__('SEO keywords','discy'),
		'desc' => esc_html__('Paste your keywords in the box','discy'),
		'id'   => 'the_keywords',
		'type' => 'textarea'
	);
	
	$options[] = array(
		'name' => esc_html__('WordPress login logo','discy'),
		'desc' => esc_html__('This is the logo that appears on the default WordPress login page','discy'),
		'id'   => 'login_logo',
		'std'  => $imagepath_theme."logo-footer.png",
		'type' => 'upload'
	);
	
	$options[] = array(
		'name' => esc_html__('WordPress login logo height','discy'),
		"id"   => "login_logo_height",
		"type" => "sliderui",
		'std'  => '45',
		"step" => "1",
		"min"  => "0",
		"max"  => "300"
	);
	
	$options[] = array(
		'name' => esc_html__('WordPress login logo width','discy'),
		"id"   => "login_logo_width",
		"type" => "sliderui",
		'std'  => '166',
		"step" => "1",
		"min"  => "0",
		"max"  => "300"
	);
	
	if (!function_exists('wp_site_icon') || !has_site_icon()) {
		$options[] = array(
			'name' => esc_html__('Custom favicon','discy'),
			'desc' => esc_html__("Upload the site's favicon here , You can create new favicon here favicon.cc","discy"),
			'id'   => 'favicon',
			'std'  => $imagepath_theme."favicon.png",
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom favicon for iPhone','discy'),
			'desc' => esc_html__('Upload your custom iPhone favicon','discy'),
			'id'   => 'iphone_icon',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom iPhone retina favicon','discy'),
			'desc' => esc_html__('Upload your custom iPhone retina favicon','discy'),
			'id'   => 'iphone_icon_retina',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom favicon for iPad','discy'),
			'desc' => esc_html__('Upload your custom iPad favicon','discy'),
			'id'   => 'ipad_icon',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom iPad retina favicon','discy'),
			'desc' => esc_html__('Upload your custom iPad retina favicon','discy'),
			'id'   => 'ipad_icon_retina',
			'type' => 'upload'
		);
	}
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);

	$options = apply_filters("discy_options_after_general_setting",$options,$options_pages);
	
	$options[] = array(
		'name' => esc_html__('Under construction','discy'),
		'id'   => 'construction',
		'type' => 'heading',
		'icon' => 'admin-tools',
	);

	$options[] = array(
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate under construction','discy'),
		'desc' => esc_html__('Select ON to enable under construction.','discy'),
		'id'   => 'under_construction',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'under_construction:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Upload the background','discy'),
		'desc'    => esc_html__('Upload the background for the under construction page','discy'),
		'id'      => 'construction_background',
		'type'    => 'background',
		'options' => array('color' => '','image' => ''),
		'std'     => array(
			'color' => '#272930',
			'image' => $imagepath_theme."register.png"
		)
	);
	
	$options[] = array(
		"name" => esc_html__('Choose the background opacity','discy'),
		"desc" => esc_html__('Choose the background opacity from here','discy'),
		"id"   => "construction_opacity",
		"type" => "sliderui",
		'std'  => 30,
		"step" => "5",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'name' => esc_html__('The headline','discy'),
		'desc' => esc_html__('Type the Headline from here','discy'),
		'id'   => 'construction_headline',
		'type' => 'text',
		'std'  => 'Coming soon'
	);
	
	$options[] = array(
		'name' => esc_html__('The paragraph','discy'),
		'desc' => esc_html__('Type the Paragraph from here','discy'),
		'id'   => 'construction_paragraph',
		'type' => 'textarea',
		'std'  => 'The site is under construction and something great is coming soon.'
	);
	
	$options[] = array(
		'name' => esc_html__('Construction redirect','discy'),
		'desc' => esc_html__('Type the link of the construction redirect','discy'),
		'id'   => 'construction_redirect',
		'type' => 'text',
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);

	$header_settings = array(
		"header_s"     => esc_html__('Header setting','discy'),
		"call_action"  => esc_html__('Call to action','discy'),
		"breadcrumb_s" => esc_html__('Breadcrumbs','discy'),
		"posts_header" => esc_html__('Posts at header or footer','discy'),
		"slider"       => esc_html__('Slider','discy'),
	);
	
	$options[] = array(
		'name'    => esc_html__('Header settings','discy'),
		'id'      => 'header',
		'type'    => 'heading',
		'icon'    => 'menu',
		'std'     => 'header_s',
		'options' => apply_filters("discy_header_settings",$header_settings)
	);
	
	$options[] = array(
		'name' => esc_html__('Header setting','discy'),
		'id'   => 'header_s',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Header height','discy'),
		'desc'    => esc_html__('Choose the header height.','discy'),
		'id'      => 'header_height',
		'std'     => 'large',
		'type'    => 'radio',
		'options' => array("large" => esc_html__("Large","discy"),"small" => esc_html__("Small","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Header style','discy'),
		'desc'    => esc_html__('Choose the header style.','discy'),
		'id'      => 'header_style',
		'std'     => 'normal',
		'type'    => 'radio',
		'options' => array("normal" => esc_html__("Normal","discy"),"simple" => esc_html__("Simple","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Header skin','discy'),
		'desc'    => esc_html__('Choose the header skin.','discy'),
		'id'      => 'header_skin',
		'std'     => 'dark',
		'type'    => 'radio',
		'options' => array("dark" => esc_html__("Dark","discy"),"light" => esc_html__("Light","discy"),"colored" => esc_html__("Colored","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Logo display','discy'),
		'desc'    => esc_html__('Choose the logo display.','discy'),
		'id'      => 'logo_display',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_title" => esc_html__("Display site title","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Logo upload','discy'),
		'desc'      => esc_html__('Upload your custom logo.','discy'),
		'id'        => 'logo_img',
		'std'       => $imagepath_theme."logo.png",
		'type'      => 'upload',
		'condition' => 'logo_display:is(custom_image)',
		'options'   => array("height" => "logo_height","width" => "logo_width"),
	);
	
	$options[] = array(
		'name'      => esc_html__('Logo retina upload','discy'),
		'desc'      => esc_html__('Upload your custom logo retina.','discy'),
		'id'        => 'retina_logo',
		'std'       => $imagepath_theme."logo-2x.png",
		'type'      => 'upload',
		'condition' => 'logo_display:is(custom_image)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Logo height','discy'),
		"id"        => "logo_height",
		"type"      => "sliderui",
		'std'       => '45',
		"step"      => "1",
		"min"       => "0",
		"max"       => "80",
		'condition' => 'logo_display:is(custom_image)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Logo width','discy'),
		"id"        => "logo_width",
		"type"      => "sliderui",
		'std'       => '137',
		"step"      => "1",
		"min"       => "0",
		"max"       => "170",
		'condition' => 'logo_display:is(custom_image)'
	);
	
	$options[] = array(
		'name' => esc_html__('Header search option','discy'),
		'desc' => esc_html__('Select ON to enable header search.','discy'),
		'id'   => 'header_search',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Activate the bigger search bar?','discy'),
		'desc'      => esc_html__('Select ON to enable header bigger search bar.','discy'),
		'id'        => 'big_search',
		'condition' => 'header_search:not(0)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'header_style:is(simple)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name'    => esc_html__('Simple header button','discy'),
		'desc'    => esc_html__('Choose simple header button style from here.','discy'),
		'id'      => 'header_button',
		'options' => array(
			'question' => esc_html__('Ask A Question','discy'),
			'post'     => esc_html__('Add A Post','discy'),
			'custom'   => esc_html__('Custom link','discy'),
		),
		'std'     => 'question',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'header_button:is(custom)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Open the page in same page or a new page?','discy'),
		'id'      => 'header_button_target',
		'std'     => "new_page",
		'type'    => 'select',
		'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button link','discy'),
		'id'   => 'header_button_link',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button text','discy'),
		'id'   => 'header_button_text',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Header user login','discy'),
		'desc' => esc_html__('Select ON to enable header user login.','discy'),
		'id'   => 'header_user_login',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'header_user_login:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Header user login style','discy'),
		'desc'    => esc_html__('Choose header user login style.','discy'),
		'id'      => 'user_login_style',
		'std'     => 'light',
		'type'    => 'radio',
		'options' => array("light" => esc_html__("Light","discy"),"dark" => esc_html__("Dark","discy"))
	);
	
	$user_login_links = array(
		"user-profile"        => array("sort" => esc_html__('User Profile','discy'),"value" => "user-profile"),
		"edit-profile"        => array("sort" => esc_html__('Edit Profile','discy'),"value" => "edit-profile"),
		"pending-questions"   => array("sort" => esc_html__('Pending Questions','discy'),"value" => "pending-questions"),
		"pending-posts"       => array("sort" => esc_html__('Pending Posts','discy'),"value" => "pending-posts"),
		"referrals"           => array("sort" => esc_html__('Referrals','discy'),"value" => "referrals"),
		"messages"            => array("sort" => esc_html__('Messages','discy'),"value" => "messages"),
		"questions"           => array("sort" => esc_html__('Questions','discy'),"value" => ""),
		"polls"               => array("sort" => esc_html__('Polls','discy'),"value" => ""),
		"questions"           => array("sort" => esc_html__('Questions','discy'),"value" => ""),
		"answers"             => array("sort" => esc_html__('Answers','discy'),"value" => ""),
		"followed"            => array("sort" => esc_html__('Followed','discy'),"value" => ""),
		"favorites"           => array("sort" => esc_html__('Favorites','discy'),"value" => ""),
		"posts"               => array("sort" => esc_html__('Posts','discy'),"value" => ""),
		"comments"            => array("sort" => esc_html__('Comments','discy'),"value" => ""),
		"followers-questions" => array("sort" => esc_html__('Followers Questions','discy'),"value" => ""),
		"followers-answers"   => array("sort" => esc_html__('Followers Answers','discy'),"value" => ""),
		"followers-posts"     => array("sort" => esc_html__('Followers Posts','discy'),"value" => ""),
		"followers-comments"  => array("sort" => esc_html__('Followers Comments','discy'),"value" => ""),
		"groups"              => array("sort" => esc_html__('Groups','discy'),"value" => ""),
		"joined_groups"       => array("sort" => esc_html__('Joined Groups','discy'),"value" => ""),
		"managed_groups"      => array("sort" => esc_html__('Managed Groups','discy'),"value" => ""),
		"paid-questions"      => array("sort" => esc_html__('Paid Questions','discy'),"value" => ""),
		"asked-questions"     => array("sort" => esc_html__('Asked Questions','discy'),"value" => "asked-questions"),
		"best-answers"        => array("sort" => esc_html__('Best Answers','discy'),"value" => "best-answers"),
		"points"              => array("sort" => esc_html__('Points','discy'),"value" => "points"),
		"followers"           => array("sort" => esc_html__('Followers','discy'),"value" => ""),
		"following"           => array("sort" => esc_html__('Following','discy'),"value" => ""),
		"blocking"            => array("sort" => esc_html__('Blocking users','discy'),"value" => ""),
		"activities"          => array("sort" => esc_html__('Activity Log','discy'),"value" => "activities"),
		"notifications"       => array("sort" => esc_html__('Notifications','discy'),"value" => ""),
		"subscriptions"       => array("sort" => esc_html__('Subscriptions','discy'),"value" => ""),
		"question"            => array("sort" => esc_html__('Ask A Question','discy'),"value" => ""),
		"post"                => array("sort" => esc_html__('Add A Post','discy'),"value" => ""),
		"group"               => array("sort" => esc_html__('Create A Group','discy'),"value" => ""),
		"log-out"             => array("sort" => esc_html__('Log out','discy'),"value" => "log-out"),
	);
	
	$options[] = array(
		'name'         => esc_html__('Select the pages to show at the login area','discy'),
		'id'           => 'user_login_links',
		'type'         => 'multicheck',
		'sort'         => 'yes',
		'limit-height' => 'yes',
		'std'          => $user_login_links,
		'options'      => $user_login_links
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'div'       => 'div',
		'type'      => 'heading-2',
		'condition' => 'active_message:not(0),header_style:is(simple)'
	);
	
	$options[] = array(
		'name' => esc_html__('Header messages','discy'),
		'desc' => esc_html__('Select ON to enable header messages.','discy'),
		'id'   => 'header_messages',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'type'      => 'heading-2',
		'condition' => 'active_message:not(0),header_style:is(simple),header_messages:not(0)'
	);
	
	$options[] = array(
		'name'    => esc_html__('Header messages style','discy'),
		'desc'    => esc_html__('Choose header messages style.','discy'),
		'id'      => 'messages_style',
		'std'     => 'light',
		'type'    => 'radio',
		'options' => array("light" => esc_html__("Light","discy"),"dark" => esc_html__("Dark","discy"))
	);
	
	$options[] = array(
		'name' => esc_html__('Header messages number','discy'),
		'desc' => esc_html__('Put the header messages number.','discy'),
		'id'   => 'messages_number',
		'std'  => 5,
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Header notifications','discy'),
		'desc' => esc_html__('Select ON to enable header notifications.','discy'),
		'id'   => 'header_notifications',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'type'      => 'heading-2',
		'condition' => 'active_notifications:not(0),header_notifications:not(0)'
	);
	
	$options[] = array(
		'name'    => esc_html__('Header notifications style','discy'),
		'desc'    => esc_html__('Choose header notifications style.','discy'),
		'id'      => 'notifications_style',
		'std'     => 'light',
		'type'    => 'radio',
		'options' => array("light" => esc_html__("Light","discy"),"dark" => esc_html__("Dark","discy"))
	);
	
	$options[] = array(
		'name' => esc_html__('Header notifications number','discy'),
		'desc' => esc_html__('Put the header notifications number.','discy'),
		'id'   => 'notifications_number',
		'std'  => 5,
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Fixed header option','discy'),
		'desc' => esc_html__('Select ON to enable fixed header.','discy'),
		'id'   => 'header_fixed',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Call to action','discy'),
		'id'   => 'call_action',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the call to action','discy'),
		'desc' => esc_html__('Select ON to enable the call to action.','discy'),
		'id'   => 'call_action',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'type'      => 'heading-2',
		'condition' => 'call_action:not(0)'
	);
	
	$options[] = array(
		'name'    => esc_html__('The call to action works at all the pages, custom pages, or home page only?','discy'),
		'id'      => 'action_home_pages',
		'options' => array(
			'home_page'     => esc_html__('Home page','discy'),
			'all_pages'     => esc_html__('All site pages','discy'),
			'all_posts'     => esc_html__('All single post pages','discy'),
			'all_questions' => esc_html__('All single question pages','discy'),
			'custom_pages'  => esc_html__('Custom pages','discy'),
		),
		'std'     => 'home_page',
		'type'    => 'radio'
	);

	$options[] = array(
		'name'      => esc_html__('Page ids','discy'),
		'desc'      => esc_html__('Type from here the page ids','discy'),
		'id'        => 'action_pages',
		'type'      => 'text',
		'condition' => 'action_home_pages:is(custom_pages)'
	);
	
	$options[] = array(
		'name'    => esc_html__('Action skin','discy'),
		'desc'    => esc_html__('Choose the action skin.','discy'),
		'id'      => 'action_skin',
		'std'     => 'dark',
		'type'    => 'radio',
		'options' => array("light" => esc_html__("Light","discy"),"dark" => esc_html__("Dark","discy"),"colored" => esc_html__("Colored","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Action style','discy'),
		'desc'    => esc_html__('Choose action style from here.','discy'),
		'id'      => 'action_style',
		'options' => array(
			'style_1'  => 'Style 1',
			'style_2'  => 'Style 2',
		),
		'std'     => 'style_1',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name'    => esc_html__('Action image or video','discy'),
		'id'      => 'action_image_video',
		'options' => array(
			'image' => esc_html__('Image','discy'),
			'video' => esc_html__('Video','discy'),
		),
		'std'     => 'image',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'action_image_video:not(video)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Upload the background','discy'),
		'id'      => 'action_background',
		'type'    => 'background',
		'options' => array('color' => '','image' => ''),
		'std'     => array(
			'image' => $imagepath_theme."action.png"
		)
	);
	
	$options[] = array(
		"name" => esc_html__('Choose the background opacity','discy'),
		"desc" => esc_html__('Choose the background opacity from here','discy'),
		"id"   => "action_opacity",
		"type" => "sliderui",
		'std'  => 50,
		"step" => "5",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'action_image_video:is(video)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name'    => esc_html__('Video type','discy'),
		'id'      => 'action_video_type',
		'type'    => 'select',
		'options' => array(
			'youtube'  => esc_html__("Youtube","discy"),
			'vimeo'    => esc_html__("Vimeo","discy"),
			'daily'    => esc_html__("Dailymotion","discy"),
			'facebook' => esc_html__("Facebook video","discy"),
			'html5'    => esc_html__("HTML 5","discy"),
			'embed'    => esc_html__("Custom embed","discy"),
		),
		'std'     => 'youtube',
		'desc'    => esc_html__('Choose from here the video type','discy'),
	);
	
	$options[] = array(
		'name'      => esc_html__('Custom embed','discy'),
		'desc'      => esc_html__('Put your Custom embed html','discy'),
		'id'        => "action_custom_embed",
		'type'      => 'textarea',
		'cols'      => "40",
		'rows'      => "8",
		'condition' => 'action_video_type:is(embed)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Video ID','discy'),
		'id'        => 'action_video_id',
		'desc'      => esc_html__('Put the Video ID here: https://www.youtube.com/watch?v=JuyB7NO0EYY Ex: "JuyB7NO0EYY"','discy'),
		'type'      => 'text',
		'operator'  => 'or',
		'condition' => 'action_video_type:is(youtube),'.'action_video_type:is(vimeo),'.'action_video_type:is(daily),'.'action_video_type:is(facebook)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Mp4 video','discy'),
		'id'        => 'action_video_mp4',
		'desc'      => esc_html__('Put mp4 video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'name'      => esc_html__('M4v video','discy'),
		'id'        => 'action_video_m4v',
		'desc'      => esc_html__('Put m4v video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Webm video','discy'),
		'id'        => 'action_video_webm',
		'desc'      => esc_html__('Put webm video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Ogv video','discy'),
		'id'        => 'action_video_ogv',
		'desc'      => esc_html__('Put ogv video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Wmv video','discy'),
		'id'        => 'action_video_wmv',
		'desc'      => esc_html__('Put wmv video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Flv video','discy'),
		'id'        => 'action_video_flv',
		'desc'      => esc_html__('Put flv video here','discy'),
		'type'      => 'text',
		'condition' => 'action_video_type:is(html5)'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('The headline','discy'),
		'desc' => esc_html__('Type the Headline from here','discy'),
		'id'   => 'action_headline',
		'type' => 'text',
		'std'  => "Share & grow the world's knowledge!"
	);
	
	$options[] = array(
		'name'     => esc_html__('The paragraph','discy'),
		'desc'     => esc_html__('Type the Paragraph from here','discy'),
		'id'       => 'action_paragraph',
		'type'     => apply_filters('discy_action_paragraph','textarea'),
		'std'      => 'We want to connect the people who have knowledge to the people who need it, to bring together people with different perspectives so they can understand each other better, and to empower everyone to share their knowledge.'
	);
	
	$options[] = array(
		'name'    => esc_html__('Action button','discy'),
		'desc'    => esc_html__('Choose Action button style from here.','discy'),
		'id'      => 'action_button',
		'options' => array(
			'signup'   => esc_html__('Create A New Account','discy'),
			'login'    => esc_html__('Login','discy'),
			'question' => esc_html__('Ask A Question','discy'),
			'post'     => esc_html__('Add A Post','discy'),
			'custom'   => esc_html__('Custom link','discy'),
		),
		'std'     => 'signup',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'action_button:is(custom)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Open the page in same page or a new page?','discy'),
		'id'      => 'action_button_target',
		'std'     => "new_page",
		'type'    => 'select',
		'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button link','discy'),
		'id'   => 'action_button_link',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button text','discy'),
		'id'   => 'action_button_text',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name'    => esc_html__('The call to action works for "Unlogged users", "Logged users" or both','discy'),
		'desc'    => esc_html__('Choose the call to action works for "Unlogged users", "Logged users" or both.','discy'),
		'id'      => 'action_logged',
		'options' => array(
			'unlogged' => esc_html__('Unlogged users','discy'),
			'logged'   => esc_html__('Logged users','discy'),
			'both'     => esc_html__('Both','discy'),
		),
		'std'     => 'unlogged',
		'type'    => 'radio',
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Breadcrumbs','discy'),
		'id'   => 'breadcrumb_s',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Breadcrumbs','discy'),
		'desc' => esc_html__('Select ON to enable the breadcrumbs.','discy'),
		'id'   => 'breadcrumbs',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'breadcrumbs:not(0)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name'    => esc_html__('Breadcrumbs style','discy'),
		'id'      => 'breadcrumbs_style',
		'options' => array(
			'style_1' => esc_html__('Style 1','discy'),
			'style_2' => esc_html__('Style 2','discy'),
		),
		'std'     => 'style_1',
		'type'    => 'radio',
	);

	$options[] = array(
		'name'      => esc_html__('Breadcrumbs skin','discy'),
		'desc'      => esc_html__('Choose the breadcrumbs skin.','discy'),
		'id'        => 'breadcrumbs_skin',
		'std'       => 'light',
		'type'      => 'radio',
		'condition' => 'breadcrumbs_style:is(style_2)',
		'options'   => array("light" => esc_html__("Light","discy"),"dark" => esc_html__("Dark","discy"),"colored" => esc_html__("Colored","discy"))
	);

	$options[] = array(
		'name' => esc_html__("Remove the h1 title for the posts and questions on the inner page to don't duplicate it","discy"),
		'desc' => esc_html__("Select ON to enable to remove the h1 title for the posts and questions on the inner page to don't duplicate it.","discy"),
		'id'   => 'breadcrumbs_content_title',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Breadcrumbs separator','discy'),
		'desc' => esc_html__('Add your breadcrumbs separator.','discy'),
		'id'   => 'breadcrumbs_separator',
		'std'  => '/',
		'type' => 'text',
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Posts at header or footer','discy'),
		'id'   => 'posts_header',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the posts area or not','discy'),
		'desc' => esc_html__('Select ON to enable the posts area.','discy'),
		'id'   => 'blog_h',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'blog_h:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('The posts area works after header or before footer?','discy'),
		'id'      => 'blog_h_where',
		'options' => array(
			'header' => esc_html__('After header','discy'),
			'footer' => esc_html__('Before footer','discy'),
		),
		'std'     => 'footer',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name'    => esc_html__('The posts area works at all the pages, custom pages, or home page only?','discy'),
		'id'      => 'blog_h_home_pages',
		'options' => array(
			'home_page'     => esc_html__('Home page','discy'),
			'all_pages'     => esc_html__('All site pages','discy'),
			'all_posts'     => esc_html__('All single post pages','discy'),
			'all_questions' => esc_html__('All single question pages','discy'),
			'custom_pages'  => esc_html__('Custom pages','discy'),
		),
		'std'     => 'home_page',
		'type'    => 'radio'
	);

	$options[] = array(
		'name'      => esc_html__('Page ids','discy'),
		'desc'      => esc_html__('Type from here the page ids','discy'),
		'id'        => 'blog_h_pages',
		'type'      => 'text',
		'condition' => 'blog_h_home_pages:is(custom_pages)'
	);
	
	$options[] = array(
		'name' => esc_html__('The title','discy'),
		'desc' => esc_html__('Type from here the title','discy'),
		'id'   => 'blog_h_title',
		'type' => 'text',
		'std'  => 'Latest News & Updates'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the more post button','discy'),
		'desc' => esc_html__('Select ON to enable the button.','discy'),
		'id'   => 'blog_h_button',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'blog_h_button:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('The text for the button','discy'),
		'desc' => esc_html__('Type from here the text for the button','discy'),
		'id'   => 'blog_h_button_text',
		'type' => 'text',
		'std'  => 'Explore Our Blog'
	);
	
	$options[] = array(
		'name'    => esc_html__('Blog page','discy'),
		'desc'    => esc_html__('Select the blog page','discy'),
		'id'      => 'blog_h_page',
		'type'    => 'select',
		'options' => $options_pages
	);
	
	$options[] = array(
		'name' => esc_html__("Type the blog link if you don't like a page","discy"),
		'id'   => 'blog_h_link',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Posts number','discy'),
		'id'   => 'blog_h_post_number',
		'std'  => 3,
		'type' => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('Post style','discy'),
		'desc'    => esc_html__('Choose post style from here.','discy'),
		'id'      => 'blog_h_post_style',
		'options' => array(
			'style_1' => esc_html__('1 column','discy'),
			'style_2' => esc_html__('List style','discy'),
			'style_3' => esc_html__('Columns','discy'),
		),
		'std'   => 'style_3',
		'type'  => 'radio',
	);

	$options[] = array(
		'name'    => esc_html__('Order by','discy'),
		'desc'    => esc_html__('Select the post order by.','discy'),
		'id'      => "orderby_post_h",
		'std'     => "recent",
		'type'    => "radio",
		'options' => array(
			'recent'  => esc_html__('Recent','discy'),
			'popular' => esc_html__('Most Commented','discy'),
			'random'  => esc_html__('Random','discy'),
		)
	);
	
	$options[] = array(
		'name'    => esc_html__('Order','discy'),
		'id'      => 'order_post_h',
		'std'     => "DESC",
		'type'    => 'radio',
		'options' => array(
			'DESC' => esc_html__('Descending','discy'),
			'ASC'  => esc_html__('Ascending','discy'),
		),
	);
	
	$options[] = array(
		'name'    => esc_html__('Display by','discy'),
		'id'      => "post_display_h",
		'type'    => 'select',
		'options' => array(
			'lasts'	             => esc_html__('Lasts','discy'),
			'single_category'    => esc_html__('Single category','discy'),
			'categories'         => esc_html__('Multiple categories','discy'),
			'exclude_categories' => esc_html__('Exclude categories','discy'),
			'custom_posts'	     => esc_html__('Custom posts','discy'),
		),
		'std'     => 'lasts',
	);
	
	$options[] = array(
		'name'      => esc_html__('Single category','discy'),
		'id'        => 'post_single_category_h',
		'type'      => 'select_category',
		'condition' => 'post_display_h:is(single_category)',
	);
	
	$options[] = array(
		'name'      => esc_html__('Post categories','discy'),
		'desc'      => esc_html__('Select the post categories.','discy'),
		'id'        => "post_categories_h",
		'type'      => 'multicheck_category',
		'condition' => 'post_display_h:is(categories)',
	);
	
	$options[] = array(
		'name'      => esc_html__('Post exclude categories','discy'),
		'desc'      => esc_html__('Select the post exclude categories.','discy'),
		'id'        => "post_exclude_categories_h",
		'type'      => 'multicheck_category',
		'condition' => 'post_display_h:is(exclude_categories)',
	);
	
	$options[] = array(
		'name'      => esc_html__('Post ids','discy'),
		'desc'      => esc_html__('Type the post ids.','discy'),
		'id'        => "post_posts_h",
		'type'      => 'text',
		'condition' => 'post_display_h:is(custom_posts)',
	);
	
	$options[] = array(
		'name'      => esc_html__("Activate the masonry style?","discy"),
		'id'        => 'blog_h_masonry_style',
		'type'      => 'checkbox',
		'condition' => 'blog_h_post_style:is(style_3)',
	);
	
	$options[] = array(
		'name' => esc_html__('Choose a custom setting for the posts','discy'),
		'id'   => 'blog_h_custom_home_blog',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'blog_h_custom_home_blog:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Hide the featured image in the loop','discy'),
		'desc' => esc_html__('Select ON to hide the featured image in the loop.','discy'),
		'id'   => 'blog_h_featured_image',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'id'        => "blog_h_sort_meta_title_image",
		'condition' => 'blog_h_post_style:is(style_3)',
		'std'       => array(
						array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
						array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
					),
		'type'      => "sort",
		'options'   => array(
						array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
						array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
					)
	);
	
	$options[] = array(
		'name' => esc_html__('Read more enable or disable','discy'),
		'id'   => 'blog_h_read_more',
		'std'  => "on",
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Excerpt post','discy'),
		'desc' => esc_html__('Put here the excerpt post.','discy'),
		'id'   => 'blog_h_post_excerpt',
		'std'  => 40,
		'type' => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('Select the meta options','discy'),
		'id'      => 'blog_h_post_meta',
		'type'    => 'multicheck',
		'std'     => array(
			"category_post" => "category_post",
			"title_post"    => "title_post",
			"author_by"     => "author_by",
			"post_date"     => "post_date",
			"post_comment"  => "post_comment",
			"post_views"    => "post_views",
		),
		'options' => array(
			"category_post" => esc_html__('Category post - Work at 1 column only','discy'),
			"title_post"    => esc_html__('Title post','discy'),
			"author_by"     => esc_html__('Author by - Work at 1 column only','discy'),
			"post_date"     => esc_html__('Date meta','discy'),
			"post_comment"  => esc_html__('Comment meta','discy'),
			"post_views"    => esc_html__("Views stats","discy"),
		)
	);
	
	$options[] = array(
		'name'      => esc_html__('Select the share options','discy'),
		'id'        => 'blog_h_post_share',
		'condition' => 'blog_h_post_style:not(style_3)',
		'type'      => 'multicheck',
		'sort'      => 'yes',
		'std'       => $share_array,
		'options'   => $share_array
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);

	$options[] = array(
		'name' => esc_html__('Slider','discy'),
		'id'   => 'slider',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the slider or not','discy'),
		'desc' => esc_html__('Select ON to enable the slider.','discy'),
		'id'   => 'slider_h',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'slider_h:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Slider works at all the pages, custom pages, or home page only?','discy'),
		'id'      => 'slider_h_home_pages',
		'options' => array(
			'home_page'     => esc_html__('Home page','discy'),
			'all_pages'     => esc_html__('All site pages','discy'),
			'all_posts'     => esc_html__('All single post pages','discy'),
			'all_questions' => esc_html__('All single question pages','discy'),
			'custom_pages'  => esc_html__('Custom pages','discy'),
		),
		'std'     => 'home_page',
		'type'    => 'radio'
	);

	$options[] = array(
		'name'      => esc_html__('Page ids','discy'),
		'desc'      => esc_html__('Type from here the page ids','discy'),
		'id'        => 'slider_h_pages',
		'type'      => 'text',
		'condition' => 'slider_h_home_pages:is(custom_pages)'
	);

	$options[] = array(
		'name'    => esc_html__('Slider works for "Unlogged users", "Logged users" or both','discy'),
		'id'      => 'slider_h_logged',
		'options' => array(
			'unlogged' => esc_html__('Unlogged users','discy'),
			'logged'   => esc_html__('Logged users','discy'),
			'both'     => esc_html__('Both','discy'),
		),
		'std'     => 'both',
		'type'    => 'radio',
	);

	$options[] = array(
		'name'    => esc_html__('Choose the slider that works with the theme or add your custom slider by inserting the code or shortcodes','discy'),
		'id'      => 'custom_slider',
		'options' => array(
			'slider' => esc_html__('Theme slider','discy'),
			'custom' => esc_html__('Custom slider','discy'),
		),
		'std'     => 'slider',
		'type'    => 'radio',
	);

	$options[] = array(
		'div'       => 'div',
		'condition' => 'custom_slider:is(slider)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name' => esc_html__('Slider height','discy'),
		"id"   => "slider_height",
		"type" => "sliderui",
		"step" => "50",
		"min"  => "400",
		"max"  => "1000",
		"std"  => "500"
	);

	$slide_elements = array(
		array(
			"type" => "color",
			"id"   => "color",
			"name" => esc_html__('Color','discy')
		),
		array(
			"type" => "upload",
			"id"   => "image",
			"name" => esc_html__('Image','discy')
		),
		array(
			"type"  => "slider",
			"name"  => esc_html__('Choose the background opacity','discy'),
			"id"    => "opacity",
			"std"   => "0",
			"step"  => "1",
			"min"   => "0",
			"max"   => "100",
			"value" => "0"
		),
		array(
			"type"    => "radio",
			"id"      => "align",
			"name"    => esc_html__('Align','discy'),
			'options' => array(
				'left'   => esc_html__('Left','discy'),
				'center' => esc_html__('Center','discy'),
				'right'  => esc_html__('Right','discy'),
			),
			'std'     => 'left',
		),
		array(
			"type"      => "radio",
			"id"        => "login",
			"name"      => esc_html__('Login or Signup','discy'),
			'options'   => array(
				'none'   => esc_html__('None','discy'),
				'login'  => esc_html__('Login','discy'),
				'signup' => esc_html__('Signup','discy'),
			),
			'condition' => '[%id%]align:not(center),[%id%]button_block:not(block)',
			'std'       => 'login',
		),
		array(
			"type" => "text",
			"id"   => "title",
			"name" => esc_html__('Title','discy')
		),
		array(
			"type" => "text",
			"id"   => "title_2",
			"name" => esc_html__('Second title','discy')
		),
		array(
			"type" => "textarea",
			"id"   => "paragraph",
			"name" => esc_html__('Paragraph','discy')
		),
		array(
			"type"    => "radio",
			"id"      => "button_block",
			"name"    => esc_html__('Button or Block','discy'),
			'options' => array(
				'none'   => esc_html__('None','discy'),
				'button' => esc_html__('button','discy'),
				'block'  => esc_html__('Block','discy'),
			),
			'std'     => 'none',
		),
		array(
			"type"      => "radio",
			"id"        => "block",
			"name"      => esc_html__('Block','discy'),
			'options'   => array(
				'search'   => esc_html__('Search','discy'),
				'question' => esc_html__('Ask A Question','discy'),
			),
			'condition' => '[%id%]button_block:is(block)',
			'std'       => 'search',
		),
		array(
			"type"      => "radio",
			"id"        => "button",
			"name"      => esc_html__('Button','discy'),
			'options'   => array(
				'signup'   => esc_html__('Create A New Account','discy'),
				'login'    => esc_html__('Login','discy'),
				'question' => esc_html__('Ask A Question','discy'),
				'post'     => esc_html__('Add A Post','discy'),
				'custom'   => esc_html__('Custom link','discy'),
			),
			'condition' => '[%id%]button_block:is(button)',
			'std'       => 'signup',
		),
		array(
			"type"      => "radio",
			"id"        => "button_style",
			"name"      => esc_html__('Button style','discy'),
			'options'   => array(
				'style_1' => esc_html__('Style 1','discy'),
				'style_2' => esc_html__('Style 2','discy'),
				'style_3' => esc_html__('Style 3','discy'),
			),
			'condition' => '[%id%]button_block:is(button)',
			'std'       => 'style_1',
		),
		array(
			'div'       => 'div',
			'condition' => '[%id%]button:is(custom),[%id%]button_block:is(button)',
			'type'      => 'heading-2'
		),
		array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'button_target',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		),
		array(
			'name' => esc_html__('Type the button link','discy'),
			'id'   => 'button_link',
			'type' => 'text'
		),
		array(
			'name' => esc_html__('Type the button text','discy'),
			'id'   => 'button_text',
			'type' => 'text'
		),
		array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		),
	);
	
	$options[] = array(
		'id'      => "add_slides",
		'type'    => "elements",
		'button'  => esc_html__('Add a new slide','discy'),
		'hide'    => "yes",
		'options' => $slide_elements,
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'id'        => "custom_slides",
		'type'      => "textarea",
		'name'      => esc_html__('Add your custom slide or shortcode','discy'),
		'condition' => 'custom_slider:is(custom)',
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);

	$options = apply_filters('discy_options_after_slider_setting',$options);
	
	$options[] = array(
		'name' => esc_html__('Responsive settings','discy'),
		'id'   => 'responsive',
		'icon' => 'smartphone',
		'type' => 'heading'
	);
	
	$options[] = array(
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('The mobile apps bar enable or disable?','discy'),
		'desc' => esc_html__('Select ON to enable the mobile apps bar.','discy'),
		'id'   => 'mobile_bar_apps',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'mobile_bar_apps:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Mobile apps bar skin','discy'),
		'desc'    => esc_html__('Choose the mobile apps bar skin.','discy'),
		'id'      => 'mobile_apps_bar_skin',
		'std'     => 'light',
		'type'    => 'radio',
		'options' => array("dark" => esc_html__("Dark","discy"),"light" => esc_html__("Light","discy"),"colored" => esc_html__("Colored","discy"))
	);

	$options[] = array(
		'name' => esc_html__('Type your iPhone app link','discy'),
		'id'   => 'mobile_bar_apps_iphone',
		'type' => 'text'
	);

	$options[] = array(
		'name' => esc_html__('Type your Android app link','discy'),
		'id'   => 'mobile_bar_apps_android',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name'      => esc_html__('Stop fixed header in mobile','discy'),
		'desc'      => esc_html__('Select ON to stop fixed header in mobile.','discy'),
		'id'        => 'header_fixed_responsive',
		'condition' => 'header_fixed:not(0)',
		'type'      => 'checkbox'
	);

	$options[] = array(
		'name' => esc_html__('Icon for the login or signup in the mobile header','discy'),
		'desc' => esc_html__('Type from here the icon of the login or signup button in the mobile header.','discy'),
		'id'   => 'header_responsive_icon',
		'std'  => 'icon-lock',
		'type' => 'text'
	);

	$options[] = array(
		'name'    => esc_html__('Button at mobile for the unlogged case','discy'),
		'desc'    => esc_html__('Choose button type at the mobile display for the unlogged case from here.','discy'),
		'id'      => 'mobile_sign',
		'options' => array(
			'login'  => esc_html__('Login','discy'),
			'signup' => esc_html__('Signup','discy'),
		),
		'std'     => 'login',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name' => esc_html__('Choose the mobile menu skin','discy'),
		'id'   => "mobile_menu",
		'std'  => "dark",
		'type' => "images",
		'options' => array(
			'dark'  => $imagepath.'menu_dark.jpg',
			'gray'  => $imagepath.'sidebar_no.jpg',
			'light' => $imagepath.'menu_light.jpg',
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Mobile bar enable or disable?','discy'),
		'desc' => esc_html__('Select ON to enable the mobile bar.','discy'),
		'id'   => 'mobile_bar',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'mobile_bar:not(0)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name'    => esc_html__('Mobile button','discy'),
		'desc'    => esc_html__('Choose mobile button style from here.','discy'),
		'id'      => 'mobile_button',
		'options' => array(
			'question' => esc_html__('Ask A Question','discy'),
			'post'     => esc_html__('Add A Post','discy'),
			'group'    => esc_html__('Create A Group','discy'),
			'custom'   => esc_html__('Custom link','discy'),
		),
		'std'     => 'question',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'mobile_button:is(custom)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Open the page in same page or a new page?','discy'),
		'id'      => 'mobile_button_target',
		'std'     => "new_page",
		'type'    => 'select',
		'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button link','discy'),
		'id'   => 'mobile_button_link',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Type the button text','discy'),
		'id'   => 'mobile_button_text',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate a custom mobile menu or not?','discy'),
		'desc' => esc_html__('Select ON to enable the custom mobile menu.','discy'),
		'id'   => 'active_mobile_menu',
		'type' => 'checkbox'
	);

	$options[] = array(
		'name'      => esc_html__('Sort the mobile menus','discy'),
		'id'        => "sort_mobile_menus",
		'condition' => 'active_mobile_menu:is(0)',
		'std'       => array(
						array("value" => "left",'name' => esc_html__('Left menu','discy'),"default" => "yes"),
						array("value" => "top",'name' => esc_html__('Top menu','discy'),"default" => "yes"),
					),
		'type'      => "sort",
		'options'   => array(
						array("value" => "left",'name' => esc_html__('Left menu','discy'),"default" => "yes"),
						array("value" => "top",'name' => esc_html__('Top menu','discy'),"default" => "yes"),
					)
	);
	
	$options[] = array(
		'name'      => esc_html__('Choose from here which menu will show at mobile for "unlogged users".','discy'),
		'id'        => 'mobile_menu',
		'type'      => 'select',
		'condition' => 'active_mobile_menu:not(0)',
		'options'   => $menus
	);
	
	$options[] = array(
		'name'      => esc_html__('Choose from here which menu will show at mobile for "logged in users".','discy'),
		'id'        => 'mobile_menu_logged',
		'type'      => 'select',
		'condition' => 'active_mobile_menu:not(0)',
		'options'   => $menus
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name'    => esc_html__('Post settings','discy'),
		'id'      => 'posts',
		'icon'    => 'admin-page',
		'type'    => 'heading',
		'std'     => 'post_loop',
		'options' => array(
			"post_loop"         => esc_html__('Posts & Loop setting','discy'),
			"add_edit_delete_p" => esc_html__('Add - Edit - Delete','discy'),
			"post_meta"         => esc_html__('Post meta settings','discy'),
			"inner_pages"       => esc_html__('Inner page settings','discy'),
			"share_setting"     => esc_html__('Share setting','discy'),
			"related_setting"   => esc_html__('Related setting','discy'),
			"posts_layouts"     => esc_html__('Posts layouts','discy')
		)
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'id'   => 'post_loop',
		'name' => esc_html__('Posts & Loop setting','discy')
	);
	
	$options[] = array(
		'name'    => esc_html__('Post style','discy'),
		'desc'    => esc_html__('Choose post style from here.','discy'),
		'id'      => 'post_style',
		'options' => array(
			'style_1' => esc_html__('1 column','discy'),
			'style_2' => esc_html__('List style','discy'),
			'style_3' => esc_html__('Columns','discy'),
		),
		'std'     => 'style_1',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name'      => esc_html__("Activate the masonry style?","discy"),
		'id'        => 'post_masonry_style',
		'type'      => 'checkbox',
		'condition' => 'post_style:is(style_3)',
	);
	
	$options[] = array(
		'name' => esc_html__('Category description enable or disable','discy'),
		'desc' => esc_html__('Select ON to enable the category description in the category page.','discy'),
		'id'   => 'category_description',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Category rss enable or disable','discy'),
		'desc'      => esc_html__('Select ON to enable the category rss in the category page.','discy'),
		'id'        => 'category_rss',
		'std'       => 'on',
		'condition' => 'category_description:not(0)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Tag description enable or disable','discy'),
		'desc' => esc_html__('Select ON to enable the tag description in the tag page.','discy'),
		'id'   => 'tag_description',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Tag rss enable or disable','discy'),
		'desc'      => esc_html__('Select ON to enable the tag rss in the tag page.','discy'),
		'id'        => 'tag_rss',
		'std'       => 'on',
		'condition' => 'tag_description:not(0)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Hide the featured image in the loop','discy'),
		'desc' => esc_html__('Select ON to hide the featured image in the loop.','discy'),
		'id'   => 'featured_image_loop_post',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'id'        => "sort_meta_title_image",
		'condition' => 'post_style:is(style_3)',
		'std'       => array(
						array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
						array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
					),
		'type'      => "sort",
		'options'   => array(
						array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
						array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
					)
	);
	
	$options[] = array(
		'name' => esc_html__('Read more enable or disable','discy'),
		'id'   => 'read_more',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Excerpt post','discy'),
		'desc' => esc_html__('Put here the excerpt post.','discy'),
		'id'   => 'post_excerpt',
		'std'  => 40,
		'type' => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('Pagination style','discy'),
		'desc'    => esc_html__('Choose pagination style from here.','discy'),
		'id'      => 'post_pagination',
		'options' => array(
			'standard'        => esc_html__('Standard','discy'),
			'pagination'      => esc_html__('Pagination','discy'),
			'load_more'       => esc_html__('Load more','discy'),
			'infinite_scroll' => esc_html__('Infinite scroll','discy'),
			'none'            => esc_html__('None','discy'),
		),
		'std'     => 'pagination',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'id'   => 'add_edit_delete_p',
		'name' => esc_html__('Add, edit and delete post','discy')
	);
	
	$options[] = array(
		'name' => esc_html__('Send schedule mails for the users as a list with recent posts','discy'),
		'id'   => 'post_schedules',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'post_schedules:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Schedule mails time','discy'),
		'id'      => 'post_schedules_time',
		'type'    => 'multicheck',
		'std'     => array("daily" => "daily","weekly" => "weekly","monthly" => "monthly"),
		'options' => array(
			"daily" => esc_html__("Daily","discy"),
			"weekly" => esc_html__("Weekly","discy"),
			"monthly" => esc_html__("Monthly","discy")
		)
	);

	$options[] = array(
		"name" => esc_html__("Set the hour to send the mail at this hour","discy"),
		"id"   => "schedules_time_hour_post",
		"type" => "sliderui",
		'std'  => 12,
		"step" => "1",
		"min"  => "1",
		"max"  => "24"
	);

	$options[] = array(
		'name'    => esc_html__('Select the day to send the mail at this day','discy'),
		'id'      => 'schedules_time_day_post',
		'type'    => "select",
		'std'     => "saturday",
		'options' => array(
			'saturday'  => esc_html__('Saturday','discy'),
			'sunday'    => esc_html__('Sunday','discy'),
			'monday'    => esc_html__('Monday','discy'),
			'tuesday'   => esc_html__('Tuesday','discy'),
			'wednesday' => esc_html__('Wednesday','discy'),
			'thursday'  => esc_html__('Thursday','discy'),
			'friday'    => esc_html__('Friday','discy')
		)
	);
	
	$options[] = array(
		'name'    => esc_html__('Send schedule mails for custom roles to send a list with recent posts','discy'),
		'id'      => 'post_schedules_groups',
		'type'    => 'multicheck',
		'std'     => array("editor" => "editor","administrator" => "administrator","author" => "author","contributor" => "contributor","subscriber" => "subscriber"),
		'options' => discy_options_roles()
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);

	$options[] = array(
		'name'    => esc_html__("Choose the way of the sending emails and notifications","discy"),
		'desc'    => esc_html__("Make the send mail to the users and send notification from the site or with schedule cron job","discy"),
		'id'      => 'way_sending_notifications_posts',
		'std'     => 'site',
		'type'    => 'radio',
		'options' => array(
			"site"    => esc_html__("From the site","discy"),
			"cronjob" => esc_html__("Schedule cron job","discy")
		)
	);

	$options[] = array(
		'div'       => 'div',
		'condition' => 'way_sending_notifications_posts:is(cronjob)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name'    => esc_html__('Schedule mails time','discy'),
		'id'      => 'schedules_time_notification_posts',
		'type'    => 'radio',
		'std'     => "hourly",
		'options' => array(
			"daily"       => esc_html__("One time daily","discy"),
			"twicedaily"  => esc_html__("Twice times daily","discy"),
			"hourly"      => esc_html__("Hourly","discy"),
			"twicehourly" => esc_html__("Each 30 minutes","discy")
		)
	);

	$options[] = array(
		"name"      => esc_html__("Set the hour to send the mail at this hour","discy"),
		"id"        => "schedules_time_hour_notification_post",
		'condition' => 'schedules_time_notification_posts:is(daily),schedules_time_notification_posts:is(twicedaily)',
		'operator'  => 'or',
		"type"      => "sliderui",
		'std'       => 12,
		"step"      => "1",
		"min"       => "1",
		"max"       => "24"
	);

	$options[] = array(
		"name" => esc_html__("Set the number of the posts you want to send on the one time","discy"),
		"id"   => "schedules_number_post",
		"type" => "sliderui",
		'std'  => 10,
		"step" => "1",
		"min"  => "1",
		"max"  => "100"
	);
	
	$options[] = array(
		'name'      => esc_html__('Note: if you choose one time daily or twice times daily we will make it visible hourly to check if there are any more posts that need to send the notifications.','discy'),
		'condition' => 'schedules_time_notification_posts:is(daily),schedules_time_notification_posts:is(twicedaily)',
		'operator'  => 'or',
		'type'      => 'info'
	);

	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end',
		'div'  => 'div'
	);
	
	$options[] = array(
		'name'    => esc_html__('Choose the way of the sending mails and notifications of a new post','discy'),
		'id'      => 'send_email_and_notification_post',
		'options' => array(
			'both'       => esc_html__('Both with the same options','discy'),
			'separately' => esc_html__('Separately','discy'),
		),
		'std'     => 'both',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'send_email_and_notification_post:has(both)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name' => esc_html__('Send mail and notification to the users about the notification of a new post','discy'),
		'desc' => esc_html__('Send mail and notification enable or disable.','discy'),
		'id'   => 'send_email_new_post_both',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Send mail and notification for custom roles about the notification of a new post','discy'),
		'id'        => 'send_email_post_groups_both',
		'type'      => 'multicheck',
		'condition' => 'send_email_new_post_both:not(0)',
		'std'       => array("editor" => "editor","administrator" => "administrator","author" => "author","contributor" => "contributor","subscriber" => "subscriber"),
		'options'   => discy_options_roles()
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'send_email_and_notification_post:has(separately)',
		'type'      => 'heading-2'
	);

	$options[] = array(
		'name' => esc_html__('Send mail to the users about the notification of a new post','discy'),
		'desc' => esc_html__('Send mail enable or disable.','discy'),
		'id'   => 'send_email_new_post',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Send mail for custom roles about the notification of a new post','discy'),
		'id'        => 'send_email_post_groups',
		'type'      => 'multicheck',
		'condition' => 'send_email_new_post:not(0)',
		'std'       => array("editor" => "editor","administrator" => "administrator","author" => "author","contributor" => "contributor","subscriber" => "subscriber"),
		'options'   => discy_options_roles()
	);
	
	$options[] = array(
		'name' => esc_html__('Send notification to the users about the notification of a new post','discy'),
		'desc' => esc_html__('Send notification enable or disable.','discy'),
		'id'   => 'send_notification_new_post',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Send notification for custom roles about the notification of a new post','discy'),
		'id'        => 'send_notification_post_groups',
		'type'      => 'multicheck',
		'condition' => 'send_notification_new_post:not(0)',
		'std'       => array("editor" => "editor","administrator" => "administrator","author" => "author","contributor" => "contributor","subscriber" => "subscriber"),
		'options'   => discy_options_roles()
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);

	$options[] = array(
		'div'       => 'div',
		'condition' => 'way_sending_notifications_posts:is(cronjob)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('The link of the notification after sending it to users will go to?','discy'),
		'id'      => 'notifications_posts_link',
		'std'     => "home",
		'type'    => 'select',
		'options' => array("home" => esc_html__("Home","discy"),"custom_page" => esc_html__("Custom page","discy"),"custom_link" => esc_html__("Custom link","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__("Type the link if you don't like above","discy"),
		'id'        => 'notifications_posts_custom_page',
		'condition' => 'notifications_posts_link:is(custom_page)',
		'type'      => 'select',
		'options'   => $options_pages
	);
	
	$options[] = array(
		'name'      => esc_html__("Type the link if you don't like above","discy"),
		'id'        => 'notifications_posts_custom_link',
		'condition' => 'notifications_posts_link:is(custom_link)',
		'type'      => 'text'
	);

	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end',
		'div'  => 'div'
	);
	
	$options[] = array(
		'name' => esc_html__('Add posts','discy'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('Add post slug','discy'),
		'desc' => esc_html__('Put the add post slug.','discy'),
		'id'   => 'add_posts_slug',
		'std'  => 'add-post',
		'type' => 'text'
	);
	
	if (has_wpqa()) {
		$options[] = array(
			'name' => '<a href="'.wpqa_add_post_permalink().'" target="_blank">'.esc_html__('The Link For The Add Post Page.','discy').'</a>',
			'type' => 'info'
		);
	}
	
	$options[] = array(
		'name' => esc_html__('Activate the add post with popup','discy'),
		'desc' => esc_html__('Add post with popup enable or disable.','discy'),
		'id'   => 'active_post_popup',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Any one can add post without register','discy'),
		'desc' => esc_html__('Any one can add post without register enable or disable.','discy'),
		'id'   => 'add_post_no_register',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'    => esc_html__('Choose post status for users only','discy'),
		'desc'    => esc_html__('Choose post status after user publish the post.','discy'),
		'id'      => 'post_publish',
		'options' => array("publish" => esc_html__("Auto publish","discy"),"draft" => esc_html__("Need a review","discy")),
		'std'     => 'draft',
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name'      => esc_html__('Choose post status for "unlogged user" only','discy'),
		'desc'      => esc_html__('Choose post status after "unlogged user" publish the post.','discy'),
		'id'        => 'post_publish_unlogged',
		'options'   => array("publish" => esc_html__("Auto publish","discy"),"draft" => esc_html__("Need a review","discy")),
		'std'       => 'draft',
		'type'      => 'radio',
		'condition' => 'add_post_no_register:not(0)',
	);
	
	$options[] = array(
		'name'      => esc_html__('Send mail when the post needs a review','discy'),
		'desc'      => esc_html__('Mail for posts review enable or disable.','discy'),
		'id'        => 'send_email_draft_posts',
		'std'       => 'on',
		'operator'  => 'or',
		'condition' => 'post_publish:not(publish),post_publish_unlogged:not(publish)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Auto Approve posts for the users that have a previously approved posts.','discy'),
		'id'        => 'approved_posts',
		'condition' => 'post_publish:not(publish)',
		'type'      => 'checkbox'
	);

	$add_post_items = array(
		"tags_post"      => array("sort" => esc_html__('Post Tags','discy'),"value" => "tags_post"),
		"featured_image" => array("sort" => esc_html__('Post featured image','discy'),"value" => "featured_image"),
		"content_post"   => array("sort" => esc_html__('Post content','discy'),"value" => "content_post"),
		"terms_active"   => array("sort" => esc_html__('Terms of Service and Privacy Policy','discy'),"value" => ""),
	);
	
	$options[] = array(
		'name'    => esc_html__("Select what to show at Add post form","discy"),
		'id'      => 'add_post_items',
		'type'    => 'multicheck',
		'sort'    => 'yes',
		'std'     => $add_post_items,
		'options' => $add_post_items
	);
	
	$options[] = array(
		'name'      => esc_html__('Enable or disable the editor for details in add post form','discy'),
		'id'        => 'editor_post_details',
		'condition' => 'add_post_items:has(content_post)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'add_post_items:has(terms_active)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Terms of Service and Privacy Policy','discy'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('Select the checked by default option','discy'),
		'desc' => esc_html__('Select ON if you want to checked it by default.','discy'),
		'id'   => 'terms_checked_post',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'    => esc_html__('Open the page in same page or a new page?','discy'),
		'id'      => 'terms_active_target_post',
		'std'     => "new_page",
		'type'    => 'select',
		'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Terms page','discy'),
		'desc'    => esc_html__('Select the terms page','discy'),
		'id'      => 'terms_page_post',
		'type'    => 'select',
		'options' => $options_pages
	);
	
	$options[] = array(
		'name' => esc_html__("Type the terms link if you don't like a page","discy"),
		'id'   => 'terms_link_post',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate Privacy Policy','discy'),
		'desc' => esc_html__('Select ON if you want to activate Privacy Policy.','discy'),
		'id'   => 'privacy_policy_post',
		'std'  => "on",
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'privacy_policy_post:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Open the page in same page or a new page?','discy'),
		'id'      => 'privacy_active_target_post',
		'std'     => "new_page",
		'type'    => 'select',
		'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'    => esc_html__('Privacy Policy page','discy'),
		'desc'    => esc_html__('Select the privacy policy page','discy'),
		'id'      => 'privacy_page_post',
		'type'    => 'select',
		'options' => $options_pages
	);
	
	$options[] = array(
		'name' => esc_html__("Type the privacy policy link if you don't like a page","discy"),
		'id'   => 'privacy_link_post',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Edit posts','discy'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('The users can edit the posts?','discy'),
		'id'   => 'can_edit_post',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'can_edit_post:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Edit post slug','discy'),
		'desc' => esc_html__('Put the edit post slug.','discy'),
		'id'   => 'edit_posts_slug',
		'std'  => 'edit-post',
		'type' => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('After editing post, auto approve the post or need to be approved again.','discy'),
		'desc'    => esc_html__('Press ON to auto approve','discy'),
		'options' => array("publish" => esc_html__("Auto publish","discy"),"draft" => esc_html__("Need a review","discy")),
		'id'      => 'post_approved',
		'type'    => 'radio',
		'std'     => 'publish'
	);
	
	$options[] = array(
		'name' => esc_html__('After edit post change the URL from the title?','discy'),
		'desc' => esc_html__('Press ON to edit the URL','discy'),
		'id'   => 'change_post_url',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Delete posts','discy'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate user can delete the posts','discy'),
		'desc' => esc_html__('Select ON if you want the user can delete the posts.','discy'),
		'id'   => 'post_delete',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('When the user deleted a post, trash it or delete it for ever?','discy'),
		'id'        => 'delete_post',
		'options'   => array(
			'delete' => esc_html__('Delete','discy'),
			'trash'  => esc_html__('Trash','discy'),
		),
		'std'       => 'delete',
		'condition' => 'post_delete:not(0)',
		'type'      => 'radio'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Post meta settings','discy'),
		'id'   => 'post_meta',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Select the meta options','discy'),
		'id'      => 'post_meta',
		'type'    => 'multicheck',
		'std'     => array(
			"category_post" => "category_post",
			"title_post"    => "title_post",
			"author_by"     => "author_by",
			"post_date"     => "post_date",
			"post_comment"  => "post_comment",
			"post_views"    => "post_views",
		),
		'options' => array(
			"category_post" => esc_html__('Category post - Work at 1 column only','discy'),
			"title_post"    => esc_html__('Title post','discy'),
			"author_by"     => esc_html__('Author by - Work at 1 column only','discy'),
			"post_date"     => esc_html__('Date meta','discy'),
			"post_comment"  => esc_html__('Comment meta','discy'),
			"post_views"    => esc_html__("Views stats","discy"),
		)
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'id'   => 'inner_pages',
		'name' => esc_html__('Inner page settings','discy')
	);
	
	$order_sections = array(
		"author"        => array("sort" => esc_html__('About the author','discy'),"value" => "author"),
		"next_previous" => array("sort" => esc_html__('Next and Previous articles','discy'),"value" => "next_previous"),
		"advertising"   => array("sort" => esc_html__('Advertising','discy'),"value" => "advertising"),
		"related"       => array("sort" => esc_html__('Related articles','discy'),"value" => "related"),
		"comments"      => array("sort" => esc_html__('Comments','discy'),"value" => "comments"),
	);
	
	$options[] = array(
		'name'    => esc_html__('Sort your sections','discy'),
		'id'      => 'order_sections',
		'type'    => 'multicheck',
		'sort'    => 'yes',
		'std'     => $order_sections,
		'options' => $order_sections
	);
	
	$options[] = array(
		'name' => esc_html__('Hide the featured image in the single post','discy'),
		'desc' => esc_html__('Select ON to hide the featured image in the single post.','discy'),
		'id'   => 'featured_image',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'    => esc_html__('Featured image style','discy'),
		'desc'    => esc_html__('Featured image style from here.','discy'),
		'id'      => 'featured_image_style',
		'std'     => 'default',
		'options' => array(
			'default' => 'Default',
			'style_270'   => '270x180',
			'style_140'   => '140x140',
			'custom_size' => esc_html__('Custom size','discy'),
		),
		'type'    => 'radio'
	);
	
	$options[] = array(
		'type'      => 'heading-2',
		'condition' => 'featured_image_style:is(custom_size)',
		'div'       => 'div'
	);
		
	$options[] = array(
		'name' => esc_html__('Featured image width','discy'),
		"id"   => "featured_image_width",
		"type" => "sliderui",
		"step" => "1",
		"min"  => "140",
		"max"  => "500"
	);
	
	$options[] = array(
		'name' => esc_html__('Featured image height','discy'),
		"id"   => "featured_image_height",
		"type" => "sliderui",
		"step" => "1",
		"min"  => "140",
		"max"  => "500"
	);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end',
			'div'  => 'div'
	);
	
	$options[] = array(
		'name' => esc_html__('Tags enable or disable','discy'),
		'id'   => 'post_tags',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Navigation post for the same category only?','discy'),
		'desc'      => esc_html__('Navigation post (next and previous posts) for the same category only?','discy'),
		'id'        => 'post_nav_category',
		'condition' => 'order_sections:has(next_previous)',
		'std'       => 'on',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Share setting','discy'),
		'id'   => 'share_setting',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Select the share options','discy'),
		'id'      => 'post_share',
		'type'    => 'multicheck',
		'sort'    => 'yes',
		'std'     => $share_array,
		'options' => $share_array
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Related setting','discy'),
		'id'   => 'related_setting',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'      => esc_html__('Activate it first from Inner page settings.','discy'),
		'condition' => 'order_sections:has_not(related)',
		'type'      => 'info'
	);
	
	$options[] = array(
		'type'      => 'heading-2',
		'condition' => 'order_sections:has(related)',
		'div'       => 'div'
	);
	
	$options[] = array(
		'name'    => esc_html__('Related style','discy'),
		'desc'    => esc_html__('Type related post style from here.','discy'),
		'id'      => 'related_style',
		'std'     => 'style_1',
		'options' => array(
			'style_1' => 'Style 1',
			'links'   => 'Style 2',
		),
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name' => esc_html__('Related posts number','discy'),
		'desc' => esc_html__('Type the number of related posts from here.','discy'),
		'id'   => 'related_number',
		'std'  => 2,
		'type' => 'text'
	);
	
	$options[] = array(
		'name'      => esc_html__('Related posts number at sidebar','discy'),
		'desc'      => esc_html__('Type related posts number at sidebar from here.','discy'),
		'id'        => 'related_number_sidebar',
		'std'       => 3,
		'condition' => 'related_style:not(links)',
		'type'      => 'text'
	);
	
	$options[] = array(
		'name'      => esc_html__('Related posts number at full width','discy'),
		'desc'      => esc_html__('Type related posts number at full width from here.','discy'),
		'id'        => 'related_number_full',
		'std'       => 4,
		'condition' => 'related_style:not(links)',
		'type'      => 'text'
	);
	
	$options[] = array(
		'name'    => esc_html__('Query type','discy'),
		'desc'    => esc_html__('Select what will the related posts show.','discy'),
		'id'      => 'query_related',
		'std'     => 'categories',
		'options' => array(
			'categories' => esc_html__('Posts in the same categories','discy'),
			'tags'       => esc_html__('Posts in the same tags (If not find any tags will show by the same categories)','discy'),
			'author'     => esc_html__('Posts by the same author','discy'),
		),
		'type'    => 'radio'
	);
	
	$options[] = array(
		'name' => esc_html__('Excerpt title in related posts','discy'),
		'desc' => esc_html__('Type excerpt title in related posts from here.','discy'),
		'id'   => 'excerpt_related_title',
		'std'  => '10',
		'type' => 'text'
	);
	
	$options[] = array(
		'name'      => esc_html__('Comment in related enable or disable','discy'),
		'id'        => 'comment_in_related',
		'std'       => 'on',
		'condition' => 'related_style:not(links)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__('Date in related enable or disable','discy'),
		'id'        => 'date_in_related',
		'std'       => 'on',
		'condition' => 'related_style:not(links)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end',
		'div'  => 'div'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Archive, categories, tags and inner post','discy'),
		'id'   => 'posts_layouts',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Post sidebar layout','discy'),
		'id'   => "post_sidebar_layout",
		'std'  => "default",
		'type' => "images",
		'options' => array(
			'default'      => $imagepath.'sidebar_default.jpg',
			'menu_sidebar' => $imagepath.'menu_sidebar.jpg',
			'right'        => $imagepath.'sidebar_right.jpg',
			'full'         => $imagepath.'sidebar_no.jpg',
			'left'         => $imagepath.'sidebar_left.jpg',
			'centered'     => $imagepath.'centered.jpg',
			'menu_left'    => $imagepath.'menu_left.jpg',
		)
	);
	
	$options[] = array(
		'name'      => esc_html__('Post Page sidebar','discy'),
		'id'        => "post_sidebar",
		'options'   => $new_sidebars,
		'type'      => 'select',
		'condition' => 'post_sidebar_layout:not(full),post_sidebar_layout:not(centered),post_sidebar_layout:not(menu_left)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Post Page sidebar 2','discy'),
		'id'        => "post_sidebar_2",
		'options'   => $new_sidebars,
		'type'      => 'select',
		'operator'  => 'or',
		'condition' => 'post_sidebar_layout:is(menu_sidebar),post_sidebar_layout:is(menu_left)'
	);
	
	$options[] = array(
		'name'    => esc_html__('Choose Your Skin','discy'),
		'class'   => "site_skin",
		'id'      => "post_skin",
		'std'     => "default",
		'type'    => "images",
		'options' => array(
			'default'    => $imagepath.'default_color.jpg',
			'skin'       => $imagepath.'default.jpg',
			'violet'     => $imagepath.'violet.jpg',
			'bright_red' => $imagepath.'bright_red.jpg',
			'green'      => $imagepath.'green.jpg',
			'red'        => $imagepath.'red.jpg',
			'cyan'       => $imagepath.'cyan.jpg',
			'blue'       => $imagepath.'blue.jpg',
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Primary Color','discy'),
		'id'   => 'post_primary_color',
		'type' => 'color'
	);
	
	$options[] = array(
		'name'    => esc_html__('Background Type','discy'),
		'id'      => 'post_background_type',
		'std'     => 'default',
		'type'    => 'radio',
		'options' => 
			array(
				"default"           => esc_html__("Default","discy"),
				"none"              => esc_html__("None","discy"),
				"patterns"          => esc_html__("Patterns","discy"),
				"custom_background" => esc_html__("Custom Background","discy")
			)
	);

	$options[] = array(
		'name'      => esc_html__('Background Color','discy'),
		'id'        => 'post_background_color',
		'type'      => 'color',
		'condition' => 'post_background_type:is(patterns)'
	);
		
	$options[] = array(
		'name'      => esc_html__('Choose Pattern','discy'),
		'id'        => "post_background_pattern",
		'std'       => "bg13",
		'type'      => "images",
		'condition' => 'post_background_type:is(patterns)',
		'class'     => "pattern_images",
		'options'   => array(
			'bg1'  => $imagepath.'bg1.jpg',
			'bg2'  => $imagepath.'bg2.jpg',
			'bg3'  => $imagepath.'bg3.jpg',
			'bg4'  => $imagepath.'bg4.jpg',
			'bg5'  => $imagepath.'bg5.jpg',
			'bg6'  => $imagepath.'bg6.jpg',
			'bg7'  => $imagepath.'bg7.jpg',
			'bg8'  => $imagepath.'bg8.jpg',
			'bg9'  => $imagepath_theme.'patterns/bg9.png',
			'bg10' => $imagepath_theme.'patterns/bg10.png',
			'bg11' => $imagepath_theme.'patterns/bg11.png',
			'bg12' => $imagepath_theme.'patterns/bg12.png',
			'bg13' => $imagepath.'bg13.jpg',
			'bg14' => $imagepath.'bg14.jpg',
			'bg15' => $imagepath_theme.'patterns/bg15.png',
			'bg16' => $imagepath_theme.'patterns/bg16.png',
			'bg17' => $imagepath.'bg17.jpg',
			'bg18' => $imagepath.'bg18.jpg',
			'bg19' => $imagepath.'bg19.jpg',
			'bg20' => $imagepath.'bg20.jpg',
			'bg21' => $imagepath_theme.'patterns/bg21.png',
			'bg22' => $imagepath.'bg22.jpg',
			'bg23' => $imagepath_theme.'patterns/bg23.png',
			'bg24' => $imagepath_theme.'patterns/bg24.png',
		)
	);

	$options[] = array(
		'name'      => esc_html__('Custom Background','discy'),
		'id'        => 'post_custom_background',
		'std'       => $background_defaults,
		'type'      => 'background',
		'options'   => $background_defaults,
		'condition' => 'post_background_type:is(custom_background)'
	);
		
	$options[] = array(
		'name'      => esc_html__('Full Screen Background','discy'),
		'desc'      => esc_html__('Select ON to enable Full Screen Background','discy'),
		'id'        => 'post_full_screen_background',
		'type'      => 'checkbox',
		'condition' => 'post_background_type:is(custom_background)'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);

	$options = apply_filters('wpqa_the_options',$options,$options_pages,$new_roles,$imagepath,$imagepath_theme,$new_sidebars,$menus);
	
	if (has_wpqa() && wpqa_plugin_version < '4.8') {
		$options[] = array(
			'name' => esc_html__('Captcha settings','discy'),
			'id'   => 'captcha',
			'icon' => 'admin-network',
			'type' => 'heading'
		);
		
		$options[] = array(
			'type' => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in ask question form)','discy'),
			'id'   => 'the_captcha',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in add group form)','discy'),
			'id'   => 'the_captcha_group',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in add post form)','discy'),
			'id'   => 'the_captcha_post',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in register form)','discy'),
			'id'   => 'the_captcha_register',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in login form)','discy'),
			'id'   => 'the_captcha_login',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in forgot password form)','discy'),
			'id'   => 'the_captcha_password',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in answer form)','discy'),
			'id'   => 'the_captcha_answer',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in comment form)','discy'),
			'id'   => 'the_captcha_comment',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in send message form)','discy'),
			'id'   => 'the_captcha_message',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha enable or disable (in add a new category form)','discy'),
			'id'   => 'the_captcha_category',
			'type' => 'checkbox'
		);

		$options = apply_filters('discy_options_captcha',$options);
		$captcha_condition_users = apply_filters('discy_captcha_condition_users','the_captcha:not(0),the_captcha_post:not(0),the_captcha_category:not(0),the_captcha_answer:not(0),the_captcha_comment:not(0),the_captcha_message:not(0)');
		$captcha_condition = apply_filters('discy_captcha_condition','the_captcha:not(0),the_captcha_post:not(0),the_captcha_category:not(0),the_captcha_register:not(0),the_captcha_login:not(0),the_captcha_password:not(0),the_captcha_answer:not(0),the_captcha_comment:not(0),the_captcha_message:not(0)');
		
		$options[] = array(
			'name'      => esc_html__('Captcha works for "unlogged users" or "unlogged and logged" users','discy'),
			'id'        => 'captcha_users',
			'std'       => 'unlogged',
			'operator'  => 'or',
			'condition' => $captcha_condition_users,
			'type'      => 'radio',
			'options'   => 
				array(
					"unlogged" => esc_html__('Unlogged users','discy'),
					"both"     => esc_html__('Unlogged and logged in users','discy')
			)
		);
		
		$options[] = array(
			'div'       => 'div',
			'operator'  => 'or',
			'condition' => $captcha_condition,
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Captcha style','discy'),
			'desc'    => esc_html__('Choose the captcha style','discy'),
			'id'      => 'captcha_style',
			'std'     => 'question_answer',
			'type'    => 'radio',
			'options' => 
				array(
					"question_answer"  => esc_html__('Question and answer','discy'),
					"normal_captcha"   => esc_html__('Normal captcha','discy'),
					"google_recaptcha" => esc_html__('Google reCaptcha','discy')
			)
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'captcha_style:is(google_recaptcha)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => sprintf(esc_html__('You can get the reCaptcha v2 site and secret keys from: %s','discy'),'<a href="https://www.google.com/recaptcha/admin/" target="_blank">'.esc_html__('here','discy').'</a>'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Site key reCaptcha','discy'),
			'id'   => 'site_key_recaptcha',
			'type' => 'text',
		);
		
		$options[] = array(
			'name' => esc_html__('Secret key reCaptcha','discy'),
			'id'   => 'secret_key_recaptcha',
			'type' => 'text',
		);
		
		$options[] = array(
			'name' => sprintf(esc_html__('You can get the reCaptcha language code from: %s','discy'),'<a href="https://developers.google.com/recaptcha/docs/language/" target="_blank">'.esc_html__('here','discy').'</a>'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('ReCaptcha language','discy'),
			'id'   => 'recaptcha_language',
			'type' => 'text',
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'captcha_style:is(question_answer)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha answer enable or disable in forms','discy'),
			'id'   => 'show_captcha_answer',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha question','discy'),
			'desc' => esc_html__('put the Captcha question','discy'),
			'id'   => 'captcha_question',
			'type' => 'text',
			'std'  => "What is the capital of Egypt?"
		);
		
		$options[] = array(
			'name' => esc_html__('Captcha answer','discy'),
			'desc' => esc_html__('put the Captcha answer','discy'),
			'id'   => 'captcha_answer',
			'type' => 'text',
			'std'  => "Cairo"
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('User settings','discy'),
			'id'   => 'user',
			'icon' => 'admin-users',
			'type' => 'heading',
			'std'     => 'setting_profile',
			'options' => array(
				"setting_profile"    => esc_html__('General Setting','discy'),
				"user_slugs"         => esc_html__('User Slugs','discy'),
				"login_setting"      => esc_html__('Login Setting','discy'),
				"register_setting"   => esc_html__('Register Setting','discy'),
				"edit_profile"       => esc_html__('Edit Profile','discy'),
				"ask_users"          => esc_html__('Ask Users','discy'),
				"referral_setting"   => esc_html__('Referral setting','discy'),
				"popup_notification" => esc_html__('Popup Notification','discy'),
				"permissions"        => esc_html__('Permissions','discy'),
				"author_setting"     => esc_html__('Author Setting','discy')
			)
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'setting_profile',
			'name' => esc_html__('General Setting','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Author info box enable or disable.','discy'),
			'id'   => 'author_box',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Block users for each other enable or disable.','discy'),
			'id'   => 'block_users',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Profile picture setting','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name' => esc_html__('Default image profile enable or disable.','discy'),
			'desc' => esc_html__("Select ON to upload your default image for the user who has not uploaded the image profile.","discy"),
			'id'   => 'default_image_active',
			'type' => 'checkbox'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'default_image_active:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Upload default image profile for the user.','discy'),
			'id'   => 'default_image',
			'std'  => $imagepath_theme."default-image.png",
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Upload default image profile for the user females.','discy'),
			'id'   => 'default_image_females',
			'std'  => $imagepath_theme."default-image-females.png",
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Upload default image profile for the anonymous users.','discy'),
			'id'   => 'default_image_anonymous',
			'type' => 'upload'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'name'      => esc_html__('Add the maximum size for the profile picture, Add it with KB, for 1 MB add 1024.','discy'),
			'desc'      => esc_html__('Add the maximum size for the profile picture, Leave it empty if you need it unlimited size.','discy'),
			'id'        => 'profile_picture_size',
			'condition' => 'register_items:has(image_profile),edit_profile_items_1:has(image_profile)',
			'operator'  => 'or',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Cover picture setting','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Cover image enable or disable.','discy'),
			'id'   => 'cover_image',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'cover_image:is(on)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('Default cover enable or disable.','discy'),
			'desc' => esc_html__("Select ON to upload your default cover for the user who has not uploaded the cover profile.","discy"),
			'id'   => 'default_cover_active',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Upload default cover for the user.','discy'),
			'id'        => 'default_cover',
			'condition' => 'default_cover_active:not(0)',
			'type'      => 'upload'
		);
		
		$options[] = array(
			'name'      => esc_html__('Upload default cover for the user females.','discy'),
			'id'        => 'default_cover_females',
			'condition' => 'default_cover_active:not(0)',
			'type'      => 'upload'
		);
		
		$options[] = array(
			'name'      => esc_html__('Add the maximum size for the profile picture, Add it with KB, for 1 MB add 1024.','discy'),
			'desc'      => esc_html__('Add the maximum size for the profile picture, Leave it empty if you need it unlimited size.','discy'),
			'id'        => 'profile_cover_size',
			'condition' => 'register_items:has(cover),edit_profile_items_1:has(cover)',
			'operator'  => 'or',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name'      => esc_html__('Cover full width or fixed','discy'),
			'desc'      => esc_html__('Choose the cover to make it work with full width or fixed.','discy'),
			'id'        => 'cover_fixed',
			'options'   => array(
				'normal' => esc_html__('Full width','discy'),
				'fixed'  => esc_html__('Fixed','discy'),
			),
			'std'       => 'normal',
			'condition' => 'cover_image:is(on)',
			'type'      => 'radio'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name'      => esc_html__('Activate other at the gender.','discy'),
			'id'        => 'gender_other',
			'condition' => 'register_items:has(gender),edit_profile_items_1:has(gender)',
			'operator'  => 'or',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Profile by login or nicename','discy'),
			'desc' => esc_html__('Choose the user profile page work by login or nicename.','discy'),
			'id'   => 'profile_type',
			'options' => array(
				'nicename' => esc_html__('Nicename','discy'),
				'login'    => esc_html__('Login name','discy'),
			),
			'std'     => 'nicename',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate the notifications system in site?','discy'),
			'desc' => esc_html__('Activate the notifications system enable or disable.','discy'),
			'id'   => 'active_notifications',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_notifications:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Choose the roles or users for the custom notification','discy'),
			'desc'    => esc_html__('Choose from here which roles or users you want to send the custom notification.','discy'),
			'id'      => 'notification_groups_users',
			'options' => array(
				'groups' => esc_html__('Roles','discy'),
				'users'  => esc_html__('Users','discy'),
			),
			'std'     => 'groups',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'      => esc_html__("Choose the roles that you want to send the custom notification.","discy"),
			'id'        => 'custom_notification_groups',
			'condition' => 'notification_groups_users:not(users)',
			'type'      => 'multicheck',
			'options'   => $new_roles,
			'std'       => array('administrator' => 'administrator','editor' => 'editor','contributor' => 'contributor','subscriber' => 'subscriber','author' => 'author'),
		);

		$options[] = array(
			'name'      => esc_html__('Specific user ids','discy'),
			'id'        => 'notification_specific_users',
			'condition' => 'notification_groups_users:is(users)',
			'type'      => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Custom notification','discy'),
			'id'   => 'custom_notification',
			'std'  => 'Welcome',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('You must save your options before sending the notification.','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name' => '<a href="#" class="button button-primary send-custom-notification">'.esc_html__('Send the custom notification','discy').'</a>',
			'type' => 'info'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate the activity log site?','discy'),
			'desc' => esc_html__('Activate the activity log enable or disable.','discy'),
			'id'   => 'active_activity_log',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Select the user stats','discy'),
			'id'      => 'user_stats',
			'type'    => 'multicheck',
			'std'     => array(
				"questions"    => "questions",
				"answers"      => "answers",
				"best_answers" => "best_answers",
				"points"       => "points",
			),
			'options' => array(
				"questions"    => esc_html__('Questions','discy'),
				"answers"      => esc_html__('Answers','discy'),
				"best_answers" => esc_html__('Best Answers','discy'),
				"points"       => esc_html__('Points','discy'),
			)
		);
		
		$options[] = array(
			'name'    => "",
			"margin"  => "-15px 0 0",
			'id'      => 'user_stats_2',
			'type'    => 'multicheck',
			'std'     => array(
				"i_follow"     => "i_follow",
				"followers"    => "followers",
			),
			'options' => array(
				"i_follow"     => esc_html__('Authors I Follow','discy'),
				"followers"    => esc_html__('Followers','discy'),
			)
		);
		
		$user_profile_pages = array(
			"questions"           => array("sort" => esc_html__('Questions','discy'),"value" => "questions"),
			"polls"               => array("sort" => esc_html__('Polls','discy'),"value" => "polls"),
			"answers"             => array("sort" => esc_html__('Answers','discy'),"value" => "answers"),
			"best-answers"        => array("sort" => esc_html__('Best Answers','discy'),"value" => "best-answers"),
			"asked"               => array("sort" => esc_html__('Asked Questions','discy'),"value" => ""),
			"asked-questions"     => array("sort" => esc_html__('Waiting Questions','discy'),"value" => ""),
			"paid-questions"      => array("sort" => esc_html__('Paid Questions','discy'),"value" => ""),
			"followed"            => array("sort" => esc_html__('Followed Questions','discy'),"value" => "followed"),
			"favorites"           => array("sort" => esc_html__('Favorite Questions','discy'),"value" => "favorites"),
			"groups"              => array("sort" => esc_html__('Groups','discy'),"value" => "groups"),
			"posts"               => array("sort" => esc_html__('Posts','discy'),"value" => ""),
			"comments"            => array("sort" => esc_html__('Comments','discy'),"value" => ""),
			"followers-questions" => array("sort" => esc_html__('Followers Questions','discy'),"value" => ""),
			"followers-answers"   => array("sort" => esc_html__('Followers Answers','discy'),"value" => ""),
			"followers-posts"     => array("sort" => esc_html__('Followers Posts','discy'),"value" => ""),
			"followers-comments"  => array("sort" => esc_html__('Followers Comments','discy'),"value" => ""),
		);
		
		$options[] = array(
			'name'         => esc_html__('Select the pages to show at the user profile page','discy'),
			'id'           => 'user_profile_pages',
			'type'         => 'multicheck',
			'sort'         => 'yes',
			'limit-height' => 'yes',
			'std'          => $user_profile_pages,
			'options'      => $user_profile_pages
		);
		
		$options[] = array(
			'name'    => esc_html__('Select the columns in the user admin','discy'),
			'id'      => 'user_meta_admin',
			'type'    => 'multicheck',
			'options' => array(
				"phone"      => esc_html__('Phone','discy'),
				"country"    => esc_html__('Country','discy'),
				"age"        => esc_html__('Age','discy'),
				"points"     => esc_html__('Points','discy'),
				"invitation" => esc_html__('Invitation','discy'),
			)
		);
		
		$options[] = array(
			'name'    => esc_html__('Users style at followed and search pages','discy'),
			'desc'    => esc_html__('Choose the users style at followed and search pages.','discy'),
			'id'      => 'user_style_pages',
			'options' => array(
				'columns'       => esc_html__('Columns','discy'),
				'small_grid'    => esc_html__('Small grid with follow','discy'),
				'simple_follow' => esc_html__('Simple with follow','discy'),
				'small'         => esc_html__('Small','discy'),
				'grid'          => esc_html__('Grid','discy'),
				'normal'        => esc_html__('Normal','discy'),
			),
			'std'     => 'columns',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name'      => esc_html__("Activate the masonry style?","discy"),
			'id'        => 'masonry_user_style',
			'type'      => 'checkbox',
			'condition' => 'user_style_pages:is(small_grid),user_style_pages:is(columns),user_style_pages:is(small),user_style_pages:is(grid)',
			'operator'  => 'or',
		);
		
		$options[] = array(
			'name' => esc_html__('Users per page at home, followed and search pages','discy'),
			'desc' => esc_html__('Put the users per page at home, followed and search pages.','discy'),
			'id'   => 'users_per_page',
			'std'  => '10',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'user_slugs',
			'name' => esc_html__('User Slugs','discy')
		);

		$options = apply_filters('discy_options_user_slugs',$options);
		
		$options[] = array(
			'name'      => esc_html__('User profile slug','discy'),
			'desc'      => esc_html__('Put the user profile slug.','discy'),
			'id'        => 'profile_slug',
			'std'       => 'profile',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Login slug','discy'),
			'desc' => esc_html__('Put the login slug.','discy'),
			'id'   => 'login_slug',
			'std'  => 'log-in',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Signup slug','discy'),
			'desc' => esc_html__('Put the signup slug.','discy'),
			'id'   => 'signup_slug',
			'std'  => 'sign-up',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Lost password slug','discy'),
			'desc' => esc_html__('Put the lost password slug.','discy'),
			'id'   => 'lost_password_slug',
			'std'  => 'lost-password',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Edit profile slug','discy'),
			'desc' => esc_html__('Put the edit profile slug.','discy'),
			'id'   => 'edit_slug',
			'std'  => 'edit',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Change password profile slug','discy'),
			'desc' => esc_html__('Put the change password slug.','discy'),
			'id'   => 'password_slug',
			'std'  => 'change-password',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Privacy profile slug','discy'),
			'desc' => esc_html__('Put the privacy profile slug.','discy'),
			'id'   => 'privacy_slug',
			'std'  => 'privacy',
			'type' => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Withdrawals profile slug','discy'),
			'desc' => esc_html__('Put the withdrawals profile slug.','discy'),
			'id'   => 'withdrawals_slug',
			'std'  => 'withdrawals',
			'type' => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Financial profile slug','discy'),
			'desc' => esc_html__('Put the financial profile slug.','discy'),
			'id'   => 'financial_slug',
			'std'  => 'financial',
			'type' => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Transactions profile slug','discy'),
			'desc' => esc_html__('Put the transactions profile slug.','discy'),
			'id'   => 'transactions_slug',
			'std'  => 'transactions',
			'type' => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Mails profile slug','discy'),
			'desc' => esc_html__('Put the mails profile slug.','discy'),
			'id'   => 'mails_slug',
			'std'  => 'mails',
			'type' => 'hidden'
		);
		
		$options[] = array(
			'name' => esc_html__('Delete profile slug','discy'),
			'desc' => esc_html__('Put the delete profile slug.','discy'),
			'id'   => 'delete_slug',
			'std'  => 'delete',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followers slug','discy'),
			'desc' => esc_html__('Put the user followers slug.','discy'),
			'id'   => 'followers_slug',
			'std'  => 'followers',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User following slug','discy'),
			'desc' => esc_html__('Put the user following slug.','discy'),
			'id'   => 'following_slug',
			'std'  => 'following',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User blocking slug','discy'),
			'desc' => esc_html__('Put the user blocking slug.','discy'),
			'id'   => 'blocking_slug',
			'std'  => 'blocking',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User notifications slug','discy'),
			'desc' => esc_html__('Put the user notifications slug.','discy'),
			'id'   => 'notifications_slug',
			'std'  => 'notifications',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User activities slug','discy'),
			'desc' => esc_html__('Put the user activities slug.','discy'),
			'id'   => 'activities_slug',
			'std'  => 'activities',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User questions slug','discy'),
			'desc' => esc_html__('Put the user questions slug.','discy'),
			'id'   => 'questions_slug',
			'std'  => 'questions',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User answers slug','discy'),
			'desc' => esc_html__('Put the user answers slug.','discy'),
			'id'   => 'answers_slug',
			'std'  => 'answers',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User best answers slug','discy'),
			'desc' => esc_html__('Put the user best answers slug.','discy'),
			'id'   => 'best_answers_slug',
			'std'  => 'best-answers',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User groups slug','discy'),
			'desc' => esc_html__('Put the user groups slug.','discy'),
			'id'   => 'groups_slug',
			'std'  => 'groups',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User points slug','discy'),
			'desc' => esc_html__('Put the user points slug.','discy'),
			'id'   => 'points_slug',
			'std'  => 'points',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User polls slug','discy'),
			'desc' => esc_html__('Put the user polls slug.','discy'),
			'id'   => 'polls_slug',
			'std'  => 'polls',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User asked slug','discy'),
			'desc' => esc_html__('Put the user asked slug.','discy'),
			'id'   => 'asked_slug',
			'std'  => 'asked',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User asked questions slug','discy'),
			'desc' => esc_html__('Put the user asked questions slug.','discy'),
			'id'   => 'asked_questions_slug',
			'std'  => 'asked-questions',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User paid questions slug','discy'),
			'desc' => esc_html__('Put the user paid questions slug.','discy'),
			'id'   => 'paid_questions_slug',
			'std'  => 'paid-questions',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followed slug','discy'),
			'desc' => esc_html__('Put the user followed slug.','discy'),
			'id'   => 'followed_slug',
			'std'  => 'followed',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User favorites slug','discy'),
			'desc' => esc_html__('Put the user favorites slug.','discy'),
			'id'   => 'favorites_slug',
			'std'  => 'favorites',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User posts slug','discy'),
			'desc' => esc_html__('Put the user posts slug.','discy'),
			'id'   => 'posts_slug',
			'std'  => 'posts',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User comments slug','discy'),
			'desc' => esc_html__('Put the user comments slug.','discy'),
			'id'   => 'comments_slug',
			'std'  => 'comments',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followers questions slug','discy'),
			'desc' => esc_html__('Put the user followers questions slug.','discy'),
			'id'   => 'followers_questions_slug',
			'std'  => 'followers-questions',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followers answers slug','discy'),
			'desc' => esc_html__('Put the user followers answers slug.','discy'),
			'id'   => 'followers_answers_slug',
			'std'  => 'followers-answers',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followers posts slug','discy'),
			'desc' => esc_html__('Put the user followers posts slug.','discy'),
			'id'   => 'followers_posts_slug',
			'std'  => 'followers-posts',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('User followers comments slug','discy'),
			'desc' => esc_html__('Put the user followers comments slug.','discy'),
			'id'   => 'followers_comments_slug',
			'std'  => 'followers-comments',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'login_setting',
			'name' => esc_html__('Login Setting','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Make the login works without ajax','discy'),
			'desc' => esc_html__('Select ON if you want to make the login works without ajax to avoid the problems with the cache plugin.','discy'),
			'id'   => 'stop_login_ajax',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Make the login works with popup','discy'),
			'desc' => esc_html__('Select ON if you want to make the login works with popup.','discy'),
			'id'   => 'login_popup',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('After login go to?','discy'),
			'id'      => 'after_login',
			'std'     => "same_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"home" => esc_html__("Home","discy"),"profile" => esc_html__("Profile","discy"),"custom_link" => esc_html__("Custom link","discy"))
		);
		
		$options[] = array(
			'name'      => esc_html__("Type the link if you don't like above","discy"),
			'id'        => 'after_login_link',
			'condition' => 'after_login:is(custom_link)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name'    => esc_html__('After Log out go to?','discy'),
			'id'      => 'after_logout',
			'std'     => "same_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"home" => esc_html__("Home","discy"),"custom_link" => esc_html__("Custom link","discy"))
		);
		
		$options[] = array(
			'name'      => esc_html__("Type the link if you don't like above","discy"),
			'id'        => 'after_logout_link',
			'condition' => 'after_logout:is(custom_link)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate after x view of pages will need to login','discy'),
			'id'   => 'activate_need_to_login',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name'      => esc_html__('After how many view pages will need to login?','discy'),
			"id"        => "need_login_pages",
			'condition' => 'activate_need_to_login:not(0)',
			"type"      => "sliderui",
			'std'       => '2',
			"step"      => "1",
			"min"       => "1",
			"max"       => "10"
		);

		$options[] = array(
			'name' => esc_html__('Make the site for the logged users only?','discy'),
			'desc' => esc_html__('Select ON to activate the site for the logged users only.','discy'),
			'id'   => 'site_users_only',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'site_users_only:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'type' => 'info',
			'name' => esc_html__('Unlogged page setting','discy')
		);
		
		$options[] = array(
			'name'    => esc_html__('Page style','discy'),
			'desc'    => esc_html__('Choose page style from here.','discy'),
			'id'      => 'register_style',
			'options' => array(
				'style_1'  => 'Style 1',
				'style_2'  => 'Style 2',
			),
			'std'     => 'style_1',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name'    => esc_html__('Upload the background','discy'),
			'desc'    => esc_html__('Upload the background for the unlogged page','discy'),
			'id'      => 'register_background',
			'type'    => 'background',
			'options' => array('color' => '','image' => ''),
			'std'     => array(
				'color' => '#272930',
				'image' => $imagepath_theme."register.png"
			)
		);
		
		$options[] = array(
			"name" => esc_html__('Choose the background opacity','discy'),
			"desc" => esc_html__('Choose the background opacity from here','discy'),
			"id"   => "register_opacity",
			"type" => "sliderui",
			'std'  => 30,
			"step" => "5",
			"min"  => "0",
			"max"  => "100"
		);
		
		$options[] = array(
			'name'    => esc_html__("Choose from here which menu will show for unlogged users.","discy"),
			'id'      => 'register_menu',
			'type'    => 'select',
			'options' => $menus
		);
		
		$options[] = array(
			'name' => esc_html__('The headline','discy'),
			'desc' => esc_html__('Type the Headline from here','discy'),
			'id'   => 'register_headline',
			'type' => 'text',
			'std'  => "Join the world's biggest Q & A network!"
		);
		
		$options[] = array(
			'name' => esc_html__('The paragraph','discy'),
			'desc' => esc_html__('Type the Paragraph from here','discy'),
			'id'   => 'register_paragraph',
			'type' => 'textarea',
			'std'  => "Login to our social questions & Answers Engine to ask questions answer people's questions & connect with other people."
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$allow_post_types = array(
			"posts"     => array("sort" => esc_html__('Posts','discy'),"value" => ""),
			"questions" => array("sort" => esc_html__('Questions','discy'),"value" => ""),
		);
		
		$options[] = array(
			'name'      => esc_html__("Choose if you want the posts or questions work for the unlogged users","discy"),
			'id'        => 'allow_post_types',
			'type'      => 'multicheck',
			'sort'      => 'yes',
			'condition' => 'activate_need_to_login:not(0),site_users_only:not(0)',
			'operator'  => 'or',
			'std'       => $allow_post_types,
			'options'   => $allow_post_types
		);
		
		$options[] = array(
			'name'    => esc_html__('Login popup style','discy'),
			'desc'    => esc_html__('Choose login popup style from here.','discy'),
			'id'      => 'login_style',
			'options' => array(
				'style_1' => esc_html__('Style 1','discy'),
				'style_2' => esc_html__('Style 2','discy'),
			),
			'std'     => 'style_1',
			'type'    => 'radio'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'login_style:not(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Logo for the login popup','discy'),
			'id'      => 'logo_login',
			'type'    => 'upload',
			'options' => array("height" => "logo_login_height","width" => "logo_login_width"),
		);

		$options[] = array(
			'name' => esc_html__('Logo retina for the login popup','discy'),
			'id'   => 'logo_login_retina',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Logo height','discy'),
			"id"   => "logo_login_height",
			"type" => "sliderui",
			'std'  => '45',
			"step" => "1",
			"min"  => "0",
			"max"  => "80"
		);
		
		$options[] = array(
			'name' => esc_html__('Logo width','discy'),
			"id"   => "logo_login_width",
			"type" => "sliderui",
			'std'  => '137',
			"step" => "1",
			"min"  => "0",
			"max"  => "170"
		);

		$options[] = array(
			'name' => esc_html__('Text for the login popup after the logo or the normal text','discy'),
			'id'   => 'text_login',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'login_style:is(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('Login image','discy'),
			'id'   => 'login_image',
			'type' => 'upload'
		);
		
		$options[] = array(
			"type" => "textarea",
			"id"   => "login_details",
			"std"  => "Login to our social questions & Answers Engine to ask questions answer people's questions & connect with other people.",
			"name" => esc_html__('Details for login popup','discy')
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'register_setting',
			'name' => esc_html__('Register Setting','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Make the register works without ajax','discy'),
			'desc' => esc_html__('Select ON if you want to make the register works without ajax to avoid the problems with the cache plugin.','discy'),
			'id'   => 'stop_register_ajax',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Make the register works with popup','discy'),
			'desc' => esc_html__('Select ON if you want to make the register works with popup.','discy'),
			'id'   => 'register_popup',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Register in default role','discy'),
			'desc'    => esc_html__('Select the default role when users registered.','discy'),
			'id'      => 'default_group',
			'std'     => 'subscriber',
			'type'    => 'select',
			'options' => discy_options_roles()
		);
		
		$options[] = array(
			'name'    => esc_html__('Add the black list emails or any domain to stop them from registering into the site','discy'),
			'id'      => "black_list_emails",
			'type'    => "elements",
			'sort'    => "no",
			'hide'    => "yes",
			'button'  => esc_html__('Add a new email','discy'),
			'options' => array(
				array(
					"type" => "text",
					"id"   => "email",
					"name" => esc_html__("Email or domain","discy")
				)
			),
		);
		
		$options[] = array(
			'name'    => esc_html__('Add the black list of words to stop anyone to register on the site with these words','discy'),
			'id'      => "block_words_register",
			'type'    => "elements",
			'sort'    => "no",
			'hide'    => "yes",
			'button'  => esc_html__('Add a new word','discy'),
			'options' => array(
				array(
					"type" => "text",
					"id"   => "name",
					"name" => esc_html__("Name","discy")
				)
			),
		);
		
		$options[] = array(
			'name'    => esc_html__('After register go to?','discy'),
			'id'      => 'after_register',
			'std'     => "same_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"home" => esc_html__("Home","discy"),"profile" => esc_html__("Profile","discy"),"custom_link" => esc_html__("Custom link","discy"))
		);
		
		$options[] = array(
			'name'      => esc_html__("Type the link if you don't like above","discy"),
			'id'        => 'after_register_link',
			'condition' => 'after_register:is(custom_link)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Send a welcome email when the user is registered','discy'),
			'desc' => esc_html__('Welcome mail for user review enable or disable.','discy'),
			'id'   => 'send_welcome_mail',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name' => esc_html__('The membership under review?','discy'),
			'desc' => esc_html__('Select ON to review the users before the registration is completed.','discy'),
			'id'   => 'user_review',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Send mail when user needs a review','discy'),
			'desc'      => esc_html__('Mail for user review enable or disable.','discy'),
			'id'        => 'send_email_users_review',
			'std'       => 'on',
			'condition' => 'user_review:not(0)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Confirm email enable or disable','discy'),
			'id'   => 'confirm_email',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Click ON to remove the confirm password from the register form.','discy'),
			'id'   => 'comfirm_password',
			'type' => 'checkbox'
		);

		$allow_duplicate_names = array(
			"nickname"     => array("sort" => esc_html__('Nickname','discy'),"value" => ""),
			"display_name" => array("sort" => esc_html__('Display Name','discy'),"value" => ""),
		);
		
		$options[] = array(
			'name'    => esc_html__("Choose if you want the nickname and display name to be duplicate or not","discy"),
			'id'      => 'allow_duplicate_names',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $allow_duplicate_names,
			'options' => $allow_duplicate_names
		);

		$register_items = array(
			"username"      => array("sort" => esc_html__('Username','discy'),"value" => "username","default" => "yes"),
			"email"         => array("sort" => esc_html__('E-mail','discy'),"value" => "email","default" => "yes"),
			"password"      => array("sort" => esc_html__('Password','discy'),"value" => "username","default" => "yes"),
			"nickname"      => array("sort" => esc_html__('Nickname','discy'),"value" => "nickname"),
			"first_name"    => array("sort" => esc_html__('First Name','discy'),"value" => "first_name"),
			"last_name"     => array("sort" => esc_html__('Last Name','discy'),"value" => "last_name"),
			"display_name"  => array("sort" => esc_html__('Display Name','discy'),"value" => "display_name"),
			"image_profile" => array("sort" => esc_html__('Image Profile','discy'),"value" => "image_profile"),
			"cover"         => array("sort" => esc_html__('Cover','discy'),"value" => "cover"),
			"country"       => array("sort" => esc_html__('Country','discy'),"value" => "country"),
			"city"          => array("sort" => esc_html__('City','discy'),"value" => "city"),
			"phone"         => array("sort" => esc_html__('Phone','discy'),"value" => "phone"),
			"gender"        => array("sort" => esc_html__('Gender','discy'),"value" => "gender"),
			"age"           => array("sort" => esc_html__('Age','discy'),"value" => "age"),
		);
		$register_items_std = array(
			"username"      => array("sort" => esc_html__('Username','discy'),"value" => "username","default" => "yes"),
			"email"         => array("sort" => esc_html__('E-mail','discy'),"value" => "email","default" => "yes"),
			"password"      => array("sort" => esc_html__('Password','discy'),"value" => "username","default" => "yes"),
			"nickname"      => array("sort" => esc_html__('Nickname','discy'),"value" => ""),
			"first_name"    => array("sort" => esc_html__('First Name','discy'),"value" => ""),
			"last_name"     => array("sort" => esc_html__('Last Name','discy'),"value" => ""),
			"display_name"  => array("sort" => esc_html__('Display Name','discy'),"value" => ""),
			"image_profile" => array("sort" => esc_html__('Image Profile','discy'),"value" => ""),
			"cover"         => array("sort" => esc_html__('Cover','discy'),"value" => ""),
			"country"       => array("sort" => esc_html__('Country','discy'),"value" => ""),
			"city"          => array("sort" => esc_html__('City','discy'),"value" => ""),
			"phone"         => array("sort" => esc_html__('Phone','discy'),"value" => ""),
			"gender"        => array("sort" => esc_html__('Gender','discy'),"value" => ""),
			"age"           => array("sort" => esc_html__('Age','discy'),"value" => ""),
		);

		$options[] = array(
			'name'    => esc_html__("Select what to show at register form","discy"),
			'id'      => 'register_items',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'options' => apply_filters("discy_options_register_items",$register_items),
			'std'     => $register_items_std
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'register_items:has(first_name),register_items:has(last_name),register_items:has(display_name),register_items:has(image_profile),register_items:has(cover),register_items:has(gender),register_items:has(country),register_items:has(city),register_items:has(phone),register_items:has(age)',
			'operator'  => 'or',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Required setting','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name'      => esc_html__('First name in register is required.','discy'),
			'id'        => 'first_name_required_register',
			'condition' => 'register_items:has(first_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Last name in register is required.','discy'),
			'id'        => 'last_name_required_register',
			'condition' => 'register_items:has(last_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Display name in register is required.','discy'),
			'id'        => 'display_name_required_register',
			'condition' => 'register_items:has(display_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Profile picture in register is required','discy'),
			'id'        => 'profile_picture_required_register',
			'condition' => 'register_items:has(image_profile)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Profile cover in register is required','discy'),
			'id'        => 'profile_cover_required_register',
			'condition' => 'register_items:has(cover),cover_image:is(on)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Gender in register is required.','discy'),
			'id'        => 'gender_required_register',
			'condition' => 'register_items:has(gender)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Country in register is required.','discy'),
			'id'        => 'country_required_register',
			'condition' => 'register_items:has(country)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('City in register is required.','discy'),
			'id'        => 'city_required_register',
			'condition' => 'register_items:has(city)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Phone in register is required.','discy'),
			'id'        => 'phone_required_register',
			'condition' => 'register_items:has(phone)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Age in register is required.','discy'),
			'id'        => 'age_required_register',
			'condition' => 'register_items:has(age)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Terms of Service and Privacy Policy','discy'),
			'type' => 'info',
		);
		
		$options[] = array(
			'name' => esc_html__('Activate Terms of Service and privacy policy page?','discy'),
			'desc' => esc_html__('Select ON if you want active Terms of Service and privacy policy page.','discy'),
			'id'   => 'terms_active_register',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'terms_active_register:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Select the checked by default option','discy'),
			'desc' => esc_html__('Select ON if you want to checked it by default.','discy'),
			'id'   => 'terms_checked_register',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'terms_active_target_register',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Terms page','discy'),
			'desc'    => esc_html__('Select the terms page','discy'),
			'id'      => 'terms_page_register',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the terms link if you don't like a page","discy"),
			'id'   => 'terms_link_register',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate Privacy Policy','discy'),
			'desc' => esc_html__('Select ON if you want to activate Privacy Policy.','discy'),
			'id'   => 'privacy_policy_register',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'privacy_policy_register:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'privacy_active_target_register',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Privacy Policy page','discy'),
			'desc'    => esc_html__('Select the privacy policy page','discy'),
			'id'      => 'privacy_page_register',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the privacy policy link if you don't like a page","discy"),
			'id'   => 'privacy_link_register',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to allow for the users register with space','discy'),
			'id'   => 'allow_spaces',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name'    => esc_html__('Select the default options when registered','discy'),
			'id'      => 'register_default_options',
			'type'    => 'multicheck',
			'std'     => array(
				"show_point_favorite"     => "show_point_favorite",
				"question_schedules"      => "question_schedules",
				"post_schedules"          => "post_schedules",
				"received_email"          => "received_email",
				"received_email_post"     => "received_email_post",
				"received_message"        => "received_message",
				"new_payment_mail"        => "new_payment_mail",
				"send_message_mail"       => "send_message_mail",
				"answer_on_your_question" => "answer_on_your_question",
				"answer_question_follow"  => "answer_question_follow",
				"notified_reply"          => "notified_reply",
			),
			'options' => array(
				"show_point_favorite"     => esc_html__('Show the private pages','discy'),
				"question_schedules"      => esc_html__('Send schedule mails for the users as a list with recent questions','discy'),
				"post_schedules"          => esc_html__('Send schedule mails for the users as a list with recent posts','discy'),
				"received_email"          => esc_html__('Send mail when user ask a new question','discy'),
				"received_email_post"     => esc_html__('Send mail when user add a new post','discy'),
				"received_message"        => esc_html__("Received message from another users","discy"),
				"new_payment_mail"        => esc_html__("Send mail when made new payment","discy"),
				"send_message_mail"       => esc_html__("Send mail when any user send message","discy"),
				"answer_on_your_question" => esc_html__("Send mail when any user answer on your question","discy"),
				"answer_question_follow"  => esc_html__("Send mail when any user answer on your following question","discy"),
				"notified_reply"          => esc_html__("Send mail when any user reply on your answer","discy"),
				"unsubscribe_mails"       => esc_html__("Unsubscribe form all the mails","discy"),
			)
		);
		
		$options[] = array(
			'name' => esc_html__('Signup setting','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name'    => esc_html__('Signup popup style','discy'),
			'desc'    => esc_html__('Choose signup pop up style from here.','discy'),
			'id'      => 'signup_style',
			'options' => array(
				'style_1' => esc_html__('Style 1','discy'),
				'style_2' => esc_html__('Style 2','discy'),
			),
			'std'     => 'style_1',
			'type'    => 'radio'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'signup_style:not(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Logo for the signup pop up','discy'),
			'id'      => 'logo_signup',
			'type'    => 'upload',
			'options' => array("height" => "logo_signup_height","width" => "logo_signup_width"),
		);

		$options[] = array(
			'name' => esc_html__('Logo retina for the signup pop up','discy'),
			'id'   => 'logo_signup_retina',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Logo height','discy'),
			"id"   => "logo_signup_height",
			"type" => "sliderui",
			'std'  => '45',
			"step" => "1",
			"min"  => "0",
			"max"  => "80"
		);
		
		$options[] = array(
			'name' => esc_html__('Logo width','discy'),
			"id"   => "logo_signup_width",
			"type" => "sliderui",
			'std'  => '137',
			"step" => "1",
			"min"  => "0",
			"max"  => "170"
		);

		$options[] = array(
			'name' => esc_html__('Text for the signup popup after the logo or the normal text','discy'),
			'id'   => 'text_signup',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'signup_style:is(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('Signup image','discy'),
			'id'   => 'signup_image',
			'type' => 'upload'
		);
		
		$options[] = array(
			"type" => "textarea",
			"id"   => "signup_details",
			"std"  => "Sign Up to our social questions and Answers Engine to ask questions, answer people's questions, and connect with other people.",
			"name" => esc_html__('Details for signup pop up','discy')
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Forgot password setting','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Make the forgot password works with popup','discy'),
			'desc' => esc_html__('Select ON if you want to make the forgot password works with popup.','discy'),
			'id'   => 'lost_pass_popup',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Forgot password pop up style','discy'),
			'desc'    => esc_html__('Choose Forgot password pop up style from here.','discy'),
			'id'      => 'pass_style',
			'options' => array(
				'style_1' => esc_html__('Style 1','discy'),
				'style_2' => esc_html__('Style 2','discy'),
			),
			'std'     => 'style_1',
			'type'    => 'radio'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'pass_style:not(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Logo for the forgot password pop up','discy'),
			'id'      => 'logo_pass',
			'type'    => 'upload',
			'options' => array("height" => "logo_pass_height","width" => "logo_pass_width"),
		);

		$options[] = array(
			'name' => esc_html__('Logo retina for the forgot password pop up','discy'),
			'id'   => 'logo_pass_retina',
			'type' => 'upload'
		);
		
		$options[] = array(
			'name' => esc_html__('Logo height','discy'),
			"id"   => "logo_pass_height",
			"type" => "sliderui",
			'std'  => '45',
			"step" => "1",
			"min"  => "0",
			"max"  => "80"
		);
		
		$options[] = array(
			'name' => esc_html__('Logo width','discy'),
			"id"   => "logo_pass_width",
			"type" => "sliderui",
			'std'  => '137',
			"step" => "1",
			"min"  => "0",
			"max"  => "170"
		);

		$options[] = array(
			'name' => esc_html__('Text for the forgot password pop up after the logo or the normal text','discy'),
			'id'   => 'text_pass',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'pass_style:is(style_2)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('Forgot password image','discy'),
			'id'   => 'pass_image',
			'type' => 'upload'
		);
		
		$options[] = array(
			"type" => "textarea",
			"id"   => "pass_details",
			"std"  => "Lost your password? Please enter your email address. You will receive a link and will create a new password via email.",
			"name" => esc_html__('Details for forgot password pop up','discy')
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'edit_profile',
			'name' => esc_html__('Edit Profile','discy')
		);
		
		$edit_profile_items_1 = array(
			"email"         => array("sort" => esc_html__('E-mail','discy'),"value" => "email","default" => "yes"),
			"nickname"      => array("sort" => esc_html__('Nickname','discy'),"value" => "nickname"),
			"first_name"    => array("sort" => esc_html__('First Name','discy'),"value" => "first_name"),
			"last_name"     => array("sort" => esc_html__('Last Name','discy'),"value" => "last_name"),
			"display_name"  => array("sort" => esc_html__('Display Name','discy'),"value" => "display_name"),
			"image_profile" => array("sort" => esc_html__('Image Profile','discy'),"value" => "image_profile"),
			"cover"         => array("sort" => esc_html__('Cover','discy'),"value" => "cover"),
			"country"       => array("sort" => esc_html__('Country','discy'),"value" => "country"),
			"city"          => array("sort" => esc_html__('City','discy'),"value" => "city"),
			"phone"         => array("sort" => esc_html__('Phone','discy'),"value" => "phone"),
			"gender"        => array("sort" => esc_html__('Gender','discy'),"value" => "gender"),
			"age"           => array("sort" => esc_html__('Age','discy'),"value" => "age"),
		);
		
		$options[] = array(
			'name'    => esc_html__("Select what to show at edit profile at the Basic Information section","discy"),
			'id'      => 'edit_profile_items_1',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $edit_profile_items_1,
			'options' => apply_filters("discy_options_edit_profile_items_1",$edit_profile_items_1),
		);
		
		$options[] = array(
			'name'      => esc_html__('You need to activate the cover option from the User settings/General Setting','discy'),
			'condition' => 'cover_image:not(on),edit_profile_items_1:has(cover)',
			'type'      => 'info'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'edit_profile_items_1:has(first_name),edit_profile_items_1:has(last_name),edit_profile_items_1:has(display_name),edit_profile_items_1:has(image_profile),edit_profile_items_1:has(cover),edit_profile_items_1:has(gender),edit_profile_items_1:has(country),edit_profile_items_1:has(city),edit_profile_items_1:has(phone),edit_profile_items_1:has(age)',
			'operator'  => 'or',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Required setting','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name'      => esc_html__('First name in edit profile is required.','discy'),
			'id'        => 'first_name_required',
			'condition' => 'edit_profile_items_1:has(first_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Last name in edit profile is required.','discy'),
			'id'        => 'last_name_required',
			'condition' => 'edit_profile_items_1:has(last_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Display name in edit profile is required.','discy'),
			'id'        => 'display_name_required',
			'condition' => 'edit_profile_items_1:has(display_name)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Profile picture in edit profile is required','discy'),
			'id'        => 'profile_picture_required',
			'condition' => 'edit_profile_items_1:has(image_profile)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Profile cover in edit profile is required','discy'),
			'id'        => 'profile_cover_required',
			'condition' => 'edit_profile_items_1:has(cover)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Gender in edit profile is required.','discy'),
			'id'        => 'gender_required',
			'condition' => 'edit_profile_items_1:has(gender)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Country in edit profile is required.','discy'),
			'id'        => 'country_required',
			'condition' => 'edit_profile_items_1:has(country)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('City in edit profile is required.','discy'),
			'id'        => 'city_required',
			'condition' => 'edit_profile_items_1:has(city)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Phone in edit profile is required.','discy'),
			'id'        => 'phone_required',
			'condition' => 'edit_profile_items_1:has(phone)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Age in edit profile is required.','discy'),
			'id'        => 'age_required',
			'condition' => 'edit_profile_items_1:has(age)',
			'type'      => 'checkbox'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Social Profiles section','discy'),
			'type' => 'info',
		);
		
		$edit_profile_items_2 = array(
			"facebook"  => array("sort" => esc_html__('Facebook','discy'),"value" => "facebook"),
			"twitter"   => array("sort" => esc_html__('Twitter','discy'),"value" => "twitter"),
			"youtube"   => array("sort" => esc_html__('Youtube','discy'),"value" => "youtube"),
			"vimeo"     => array("sort" => esc_html__('Vimeo','discy'),"value" => "vimeo"),
			"linkedin"  => array("sort" => esc_html__('Linkedin','discy'),"value" => "linkedin"),
			"instagram" => array("sort" => esc_html__('Instagram','discy'),"value" => "instagram"),
			"pinterest" => array("sort" => esc_html__('Pinterest','discy'),"value" => "pinterest"),
		);
		
		$options[] = array(
			'name'    => esc_html__("Select what to show at edit profile at the Social Profiles section","discy"),
			'id'      => 'edit_profile_items_2',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $edit_profile_items_2,
			'options' => $edit_profile_items_2
		);
		
		$options[] = array(
			'name' => esc_html__('About Me section','discy'),
			'type' => 'info',
		);
		
		$edit_profile_items_3 = array(
			"website"            => array("sort" => esc_html__('Website','discy'),"value" => "website"),
			"bio"                => array("sort" => esc_html__('Professional Bio','discy'),"value" => "bio"),
			"profile_credential" => array("sort" => esc_html__('Profile credential','discy'),"value" => "profile_credential"),
			"private_pages"      => array("sort" => esc_html__('Private Pages','discy'),"value" => "private_pages"),
			"received_message"   => array("sort" => esc_html__('Received message from the users','discy'),"value" => "received_message"),
		);
		
		$options[] = array(
			'name'    => esc_html__("Select what to show at edit profile at the About Me section","discy"),
			'id'      => 'edit_profile_items_3',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $edit_profile_items_3,
			'options' => $edit_profile_items_3
		);

		$options[] = array(
			'name'      => esc_html__('URL in edit profile form is required','discy'),
			'id'        => 'url_required_profile',
			'condition' => 'edit_profile_items_3:has(website)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Editor enable or disable for professional bio','discy'),
			'id'        => 'bio_editor',
			'condition' => 'edit_profile_items_3:has(bio)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'edit_profile_items_3:has(profile_credential)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Profile credential in edit profile is required.','discy'),
			'id'   => 'profile_credential_required',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Add the maximum length for the profile credential, leave it empty if you need it unlimited.','discy'),
			'id'   => 'profile_credential_maximum',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom categories at the left menu','discy'),
			'type' => 'info',
		);

		$options[] = array(
			'name' => esc_html__('Do you need to allow the users to add a custom categories at the left menu?','discy'),
			'desc' => esc_html__('Select ON if you need the users to add a custom categories at the left menu.','discy'),
			'id'   => 'custom_left_menu',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name'      => esc_html__('Put from here after which number of the items you need to show the custom categories for the left menu','discy'),
			'id'        => 'left_menu_category_after',
			'std'       => '2',
			'condition' => 'custom_left_menu:not(0)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Mails section','discy'),
			'type' => 'info',
		);

		$edit_profile_items_4 = array(
			"question_schedules"      => array("sort" => esc_html__('Send schedule mails for the users as a list with recent questions','discy'),"value" => "question_schedules"),
			"post_schedules"          => array("sort" => esc_html__('Send schedule mails for the users as a list with recent posts','discy'),"value" => "post_schedules"),
			"send_emails"             => array("sort" => esc_html__('Send mail when any users ask questions','discy'),"value" => "send_emails"),
			"send_emails_post"        => array("sort" => esc_html__('Send mail when any users add posts','discy'),"value" => "send_emails_post"),
			"new_payment_mail"        => array("sort" => esc_html__('Send mail when made new payment','discy'),"value" => "new_payment_mail"),
			"send_message_mail"       => array("sort" => esc_html__('Send mail when any user send message','discy'),"value" => "send_message_mail"),
			"answer_on_your_question" => array("sort" => esc_html__('Send mail when any user answer on your question','discy'),"value" => "answer_on_your_question"),
			"answer_question_follow"  => array("sort" => esc_html__('Send mail when any user answer on your following question','discy'),"value" => "answer_question_follow"),
			"notified_reply"          => array("sort" => esc_html__('Send mail when any user reply on your answer','discy'),"value" => "notified_reply"),
			"unsubscribe_mails"       => array("sort" => esc_html__('Unsubscribe form all the mails','discy'),"value" => "unsubscribe_mails"),
		);
		
		$options[] = array(
			'name'    => esc_html__("Select what to show at edit profile at the mails section","discy"),
			'id'      => 'edit_profile_items_4',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $edit_profile_items_4,
			'options' => $edit_profile_items_4
		);
		
		$options[] = array(
			'name' => esc_html__('Privacy account','discy'),
			'type' => 'info',
		);

		$options[] = array(
			'name' => esc_html__('Do you like to allow the users to choose their privacy?','discy'),
			'id'   => 'privacy_account',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$privacy_options = array(
			"public"  => esc_html__('Public','discy'),
			"members" => esc_html__("All members","discy"),
			"me"      => esc_html__("Only me","discy"),
		);

		$privacy_array = array(
			"email"      => esc_html__("Email","discy"),
			"country"    => esc_html__("Country","discy"),
			"city"       => esc_html__("City","discy"),
			"phone"      => esc_html__("Phone","discy"),
			"gender"     => esc_html__("Gender","discy"),
			"age"        => esc_html__("Age","discy"),
			"social"     => esc_html__("Social links","discy"),
			"website"    => esc_html__("Website","discy"),
			"bio"        => esc_html__("Biography","discy"),
			"credential" => esc_html__("Profile credential","discy")
		);

		foreach ($privacy_array as $key_privacy => $value_privacy) {
			$options[] = array(
				'name'    => $value_privacy,
				'id'      => 'privacy_'.$key_privacy,
				'type'    => 'select',
				'options' => $privacy_options,
				'std'     => ($key_privacy == "email"?"me":"public")
			);
		}

		$options[] = array(
			'name' => esc_html__('Delete account','discy'),
			'type' => 'info',
		);

		$options[] = array(
			'name' => esc_html__('Do you like to allow the users to delete their account?','discy'),
			'id'   => 'delete_account',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Profile Strength / To use this feature you need to add widget "Profile Strength"','discy'),
			'type' => 'info',
		);

		$profile_strength_std = apply_filters("discy_filter_profile_strength_std",array(
				"avatar"       => "avatar",
				"cover"        => "cover",
				"credential"   => "credential",
				"follow_cats"  => "follow_cats",
				"follow_user"  => "follow_user",
				"ask_question" => "ask_question",
				"answer"       => "answer",
			)
		);

		$profile_strength = apply_filters("discy_filter_profile_strength",array(
				"avatar"       => esc_html__('User Avatar','discy'),
				"cover"        => esc_html__('User Cover','discy'),
				"credential"   => esc_html__('Profile Credential','discy'),
				"follow_cats"  => esc_html__("Follow Categories","discy"),
				"follow_user"  => esc_html__("Follow Users","discy"),
				"ask_question" => esc_html__("Ask first question","discy"),
				"answer"       => esc_html__("Add Answers","discy"),
			)
		);

		$options[] = array(
			'name'    => esc_html__('Select the items for the profile strength','discy'),
			'id'      => 'profile_strength',
			'type'    => 'multicheck',
			'std'     => $profile_strength_std,
			'options' => $profile_strength
		);

		$options[] = array(
			'name'      => esc_html__('Select the number for the profile strength for the following categories','discy'),
			'id'        => 'profile_follow_cats',
			'type'      => 'text',
			'std'       => '3',
			'condition' => 'profile_strength:has(follow_cats)',
		);

		$options[] = array(
			'name'      => esc_html__('Select the number for the profile strength for the following users','discy'),
			'id'        => 'profile_follow_users',
			'type'      => 'text',
			'std'       => '3',
			'condition' => 'profile_strength:has(follow_user)',
		);

		$options[] = array(
			'name'      => esc_html__('Select the number for the profile strength for the answers on the questions','discy'),
			'id'        => 'profile_answer',
			'type'      => 'text',
			'std'       => '3',
			'condition' => 'profile_strength:has(answer)',
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for avatar','discy'),
			"id"        => "percent_avatar",
			"type"      => "sliderui",
			'std'       => 10,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(avatar)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for cover','discy'),
			"id"        => "percent_cover",
			"type"      => "sliderui",
			'std'       => 10,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(cover)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for credential','discy'),
			"id"        => "percent_credential",
			"type"      => "sliderui",
			'std'       => 10,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(credential)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for follow cats','discy'),
			"id"        => "percent_follow_cats",
			"type"      => "sliderui",
			'std'       => 20,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(follow_cats)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for follow user','discy'),
			"id"        => "percent_follow_user",
			"type"      => "sliderui",
			'std'       => 20,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(follow_user)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for ask question','discy'),
			"id"        => "percent_ask_question",
			"type"      => "sliderui",
			'std'       => 10,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(ask_question)",
			"max"       => "100"
		);
		
		$options[] = array(
			"name"      => esc_html__('The percent for answer','discy'),
			"id"        => "percent_answer",
			"type"      => "sliderui",
			'std'       => 20,
			"step"      => "1",
			"min"       => "1",
			"condition" => "profile_strength:has(answer)",
			"max"       => "100"
		);

		$options = apply_filters('discy_options_after_percent_answer',$options);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'ask_users',
			'name' => esc_html__('Ask Users','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Ask question to the users','discy'),
			'desc' => esc_html__('Any one can ask question to the users enable or disable.','discy'),
			'id'   => 'ask_question_to_users',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'ask_question_to_users:not(0)',
			'type'      => 'heading-2'
		);
		
		$ask_user_items = array(
			"title_question"       => array("sort" => esc_html__('Question Title','discy'),"value" => "title_question"),
			"comment_question"     => array("sort" => esc_html__('Question content','discy'),"value" => "comment_question"),
			"anonymously_question" => array("sort" => esc_html__('Ask Anonymously','discy'),"value" => "anonymously_question"),
			"private_question"     => array("sort" => esc_html__('Private Question','discy'),"value" => "private_question"),
			"remember_answer"      => array("sort" => esc_html__('Remember Answer','discy'),"value" => "remember_answer"),
			"terms_active"         => array("sort" => esc_html__('Terms of Service and Privacy Policy','discy'),"value" => "terms_active"),
		);
		
		$options[] = array(
			'name'    => esc_html__("Select what to show at ask user question form","discy"),
			'id'      => 'ask_user_items',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $ask_user_items,
			'options' => $ask_user_items
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'ask_user_items:has_not(title_question)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Excerpt type for title from the content','discy'),
			'desc'    => esc_html__('Choose form here the excerpt type.','discy'),
			'id'      => 'title_excerpt_type_user',
			'type'    => "select",
			'options' => array(
				'words'      => esc_html__('Words','discy'),
				'characters' => esc_html__('Characters','discy')
			)
		);

		$options[] = array(
			'name' => esc_html__('Excerpt title from the content','discy'),
			'desc' => esc_html__('Put here the excerpt title from the content.','discy'),
			'id'   => 'title_excerpt_user',
			'std'  => 10,
			'type' => 'text'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end',
			'div'  => 'div'
		);

		$options[] = array(
			'name'      => esc_html__('Select the checked by default options at ask user question form','discy'),
			'id'        => 'add_question_default_user',
			'type'      => 'multicheck',
			'condition' => 'ask_user_items:has(anonymously_question),ask_user_items:has(private_question),ask_user_items:has(remember_answer),ask_user_items:has(terms_active)',
			'operator'  => 'or',
			'std'       => array(
				"notified" => "notified",
			),
			'options' => array(
				"notified"    => esc_html__('Notified','discy'),
				"private"     => esc_html__("Private question","discy"),
				"anonymously" => esc_html__("Ask anonymously","discy"),
				"terms"       => esc_html__("Terms","discy"),
			)
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'ask_user_items:has(comment_question)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Details in ask question form is required','discy'),
			'id'   => 'content_ask_user',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the editor for details in ask question form','discy'),
			'id'   => 'editor_ask_user',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'ask_user_items:has(terms_active)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('Terms of Service and Privacy Policy','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'terms_active_user_target',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Terms page','discy'),
			'desc'    => esc_html__('Select the terms page','discy'),
			'id'      => 'terms_page_user',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the terms link if you don't like a page","discy"),
			'id'   => 'terms_link_user',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate Privacy Policy','discy'),
			'desc' => esc_html__('Select ON if you want to activate Privacy Policy.','discy'),
			'id'   => 'privacy_policy_user',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'privacy_policy_user:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'privacy_active_target_user',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Privacy Policy page','discy'),
			'desc'    => esc_html__('Select the privacy policy page','discy'),
			'id'      => 'privacy_page_user',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the privacy policy link if you don't like a page","discy"),
			'id'   => 'privacy_link_user',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'referral_setting',
			'name' => esc_html__('Referral Setting','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Activate referrals to the users','discy'),
			'desc' => esc_html__('Any one can send referral to the users enable or disable.','discy'),
			'id'   => 'active_referral',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_referral:not(0)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__("Referrals slug","discy"),
			'desc' => esc_html__("Select the referrals slug","discy"),
			'id'   => 'referrals_slug',
			'type' => 'text',
			'std'  => 'referrals'
		);
		
		$options[] = array(
			'name' => esc_html__('The headline','discy'),
			'desc' => esc_html__('Type the Headline from here','discy'),
			'id'   => 'referrals_headline',
			'type' => 'text',
			'std'  => 'Spread the word. Earn points.'
		);
		
		$options[] = array(
			'name' => esc_html__('The paragraph','discy'),
			'desc' => esc_html__('Type the Paragraph from here','discy'),
			'id'   => 'referrals_paragraph',
			'type' => 'textarea',
			'std'  => 'We have a number of ways to help spread the word to your friends and family, Choose whatever works best for you.'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate the share on referrals','discy'),
			'desc' => esc_html__('Share enable or disable for referrals','discy'),
			'id'   => 'referrals_share_on',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name'      => esc_html__('Select the share options','discy'),
			'id'        => 'referrals_share',
			'condition' => 'referrals_share_on:not(0)',
			'type'      => 'multicheck',
			'sort'      => 'yes',
			'std'       => $share_array,
			'options'   => $share_array
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'popup_notification',
			'name' => esc_html__('Popup Notification','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Note: the last popup notification only will show not all the popup notifications.','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name'    => esc_html__('Show the popup notification for the user one time only or forever','discy'),
			'id'      => 'popup_notification_time',
			'options' => array(
				'one_time' => esc_html__('One time','discy'),
				'for_ever' => esc_html__('Forever','discy'),
			),
			'std'     => 'one_time',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'    => esc_html__('Show the popup notification at all the pages, custom pages, or home page only?','discy'),
			'id'      => 'popup_notification_home_pages',
			'options' => array(
				'home_page'     => esc_html__('Home page','discy'),
				'all_pages'     => esc_html__('All site pages','discy'),
				'all_posts'     => esc_html__('All single post pages','discy'),
				'all_questions' => esc_html__('All single question pages','discy'),
				'custom_pages'  => esc_html__('Custom pages','discy'),
			),
			'std'     => 'home_page',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'      => esc_html__('Page ids','discy'),
			'desc'      => esc_html__('Type from here the page ids','discy'),
			'id'        => 'popup_notification_pages',
			'type'      => 'text',
			'condition' => 'popup_notification_home_pages:is(custom_pages)'
		);

		$options[] = array(
			'name'    => esc_html__('Choose the roles or users for the popup notification','discy'),
			'desc'    => esc_html__('Choose from here which roles or users you want to send the popup notification.','discy'),
			'id'      => 'popup_notification_groups_users',
			'options' => array(
				'groups' => esc_html__('Roles','discy'),
				'users'  => esc_html__('Users','discy'),
			),
			'std'     => 'groups',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'      => esc_html__("Choose the roles you need to send the popup notification.","discy"),
			'id'        => 'popup_notification_groups',
			'condition' => 'popup_notification_groups_users:not(users)',
			'type'      => 'multicheck',
			'options'   => $new_roles,
			'std'       => array('administrator' => 'administrator','editor' => 'editor','contributor' => 'contributor','subscriber' => 'subscriber','author' => 'author'),
		);

		$options[] = array(
			'name'      => esc_html__('Specific user ids','discy'),
			'id'        => 'popup_notification_specific_users',
			'condition' => 'popup_notification_groups_users:is(users)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Popup notification text','discy'),
			'id'       => 'popup_notification_text',
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'popup_notification_button_target',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name' => esc_html__('Type the button link','discy'),
			'id'   => 'popup_notification_button_url',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Type the button text','discy'),
			'id'   => 'popup_notification_button_text',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('You must save your options before sending the popup notification.','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => '<a href="#" class="button button-primary send-popup-notification">'.esc_html__('Send the popup notification','discy').'</a>',
			'type' => 'info'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'permissions',
			'name' => esc_html__('Permissions','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to add a custom permission.','discy'),
			'id'   => 'custom_permission',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'custom_permission:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Unlogged users','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to ask a question.','discy'),
			'id'   => 'ask_question',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to view other questions.','discy'),
			'id'   => 'show_question',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to add an answer.','discy'),
			'id'   => 'add_answer',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to view other answers.','discy'),
			'id'   => 'show_answer',
			'std'  => "on",
			'type' => 'checkbox'
		);

		$options[] = array(
			'name' => esc_html__('Select ON to be able to add a group.','discy'),
			'id'   => 'add_group',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to add a post.','discy'),
			'id'   => 'add_post',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to add a category.','discy'),
			'id'   => 'add_category',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to send message.','discy'),
			'id'   => 'send_message',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to auto approve the questions when media has been attached.','discy'),
			'id'   => 'approve_question_media',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to auto approve the answers when media has been attached.','discy'),
			'id'   => 'approve_answer_media',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to view other posts.','discy'),
			'id'   => 'show_post',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to add a comment.','discy'),
			'id'   => 'add_comment',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to be able to view other comments.','discy'),
			'id'   => 'show_comment',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Setting for the user roles & Add a new role','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'id'   => "roles",
			'type' => 'roles'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end',
			'div'  => 'div'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'author_setting',
			'name' => esc_html__('Author Setting','discy')
		);
		
		$options[] = array(
			'name'    => esc_html__('Post style','discy'),
			'desc'    => esc_html__('Choose post style from here.','discy'),
			'id'      => 'author_post_style',
			'options' => array(
				'default'  => esc_html__('Default','discy'),
				'style_1'  => esc_html__('1 column','discy'),
				'style_2'  => esc_html__('List style','discy'),
				'style_3'  => esc_html__('Columns','discy'),
			),
			'std'     => 'default',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'id'        => "author_sort_meta_title_image",
			'condition' => 'author_post_style:is(style_3)',
			'std'       => array(
							array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
							array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
						),
			'type'      => "sort",
			'options'   => array(
							array("value" => "image",'name' => esc_html__('Image','discy'),"default" => "yes"),
							array("value" => "meta_title",'name' => esc_html__('Meta and title','discy'),"default" => "yes"),
						)
		);
		
		$options[] = array(
			'name'    => esc_html__('Author sidebar layout','discy'),
			'id'      => "author_sidebar_layout",
			'std'     => "default",
			'type'    => "images",
			'options' => array(
				'default'      => $imagepath.'sidebar_default.jpg',
				'menu_sidebar' => $imagepath.'menu_sidebar.jpg',
				'right'        => $imagepath.'sidebar_right.jpg',
				'full'         => $imagepath.'sidebar_no.jpg',
				'left'         => $imagepath.'sidebar_left.jpg',
				'centered'     => $imagepath.'centered.jpg',
				'menu_left'    => $imagepath.'menu_left.jpg',
			)
		);
		
		$options[] = array(
			'name'      => esc_html__('Author Page sidebar','discy'),
			'id'        => "author_sidebar",
			'options'   => $new_sidebars,
			'type'      => 'select',
			'condition' => 'author_sidebar_layout:not(full),author_sidebar_layout:not(centered),author_sidebar_layout:not(menu_left)'
		);
		
		$options[] = array(
			'name'      => esc_html__('Author Page sidebar 2','discy'),
			'id'        => "author_sidebar_2",
			'options'   => $new_sidebars,
			'type'      => 'select',
			'operator'  => 'or',
			'condition' => 'author_sidebar_layout:is(menu_sidebar),author_sidebar_layout:is(menu_left)'
		);
		
		$options[] = array(
			'name'    => esc_html__('Choose Your Skin','discy'),
			'class'   => "site_skin",
			'id'      => "author_skin",
			'std'     => "default",
			'type'    => "images",
			'options' => array(
				'default'    => $imagepath.'default_color.jpg',
				'skin'       => $imagepath.'default.jpg',
				'violet'     => $imagepath.'violet.jpg',
				'bright_red' => $imagepath.'bright_red.jpg',
				'green'      => $imagepath.'green.jpg',
				'red'        => $imagepath.'red.jpg',
				'cyan'       => $imagepath.'cyan.jpg',
				'blue'       => $imagepath.'blue.jpg',
			)
		);
		
		$options[] = array(
			'name' => esc_html__('Primary Color','discy'),
			'id'   => 'author_primary_color',
			'type' => 'color'
		);
		
		$options[] = array(
			'name'    => esc_html__('Background Type','discy'),
			'id'      => 'author_background_type',
			'std'     => 'default',
			'type'    => 'radio',
			'options' => 
				array(
					"default"           => esc_html__("Default","discy"),
					"none"              => esc_html__("None","discy"),
					"patterns"          => esc_html__("Patterns","discy"),
					"custom_background" => esc_html__("Custom Background","discy")
				)
		);

		$options[] = array(
			'name'      => esc_html__('Background Color','discy'),
			'id'        => 'author_background_color',
			'type'      => 'color',
			'condition' => 'author_background_type:is(patterns)'
		);
			
		$options[] = array(
			'name'      => esc_html__('Choose Pattern','discy'),
			'id'        => "author_background_pattern",
			'std'       => "bg13",
			'type'      => "images",
			'condition' => 'author_background_type:is(patterns)',
			'class'     => "pattern_images",
			'options'   => array(
				'bg1'  => $imagepath.'bg1.jpg',
				'bg2'  => $imagepath.'bg2.jpg',
				'bg3'  => $imagepath.'bg3.jpg',
				'bg4'  => $imagepath.'bg4.jpg',
				'bg5'  => $imagepath.'bg5.jpg',
				'bg6'  => $imagepath.'bg6.jpg',
				'bg7'  => $imagepath.'bg7.jpg',
				'bg8'  => $imagepath.'bg8.jpg',
				'bg9'  => $imagepath_theme.'patterns/bg9.png',
				'bg10' => $imagepath_theme.'patterns/bg10.png',
				'bg11' => $imagepath_theme.'patterns/bg11.png',
				'bg12' => $imagepath_theme.'patterns/bg12.png',
				'bg13' => $imagepath.'bg13.jpg',
				'bg14' => $imagepath.'bg14.jpg',
				'bg15' => $imagepath_theme.'patterns/bg15.png',
				'bg16' => $imagepath_theme.'patterns/bg16.png',
				'bg17' => $imagepath.'bg17.jpg',
				'bg18' => $imagepath.'bg18.jpg',
				'bg19' => $imagepath.'bg19.jpg',
				'bg20' => $imagepath.'bg20.jpg',
				'bg21' => $imagepath_theme.'patterns/bg21.png',
				'bg22' => $imagepath.'bg22.jpg',
				'bg23' => $imagepath_theme.'patterns/bg23.png',
				'bg24' => $imagepath_theme.'patterns/bg24.png',
			)
		);

		$options[] = array(
			'name'      => esc_html__('Custom Background','discy'),
			'id'        => 'author_custom_background',
			'std'       => $background_defaults,
			'type'      => 'background',
			'options'   => $background_defaults,
			'condition' => 'author_background_type:is(custom_background)'
		);
			
		$options[] = array(
			'name'      => esc_html__('Full Screen Background','discy'),
			'desc'      => esc_html__('Select ON to enable Full Screen Background','discy'),
			'id'        => 'author_full_screen_background',
			'type'      => 'checkbox',
			'condition' => 'author_background_type:is(custom_background)'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Message settings','discy'),
			'icon' => 'email-alt',
			'type' => 'heading'
		);
		
		$options[] = array(
			'type' => 'heading-2',
		);
		
		$options[] = array(
			'name' => esc_html__('Activate messages to the users','discy'),
			'desc' => esc_html__('Any one can send message to the users enable or disable.','discy'),
			'id'   => 'active_message',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_message:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__("Messages slug","discy"),
			'desc' => esc_html__("Select the messages slug","discy"),
			'id'   => 'messages_slug',
			'type' => 'text',
			'std'  => 'messages'
		);
		
		$options[] = array(
			'name'    => esc_html__('Choose message status','discy'),
			'desc'    => esc_html__('Choose message status after user publish the message.','discy'),
			'id'      => 'message_publish',
			'options' => array("publish" => esc_html__("Auto publish","discy"),"draft" => esc_html__("Need a review","discy")),
			'std'     => 'draft',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name' => esc_html__('Any one can send message without register','discy'),
			'desc' => esc_html__('Any one can send message without register enable or disable.','discy'),
			'id'   => 'send_message_no_register',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the featured image in send message form','discy'),
			'id'   => 'featured_image_message',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'featured_image_message:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to enable the lightbox for featured image','discy'),
			'desc' => esc_html__('Select ON to enable the lightbox for featured image.','discy'),
			'id'   => 'featured_image_message_lightbox',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			"name" => esc_html__("Set the width for the featured image for the message","discy"),
			"id"   => "featured_image_message_width",
			"type" => "sliderui",
			'std'  => 260,
			"step" => "1",
			"min"  => "50",
			"max"  => "600"
		);
		
		$options[] = array(
			"name" => esc_html__("Set the height for the featured image for the message","discy"),
			"id"   => "featured_image_message_height",
			"type" => "sliderui",
			'std'  => 185,
			"step" => "1",
			"min"  => "50",
			"max"  => "600"
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Details in send message form is required','discy'),
			'id'   => 'comment_message',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the editor for details in send message form','discy'),
			'id'   => 'editor_message_details',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Send mail after message has been sent?','discy'),
			'id'   => 'send_email_message',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate user can delete the messages','discy'),
			'desc' => esc_html__('Select ON if you want the user to be able to delete the messages.','discy'),
			'id'   => 'message_delete',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate user can see the message in the notification','discy'),
			'desc' => esc_html__('Select ON if you want the user to be notified if the message is seen.','discy'),
			'id'   => 'seen_message',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$roles_user_only = $new_roles;
		unset($roles_user_only["wpqa_under_review"]);
		unset($roles_user_only["ban_group"]);
		unset($roles_user_only["activation"]);

		$options[] = array(
			'name'    => esc_html__('Choose the roles or users for the custom message','discy'),
			'desc'    => esc_html__('Choose from here which roles or users you want to send the custom message.','discy'),
			'id'      => 'message_groups_users',
			'options' => array(
				'groups' => esc_html__('Roles','discy'),
				'users'  => esc_html__('Users','discy'),
			),
			'std'     => 'groups',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'      => esc_html__("Choose the roles you need to send the custom message.","discy"),
			'id'        => 'custom_message_groups',
			'condition' => 'message_groups_users:not(users)',
			'type'      => 'multicheck',
			'options'   => $new_roles,
			'std'       => array('administrator' => 'administrator','editor' => 'editor','contributor' => 'contributor','subscriber' => 'subscriber','author' => 'author'),
		);

		$options[] = array(
			'name'      => esc_html__('Specific user ids','discy'),
			'id'        => 'message_specific_users',
			'condition' => 'message_groups_users:is(users)',
			'type'      => 'text'
		);

		$options[] = array(
			'name' => esc_html__('Custom message title','discy'),
			'id'   => 'title_custom_message',
			'std'  => 'Welcome',
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Custom message','discy'),
			'id'       => 'custom_message',
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'name' => esc_html__('You must save your options before send the message.','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => '<a href="#" class="button button-primary send-custom-message">'.esc_html__('Send the custom message','discy').'</a>',
			'type' => 'info'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);

		$badges_setting = array(
			"badges" => esc_html__('Badge settings','discy'),
			"points" => esc_html__('Point settings','discy')
		);
		
		$options[] = array(
			'name'    => esc_html__('Badges & Point settings','discy'),
			'id'      => 'badges',
			'icon'    => 'star-filled',
			'type'    => 'heading',
			'std'     => 'badges',
			'options' => apply_filters("discy_badges_setting",$badges_setting)
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'badges',
			'name' => esc_html__('Badge settings','discy')
		);
		
		$options[] = array(
			"type" => "textarea",
			"id"   => "badges_details",
			"name" => esc_html__('Details for badges','discy')
		);
		
		$options[] = array(
			'name'    => esc_html__('Choose the badges style','discy'),
			'desc'    => esc_html__('Choose from here the badges style.','discy'),
			'id'      => 'badges_style',
			'options' => array(
				"by_points" => esc_html__("By points","discy"),
				"by_groups" => esc_html__("By roles","discy"),
				"by_groups_points" => esc_html__("By roles and points","discy"),
				"by_questions" => esc_html__("By questions","discy"),
				"by_answers" => esc_html__("By answers","discy")
			),
			'std'     => 'by_points',
			'type'    => 'select'
		);
		
		$badge_elements = array(
			array(
				"type" => "text",
				"id"   => "badge_name",
				"name" => esc_html__('Badge name','discy')
			),
			array(
				"type" => "text",
				"id"   => "badge_points",
				"name" => esc_html__('Points','discy')
			),
			array(
				"type" => "color",
				"id"   => "badge_color",
				"name" => esc_html__('Color','discy')
			),
			array(
				"type" => "textarea",
				"id"   => "badge_details",
				"name" => esc_html__('Details','discy')
			)
		);
		
		$options[] = array(
			'id'        => "badges",
			'type'      => "elements",
			'sort'      => "no",
			'hide'      => "yes",
			'button'    => esc_html__('Add a new badge','discy'),
			'options'   => $badge_elements,
			'condition' => 'badges_style:is(by_points)',
		);
		
		$badge_elements = array(
			array(
				"type" => "text",
				"id"   => "badge_name",
				"name" => esc_html__('Badge name','discy')
			),
			array(
				"type" => "text",
				"id"   => "badge_questions",
				"name" => esc_html__('Questions','discy')
			),
			array(
				"type" => "color",
				"id"   => "badge_color",
				"name" => esc_html__('Color','discy')
			),
			array(
				"type" => "textarea",
				"id"   => "badge_details",
				"name" => esc_html__('Details','discy')
			)
		);
		
		$options[] = array(
			'id'        => "badges_questions",
			'type'      => "elements",
			'sort'      => "no",
			'hide'      => "yes",
			'button'    => esc_html__('Add a new badge','discy'),
			'options'   => $badge_elements,
			'condition' => 'badges_style:is(by_questions)',
		);
		
		$badge_elements = array(
			array(
				"type" => "text",
				"id"   => "badge_name",
				"name" => esc_html__('Badge name','discy')
			),
			array(
				"type" => "text",
				"id"   => "badge_answers",
				"name" => esc_html__('Answers','discy')
			),
			array(
				"type" => "color",
				"id"   => "badge_color",
				"name" => esc_html__('Color','discy')
			),
			array(
				"type" => "textarea",
				"id"   => "badge_details",
				"name" => esc_html__('Details','discy')
			)
		);
		
		$options[] = array(
			'id'        => "badges_answers",
			'type'      => "elements",
			'sort'      => "no",
			'hide'      => "yes",
			'button'    => esc_html__('Add a new badge','discy'),
			'options'   => $badge_elements,
			'condition' => 'badges_style:is(by_answers)',
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'badges_style:is(by_groups)',
			'type'      => 'heading-2'
		);
		
		$badges_roles = $new_roles;
		unset($badges_roles["activation"]);
		unset($badges_roles["wpqa_under_review"]);
		unset($badges_roles["ban_group"]);
		
		$badge_elements = array(
			array(
				"type"    => "select",
				"id"      => "badge_name",
				"options" => $badges_roles,
				"name"    => esc_html__('Badge name','discy')
			),
			array(
				"type" => "color",
				"id"   => "badge_color",
				"name" => esc_html__('Color','discy')
			),
		);
		
		$options[] = array(
			'id'      => "badges_groups",
			'type'    => "elements",
			'sort'    => "no",
			'hide'    => "yes",
			'button'  => esc_html__('Add a new badge','discy'),
			'options' => $badge_elements,
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'badges_style:is(by_groups_points)',
			'type'      => 'heading-2'
		);
		
		$badge_elements = array(
			array(
				"type"    => "text",
				"id"      => "badge_name",
				"name"    => esc_html__('Badge name','discy')
			),
			array(
				"type"    => "select",
				"id"      => "badge_group",
				"options" => $badges_roles,
				"name"    => esc_html__('Badge role','discy')
			),
			array(
				"type" => "text",
				"id"   => "badge_points",
				"name" => esc_html__('Points','discy')
			),
			array(
				"type" => "color",
				"id"   => "badge_color",
				"name" => esc_html__('Color','discy')
			),
			array(
				"type" => "textarea",
				"id"   => "badge_details",
				"name" => esc_html__('Details','discy')
			)
		);
		
		$options[] = array(
			'id'      => "badges_groups_points",
			'type'    => "elements",
			'sort'    => "no",
			'hide'    => "yes",
			'button'  => esc_html__('Add a new badge','discy'),
			'options' => $badge_elements,
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'id'   => 'points',
			'name' => esc_html__('Point settings','discy')
		);
		
		$options[] = array(
			'name'      => esc_html__('You must activate the points at your site to see the options from "Question settings/General settings".','discy'),
			'type'      => 'info',
			'condition' => 'active_points:not(on)'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_points:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			"type" => "textarea",
			"id"   => "points_details",
			"name" => esc_html__('Details for points','discy')
		);
		
		$options[] = array(
			'name' => esc_html__('Points for ask a new question (put it 0 for off the option)','discy'),
			'desc' => esc_html__('put the points choose for ask a new question','discy'),
			'id'   => 'point_add_question',
			'type' => 'text',
			'std'  => 0
		);
		
		$options[] = array(
			'name' => esc_html__('Points for add a new post (put it 0 for off the option)','discy'),
			'desc' => esc_html__('put the points choose for add a new post','discy'),
			'id'   => 'point_add_post',
			'type' => 'text',
			'std'  => 0
		);
		
		$options[] = array(
			'name' => esc_html__('Points for choosing the best answer','discy'),
			'desc' => esc_html__('put the points for choosing the best answer','discy'),
			'id'   => 'point_best_answer',
			'type' => 'text',
			'std'  => 5
		);
		
		$options[] = array(
			'name' => esc_html__('Points voting question','discy'),
			'desc' => esc_html__('put the points voting question','discy'),
			'id'   => 'point_voting_question',
			'type' => 'text',
			'std'  => 1
		);
		
		$options[] = array(
			'name' => esc_html__('Points add answer','discy'),
			'desc' => esc_html__('put the points add answer','discy'),
			'id'   => 'point_add_comment',
			'type' => 'text',
			'std'  => 2
		);
		
		$options[] = array(
			'name' => esc_html__('Points voting answer','discy'),
			'desc' => esc_html__('put the points voting answer','discy'),
			'id'   => 'point_voting_answer',
			'type' => 'text',
			'std'  => 1
		);
		
		$options[] = array(
			'name' => esc_html__('Points following user','discy'),
			'desc' => esc_html__('put the points following user','discy'),
			'id'   => 'point_following_me',
			'type' => 'text',
			'std'  => 1
		);
		
		$options[] = array(
			'name' => esc_html__('Points for a new user','discy'),
			'desc' => esc_html__('put the points for a new user','discy'),
			'id'   => 'point_new_user',
			'type' => 'text',
			'std'  => 20
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_referral:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Points for a new referral','discy'),
			'desc' => esc_html__('put the points for a new referral','discy'),
			'id'   => 'points_referral',
			'type' => 'text',
			'std'  => 10
		);
		
		$options[] = array(
			'name' => esc_html__('Points for a new referral for paid membership','discy'),
			'desc' => esc_html__('put the points for a new for paid membership','discy'),
			'id'   => 'referral_membership',
			'type' => 'text',
			'std'  => 20
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name'      => esc_html__('Points to add one of your each social media accounts.','discy'),
			'desc'      => esc_html__('put the points to add one of your each social media accounts','discy'),
			'id'        => 'points_social',
			'operator'  => 'or',
			'condition' => 'edit_profile_items_2:has(facebook),edit_profile_items_2:has(twitter),edit_profile_items_2:has(youtube),edit_profile_items_2:has(vimeo),edit_profile_items_2:has(linkedin),edit_profile_items_2:has(instagram),edit_profile_items_2:has(pinterest)',
			'type'      => 'text',
			'std'       => 1
		);

		$options = apply_filters('discy_options_end_of_points',$options);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);

		$options = apply_filters('discy_options_after_points_setting',$options);
			
		$options[] = array(
			'name'    => esc_html__('Comments & Answers','discy'),
			'id'      => 'comment_answer',
			'icon'    => 'admin-comments',
			'type'    => 'heading',
			'std'     => 'comments_setting',
			'options' => array(
				"comments_setting" => esc_html__('Comments','discy'),
				"answers_setting"  => esc_html__('Answers','discy')
			)
		);
		
		$options[] = array(
			'name' => esc_html__('Comment settings','discy'),
			'id'   => 'comments_setting',
			'type' => 'heading-2'
		);

		// $options[] = array(
		// 	'name'    => esc_html__("Choose the way of the sending emails and notifications","discy"),
		// 	'desc'    => esc_html__("Make the send mail to the users and send notification from the site or with schedule cron job","discy"),
		// 	'id'      => 'way_sending_notifications_comments',
		// 	'std'     => 'site',
		// 	'type'    => 'radio',
		// 	'options' => array(
		// 		"site"    => esc_html__("From the site","discy"),
		// 		"cronjob" => esc_html__("Schedule cron job","discy")
		// 	)
		// );

		// $options[] = array(
		// 	'div'       => 'div',
		// 	'condition' => 'way_sending_notifications_comments:is(cronjob)',
		// 	'type'      => 'heading-2'
		// );

		// $options[] = array(
		// 	'name'    => esc_html__('Schedule mails time','discy'),
		// 	'id'      => 'schedules_time_notification_comments',
		// 	'type'    => 'radio',
		// 	'std'     => "hourly",
		// 	'options' => array(
		// 		"daily"       => esc_html__("One time daily","discy"),
		// 		"twicedaily"  => esc_html__("Twice times daily","discy"),
		// 		"hourly"      => esc_html__("Hourly","discy"),
		// 		"twicehourly" => esc_html__("Each 30 minutes","discy")
		// 	)
		// );

		// $options[] = array(
		// 	"name"      => esc_html__("Set the hour to send the mail at this hour","discy"),
		// 	"id"        => "schedules_time_hour_notification_comment",
		// 	'condition' => 'schedules_time_notification_comments:is(daily),schedules_time_notification_comments:is(twicedaily)',
		// 	'operator'  => 'or',
		// 	"type"      => "sliderui",
		// 	'std'       => 12,
		// 	"step"      => "1",
		// 	"min"       => "1",
		// 	"max"       => "24"
		// );

		// $options[] = array(
		// 	"name" => esc_html__("Set the number of the comments you want to send on the one time","discy"),
		// 	"id"   => "schedules_number_comment",
		// 	"type" => "sliderui",
		// 	'std'  => 10,
		// 	"step" => "1",
		// 	"min"  => "1",
		// 	"max"  => "100"
		// );
		
		// $options[] = array(
		// 	'name'      => esc_html__('Note: if you choose one time daily or twice times daily we will make it visible hourly to check if there are any more comments that need to send the notifications.','discy'),
		// 	'condition' => 'schedules_time_notification_comments:is(daily),schedules_time_notification_comments:is(twicedaily)',
		// 	'operator'  => 'or',
		// 	'type'      => 'info'
		// );

		// $options[] = array(
		// 	'type' => 'heading-2',
		// 	'end'  => 'end',
		// 	'div'  => 'div'
		// );
		
		$options[] = array(
			'name' => esc_html__('Enable or disable to hide replies and show them by jQuery','discy'),
			'id'   => 'show_replies',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable to count the comments or answers only with replies or not','discy'),
			'id'   => 'count_comment_only',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Note: if you need to show the load more or infinite scroll the comments you must activate from Settings/Discussion/Break comments into pages with, and add any number, also choose the displated by default, first.','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name'    => esc_html__('Pagination style','discy'),
			'desc'    => esc_html__('Choose pagination style from here.','discy'),
			'id'      => 'comment_pagination',
			'options' => array(
				'standard'        => esc_html__('Standard','discy'),
				'pagination'      => esc_html__('Pagination','discy'),
				'load_more'       => esc_html__('Load more','discy'),
				'infinite_scroll' => esc_html__('Infinite scroll','discy'),
			),
			'std'     => 'pagination',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name'    => esc_html__('Select the share options to show at the comments/answers','discy'),
			'id'      => 'comment_share',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $share_array,
			'options' => $share_array
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the editor for details in comment form','discy'),
			'id'   => 'comment_editor',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the editor for the replies on comments/answers','discy'),
			'id'   => 'activate_editor_reply',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Add your minimum limit of the number of letters for the comment, like 15, 20, if you leave it empty it will make it not important','discy'),
			'id'   => 'comment_min_limit',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Add your limit of the number of letters for the comment, like 140, 200, if you leave it empty it will make it unlimited','discy'),
			'id'   => 'comment_limit',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate the author image in comments/answers?','discy'),
			'desc' => esc_html__('Author image in comments/answers enable or disable.','discy'),
			'id'   => 'answer_image',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate Terms of Service and privacy policy page?','discy'),
			'desc' => esc_html__('Select ON if you want active Terms of Service and privacy policy page.','discy'),
			'id'   => 'terms_active_comment',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'terms_active_comment:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Terms of Service and Privacy Policy','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Select the checked by default option','discy'),
			'desc' => esc_html__('Select ON if you want to checked it by default.','discy'),
			'id'   => 'terms_checked_comment',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'terms_active_target_comment',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Terms page','discy'),
			'desc'    => esc_html__('Select the terms page','discy'),
			'id'      => 'terms_page_comment',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the terms link if you don't like a page","discy"),
			'id'   => 'terms_link_comment',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Activate Privacy Policy','discy'),
			'desc' => esc_html__('Select ON if you want to activate Privacy Policy.','discy'),
			'id'   => 'privacy_policy_comment',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'privacy_policy_comment:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Open the page in same page or a new page?','discy'),
			'id'      => 'privacy_active_target_comment',
			'std'     => "new_page",
			'type'    => 'select',
			'options' => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
		);
		
		$options[] = array(
			'name'    => esc_html__('Privacy Policy page','discy'),
			'desc'    => esc_html__('Select the privacy policy page','discy'),
			'id'      => 'privacy_page_comment',
			'type'    => 'select',
			'options' => $options_pages
		);
		
		$options[] = array(
			'name' => esc_html__("Type the privacy policy link if you don't like a page","discy"),
			'id'   => 'privacy_link_comment',
			'type' => 'text'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Note: if you need all the comments/answers manually approved, From Settings/Discussion/Comment must be manually approved.','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name'    => esc_html__('Choose comments/answers status for unlogged user only','discy'),
			'desc'    => esc_html__('Choose comments/answers status after unlogged user publish the comments/answers.','discy'),
			'id'      => 'comment_unlogged',
			'options' => array("publish" => esc_html__("Auto publish","discy"),"draft" => esc_html__("Need a review","discy")),
			'std'     => 'draft',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name' => esc_html__('Send mail when comment/answer need a review','discy'),
			'desc' => esc_html__('Mail for comment/answer review enable or disable.','discy'),
			'id'   => 'send_email_draft_comments',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Edit comments/answers','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('User can edit the comments/answers?','discy'),
			'id'   => 'can_edit_comment',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'can_edit_comment:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			"name" => esc_html__('User can edit the comments/answers after x hours','discy'),
			"desc" => esc_html__('If you want the user to edit it all the time leave It to 0','discy'),
			"id"   => "can_edit_comment_after",
			"type" => "sliderui",
			'std'  => 1,
			"step" => "1",
			"min"  => "0",
			"max"  => "24"
		);
		
		$options[] = array(
			'name' => esc_html__('Edit comments/answers slug','discy'),
			'desc' => esc_html__('Put the edit comments/answers slug.','discy'),
			'id'   => 'edit_comments_slug',
			'std'  => 'edit-comment',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('After editing comments/answers, auto approve or need to be approved again?','discy'),
			'desc' => esc_html__('Press ON to auto approve','discy'),
			'id'   => 'comment_approved',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Delete comments/answers','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('User can delete the comments/answers?','discy'),
			'id'   => 'can_delete_comment',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('When the users delete the comments/answers send it to the trash or delete it forever?','discy'),
			'id'        => 'delete_comment',
			'options'   => array(
				'delete' => esc_html__('Delete','discy'),
				'trash'  => esc_html__('Trash','discy'),
			),
			'std'       => 'delete',
			'condition' => 'can_delete_comment:not(0)',
			'type'      => 'radio'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Answer settings','discy'),
			'id'   => 'answers_setting',
			'type' => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__("Choose the way of the sending emails and notifications","discy"),
			'desc'    => esc_html__("Make the send mail to the users and send notification from the site or with schedule cron job","discy"),
			'id'      => 'way_sending_notifications_answers',
			'std'     => 'site',
			'type'    => 'radio',
			'options' => array(
				"site"    => esc_html__("From the site","discy"),
				"cronjob" => esc_html__("Schedule cron job","discy")
			)
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'way_sending_notifications_answers:is(cronjob)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Schedule mails time','discy'),
			'id'      => 'schedules_time_notification_answers',
			'type'    => 'radio',
			'std'     => "hourly",
			'options' => array(
				"daily"       => esc_html__("One time daily","discy"),
				"twicedaily"  => esc_html__("Twice times daily","discy"),
				"hourly"      => esc_html__("Hourly","discy"),
				"twicehourly" => esc_html__("Each 30 minutes","discy")
			)
		);

		$options[] = array(
			"name"      => esc_html__("Set the hour to send the mail at this hour","discy"),
			"id"        => "schedules_time_hour_notification_answer",
			'condition' => 'schedules_time_notification_answers:is(daily),schedules_time_notification_answers:is(twicedaily)',
			'operator'  => 'or',
			"type"      => "sliderui",
			'std'       => 12,
			"step"      => "1",
			"min"       => "1",
			"max"       => "24"
		);

		$options[] = array(
			"name" => esc_html__("Set the number of the answers you want to send on the one time","discy"),
			"id"   => "schedules_number_answer",
			"type" => "sliderui",
			'std'  => 10,
			"step" => "1",
			"min"  => "1",
			"max"  => "100"
		);
		
		$options[] = array(
			'name'      => esc_html__('Note: if you choose one time daily or twice times daily we will make it visible hourly to check if there are any more answers that need to send the notifications.','discy'),
			'condition' => 'schedules_time_notification_answers:is(daily),schedules_time_notification_answers:is(twicedaily)',
			'operator'  => 'or',
			'type'      => 'info'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end',
			'div'  => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the editor for details in the answer','discy'),
			'id'   => 'answer_editor',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Allow for the user to answer one time per question','discy'),
			'id'   => 'answer_per_question',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'    => esc_html__('Answer with question title style at the answers page.','discy'),
			'desc'    => esc_html__('Choose the answers with question title style at the answers page.','discy'),
			'id'      => 'answer_question_style',
			'options' => array('style_1' => 'Style 1','style_2' => 'Style 2','style_3' => 'Style 3'),
			'std'     => 'style_1',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name' => esc_html__('Add your minimum limit for the number of letters for the answer, like 15, 20, if you leave it empty it will make it not important','discy'),
			'id'   => 'answer_min_limit',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Add your limit for the number of letters for the answer, like 140, 200, if you leave it empty it will make it unlimited','discy'),
			'id'   => 'answer_limit',
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Enable or disable the read more in the answer by jQuery','discy'),
			'id'   => 'read_more_answer',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Note: if you need to show the load more or infinite scroll the comments you must activate from Settings/Discussion/Break comments into pages with, and add any number, also choose the displated by default, first.','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name'    => esc_html__('Pagination style','discy'),
			'desc'    => esc_html__('Choose pagination style from here.','discy'),
			'id'      => 'answer_pagination',
			'options' => array(
				'standard'        => esc_html__('Standard','discy'),
				'pagination'      => esc_html__('Pagination','discy'),
				'load_more'       => esc_html__('Load more','discy'),
				'infinite_scroll' => esc_html__('Infinite scroll','discy'),
			),
			'std'     => 'pagination',
			'type'    => 'radio'
		);
		
		$answers_tabs = array(
			"votes"  => array("sort" => esc_html__('Voted','discy'),"value" => "votes"),
			"oldest" => array("sort" => esc_html__('Oldest','discy'),"value" => "oldest"),
			"recent" => array("sort" => esc_html__('Recent','discy'),"value" => "recent"),
			"random" => array("sort" => esc_html__('Random','discy'),"value" => ""),
		);
		
		$options[] = array(
			'name'    => esc_html__('Tabs at the answers','discy'),
			'desc'    => esc_html__('Select the tabs at the answers on the question page.','discy'),
			'id'      => 'answers_tabs',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => $answers_tabs,
			'options' => $answers_tabs
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to activate the vote at answers','discy'),
			'desc' => esc_html__('Select ON to enable the vote at the answers.','discy'),
			'id'   => 'active_vote_answer',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Select ON to hide the dislike at answers','discy'),
			'desc'      => esc_html__('If you put it ON the dislike will not show.','discy'),
			'id'        => 'show_dislike_answers',
			'condition' => 'active_vote_answer:not(0)',
			'type'      => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Add answer anonymously','discy'),
			'desc' => esc_html__('Select ON to enable the answer anonymously.','discy'),
			'id'   => 'answer_anonymously',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Add a private answer','discy'),
			'desc' => esc_html__('Select ON to enable the private answer.','discy'),
			'id'   => 'private_answer',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name'      => esc_html__('Activate the user who added the question to see private answer or not?','discy'),
			'desc'      => esc_html__('Select ON if you want active the user who added the question to see private answer.','discy'),
			'id'        => 'private_answer_user',
			'condition' => 'private_answer:not(0)',
			'type'      => 'checkbox'
		);

		$options[] = array(
			'name' => esc_html__('Video','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Video in the answer form','discy'),
			'desc' => esc_html__('Select ON to enable the video in the answer form.','discy'),
			'id'   => 'answer_video',
			'type' => 'checkbox'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'answer_video:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name'    => esc_html__('Video description position at answer','discy'),
			'desc'    => esc_html__('Choose the video description position.','discy'),
			'id'      => 'video_answer_position',
			'options' => array("before" => "Before content","after" => "After content"),
			'std'     => 'after',
			'type'    => 'select'
		);
		
		$options[] = array(
			'name' => esc_html__('Set the video description to 100%?','discy'),
			'desc' => esc_html__('Select ON if you want to set the video description to 100%.','discy'),
			'id'   => 'video_answer_100',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			"name"      => esc_html__("Set the width for the video description for the answer","discy"),
			"id"        => "video_answer_width",
			'condition' => 'video_answer_100:not(on)',
			"type"      => "sliderui",
			'std'       => 260,
			"step"      => "1",
			"min"       => "50",
			"max"       => "600"
		);
		
		$options[] = array(
			"name" => esc_html__("Set the height for the video description for the answer","discy"),
			"id"   => "video_answer_height",
			"type" => "sliderui",
			'std'  => 500,
			"step" => "1",
			"min"  => "50",
			"max"  => "600"
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end',
			'div'  => 'div'
		);

		$options[] = array(
			'name' => esc_html__('Attachment','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name' => esc_html__('Attachment in the answer form','discy'),
			'desc' => esc_html__('Select ON to enable the attachment in the answer form.','discy'),
			'id'   => 'attachment_answer',
			'type' => 'checkbox'
		);

		$options[] = array(
			'name' => esc_html__('Featured image','discy'),
			'type' => 'info'
		);
		
		$options[] = array(
			'name' => esc_html__('Featured image in the answer form','discy'),
			'desc' => esc_html__('Select ON to enable the featured image in the answer form.','discy'),
			'id'   => 'featured_image_answer',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'div'       => 'div',
			'condition' => 'featured_image_answer:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to show featured image in the question answers','discy'),
			'desc' => esc_html__('Select ON to enable the featured image in the question answers.','discy'),
			'id'   => 'featured_image_question_answers',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to show featured image in the answers tab, answers template, answers at profile or answers is search','discy'),
			'desc' => esc_html__('Select ON to enable the featured image in the answers.','discy'),
			'id'   => 'featured_image_in_answers',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Select ON to enable the lightbox for featured image','discy'),
			'desc' => esc_html__('Select ON to enable the lightbox for featured image.','discy'),
			'id'   => 'featured_image_answers_lightbox',
			'std'  => "on",
			'type' => 'checkbox'
		);
		
		$options[] = array(
			"name" => esc_html__("Set the width for the featured image for the answers","discy"),
			"id"   => "featured_image_answer_width",
			"type" => "sliderui",
			'std'  => 260,
			"step" => "1",
			"min"  => "50",
			"max"  => "600"
		);
		
		$options[] = array(
			"name" => esc_html__("Set the height for the featured image for the answers","discy"),
			"id"   => "featured_image_answer_height",
			"type" => "sliderui",
			'std'  => 185,
			"step" => "1",
			"min"  => "50",
			"max"  => "600"
		);
		
		$options[] = array(
			'name'    => esc_html__('Featured image position','discy'),
			'desc'    => esc_html__('Choose the featured image position.','discy'),
			'id'      => 'featured_answer_position',
			'options' => array("before" => "Before content","after" => "After content"),
			'std'     => 'before',
			'type'    => 'select'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Search Settings','discy'),
			'id'   => 'search_setting',
			'icon' => 'search',
			'type' => 'heading',
		);
		
		$options[] = array(
			'type' => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Search slug','discy'),
			'desc' => esc_html__('Put the search slug.','discy'),
			'id'   => 'search_slug',
			'std'  => 'search',
			'type' => 'text'
		);
		
		if (has_wpqa()) {
			$options[] = array(
				'name' => '<a href="'.wpqa_get_search_permalink().'" target="_blank">'.esc_html__('The Link For The Search Page.','discy').'</a>',
				'type' => 'info'
			);
		}
		
		$search_attrs = array(
			"questions"         => array("sort" => esc_html__('Questions','discy'),"value" => "questions"),
			"answers"           => array("sort" => esc_html__('Answers','discy'),"value" => "answers"),
			"question-category" => array("sort" => esc_html__('Question categories','discy'),"value" => "question-category"),
			"question_tags"     => array("sort" => esc_html__('Question tags','discy'),"value" => "question_tags"),
			"groups"            => array("sort" => esc_html__('Groups','discy'),"value" => "groups"),
			"posts"             => array("sort" => esc_html__('Posts','discy'),"value" => "posts"),
			"comments"          => array("sort" => esc_html__('Comments','discy'),"value" => "comments"),
			"category"          => array("sort" => esc_html__('Post categories','discy'),"value" => "category"),
			"post_tag"          => array("sort" => esc_html__('Post tags','discy'),"value" => "post_tag"),
			"users"             => array("sort" => esc_html__('Users','discy'),"value" => "users"),
		);
		
		$options[] = array(
			'name'    => esc_html__('Select the search options','discy'),
			'desc'    => esc_html__('Select the search options on the search page.','discy'),
			'id'      => 'search_attrs',
			'type'    => 'multicheck',
			'sort'    => 'yes',
			'std'     => apply_filters("discy_search_attrs",$search_attrs),
			'options' => apply_filters("discy_search_attrs",$search_attrs)
		);
		
		$options[] = array(
			'name'    => esc_html__('Default search','discy'),
			'desc'    => esc_html__("Choose what's the default search","discy"),
			'id'      => 'default_search',
			'type'    => 'select',
			'stc'     => 'questions',
			'options' => array(
				"questions"         => esc_html__("Questions","discy"),
				"answers"           => esc_html__("Answers","discy"),
				"question-category" => esc_html__("Question categories","discy"),
				"question_tags"     => esc_html__("Question tags","discy"),
				"groups"            => esc_html__("Groups","discy"),
				"posts"             => esc_html__("Posts","discy"),
				"comments"          => esc_html__("Comments","discy"),
				"category"          => esc_html__("Post categories","discy"),
				"post_tag"          => esc_html__("Post tags","discy"),
				"users"             => esc_html__("Users","discy"),
			)
		);

		$options[] = array(
			'name' => esc_html__("Choose the live search enable or disable","discy"),
			'id'   => "live_search",
			'type' => "checkbox",
			'std'  => "on",
		);

		$options[] = array(
			'name' => esc_html__("Include the asked questions on the search or not","discy"),
			'id'   => "asked_questions_search",
			'type' => "checkbox",
		);

		$options[] = array(
			'name'      => esc_html__('Search result number','discy'),
			'desc'      => esc_html__('Type the search result number from here.','discy'),
			'id'        => 'search_result_number',
			'condition' => 'live_search:not(0)',
			'std'       => '5',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name'    => esc_html__('Tags style at search page','discy'),
			'desc'    => esc_html__('Choose the tags style.','discy'),
			'id'      => 'tag_style_pages',
			'options' => array(
				'simple_follow' => esc_html__('Simple with follow','discy'),
				'advanced'      => esc_html__('Advanced','discy'),
				'simple'        => esc_html__('Simple','discy'),
			),
			'std'     => 'simple_follow',
			'type'    => 'radio'
		);
		
		$options[] = array(
			'name' => esc_html__('Show the user filter at search page.','discy'),
			'id'   => 'user_filter',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Show the category search at category pages.','discy'),
			'id'   => 'cat_search',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__('Show the tag search at tag pages.','discy'),
			'id'   => 'tag_search',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
	}
	
	$options[] = array(
		'name' => esc_html__('Sidebar','discy'),
		'id'   => 'sidebar',
		'icon' => 'align-none',
		'type' => 'heading'
	);
	
	$options[] = array(
		'type' => 'heading-2'
	);
	
	$sidebar_elements = array(
		array(
			"type" => "text",
			"id"   => "name",
			"name" => esc_html__('Sidebar name','discy')
		),
	);
	
	$options[] = array(
		'id'      => "sidebars",
		'type'    => "elements",
		'sort'    => "no",
		'button'  => esc_html__('Add a new sidebar','discy'),
		'options' => $sidebar_elements,
	);
	
	$options[] = array(
		'name'    => esc_html__('Sidebar layout','discy'),
		'id'      => "sidebar_layout",
		'std'     => "menu_sidebar",
		'type'    => "images",
		'options' => array(
			'menu_sidebar' => $imagepath.'menu_sidebar.jpg',
			'right'        => $imagepath.'sidebar_right.jpg',
			'full'         => $imagepath.'sidebar_no.jpg',
			'left'         => $imagepath.'sidebar_left.jpg',
			'centered'     => $imagepath.'centered.jpg',
			'menu_left'    => $imagepath.'menu_left.jpg',
		)
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'sidebar_layout:not(full),sidebar_layout:not(centered),sidebar_layout:not(menu_left)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Sidebar','discy'),
		'id'      => "sidebar_home",
		'options' => $new_sidebars,
		'type'    => 'select'
	);
	
	$options[] = array(
		'name'    => esc_html__('Sticky sidebar','discy'),
		'id'      => 'sticky_sidebar',
		'std'     => 'side_menu_bar',
		'type'    => 'select',
		'options' => array(
			'sidebar'       => esc_html__('Sidebar','discy'),
			'nav_menu'      => esc_html__('Side menu (If enabled)','discy'),
			'side_menu_bar' => esc_html__('Sidebar & Side menu (If enabled)','discy'),
			'no_sidebar'    => esc_html__('Not active','discy'),
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Widget icons enable or disable','discy'),
		'id'   => 'widget_icons',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'div'       => 'div',
		'operator'  => 'or',
		'condition' => 'sidebar_layout:is(menu_sidebar),sidebar_layout:is(menu_left)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Sidemenu style','discy'),
		'id'      => 'left_area',
		'std'     => 'menu',
		'type'    => 'radio',
		'options' => 
			array(
				"menu"    => esc_html__("Menu","discy"),
				"sidebar" => esc_html__("Sidebar","discy")
			)
	);
	
	$options[] = array(
		'name'      => esc_html__('Choose the left menu style','discy'),
		'id'        => "left_menu_style",
		'options'   => array('style_1' => 'Style 1','style_2' => 'Style 2','style_3' => 'Style 3'),
		'type'      => 'select',
		'condition' => 'left_area:not(sidebar)',
	);
	
	$options[] = array(
		'name'      => esc_html__('Sidebar 2','discy'),
		'id'        => "sidebar_home_2",
		'options'   => $new_sidebars,
		'type'      => 'select',
		'condition' => 'left_area:is(sidebar)',
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name'    => esc_html__('Styling & Typography','discy'),
		'id'      => 'styling',
		'icon'    => 'art',
		'type'    => 'heading',
		'std'     => 'styling',
		'options' => array(
			"styling"    => esc_html__('Styling','discy'),
			"typography" => esc_html__('Typography','discy')
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Styling','discy'),
		'id'   => 'styling',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Choose the site width','discy'),
		"id"   => "site_width",
		"type" => "sliderui",
		"std"  => "1170",
		"step" => "10",
		"min"  => "1170",
		"max"  => "1300"
	);

	$options[] = array(
		'name' => esc_html__('Discoura style','discy'),
		'desc' => esc_html__('Select ON to activate the Discoura style','discy'),
		'id'   => 'discoura_style',
		'type' => 'checkbox',
	);
	
	$options[] = array(
		'name'    => esc_html__('Site style','discy'),
		'id'      => 'site_style',
		'std'     => 'none',
		'type'    => 'radio',
		'options' => 
			array(
				"none"    => esc_html__("Normal style","discy"),
				"style_1" => esc_html__("Boxed style 1","discy"),
				"style_2" => esc_html__("Boxed style 2","discy"),
				"style_3" => esc_html__("Boxed style 3 - without left menu","discy"),
				"style_4" => esc_html__("Boxed style 4 - without left menu","discy"),
			)
	);
	
	$options[] = array(
		'name'    => esc_html__('Choose Your Skin','discy'),
		'class'   => "site_skin",
		'id'      => "site_skin",
		'std'     => "default",
		'type'    => "images",
		'options' => array(
			'default'    => $imagepath.'default.jpg',
			'violet'     => $imagepath.'violet.jpg',
			'bright_red' => $imagepath.'bright_red.jpg',
			'green'      => $imagepath.'green.jpg',
			'red'        => $imagepath.'red.jpg',
			'cyan'       => $imagepath.'cyan.jpg',
			'blue'       => $imagepath.'blue.jpg',
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Primary Color','discy'),
		'id'   => 'primary_color',
		'type' => 'color'
	);
	
	$options[] = array(
		'name'    => esc_html__('Background Type','discy'),
		'id'      => 'background_type',
		'std'     => 'none',
		'type'    => 'radio',
		'options' => 
			array(
				"none"              => esc_html__("None","discy"),
				"patterns"          => esc_html__("Patterns","discy"),
				"custom_background" => esc_html__("Custom Background","discy")
			)
	);
	
	$options[] = array(
		'name'      => esc_html__('Background Color','discy'),
		'id'        => 'background_color',
		'type'      => 'color',
		'condition' => 'background_type:is(patterns)'
	);
		
	$options[] = array(
		'name'      => esc_html__('Choose Pattern','discy'),
		'id'        => "background_pattern",
		'std'       => "bg13",
		'type'      => "images",
		'condition' => 'background_type:is(patterns)',
		'class'     => "pattern_images",
		'options'   => array(
			'bg1'  => $imagepath.'bg1.jpg',
			'bg2'  => $imagepath.'bg2.jpg',
			'bg3'  => $imagepath.'bg3.jpg',
			'bg4'  => $imagepath.'bg4.jpg',
			'bg5'  => $imagepath.'bg5.jpg',
			'bg6'  => $imagepath.'bg6.jpg',
			'bg7'  => $imagepath.'bg7.jpg',
			'bg8'  => $imagepath.'bg8.jpg',
			'bg9'  => $imagepath_theme.'patterns/bg9.png',
			'bg10' => $imagepath_theme.'patterns/bg10.png',
			'bg11' => $imagepath_theme.'patterns/bg11.png',
			'bg12' => $imagepath_theme.'patterns/bg12.png',
			'bg13' => $imagepath.'bg13.jpg',
			'bg14' => $imagepath.'bg14.jpg',
			'bg15' => $imagepath_theme.'patterns/bg15.png',
			'bg16' => $imagepath_theme.'patterns/bg16.png',
			'bg17' => $imagepath.'bg17.jpg',
			'bg18' => $imagepath.'bg18.jpg',
			'bg19' => $imagepath.'bg19.jpg',
			'bg20' => $imagepath.'bg20.jpg',
			'bg21' => $imagepath_theme.'patterns/bg21.png',
			'bg22' => $imagepath.'bg22.jpg',
			'bg23' => $imagepath_theme.'patterns/bg23.png',
			'bg24' => $imagepath_theme.'patterns/bg24.png',
		)
	);
	
	$options[] = array(
		'name'      => esc_html__('Custom Background','discy'),
		'id'        => 'custom_background',
		'std'       => $background_defaults,
		'type'      => 'background',
		'options'   => $background_defaults,
		'condition' => 'background_type:is(custom_background)'
	);
	
	$options[] = array(
		'name'      => esc_html__('Full Screen Background','discy'),
		'desc'      => esc_html__('Select ON to enable Full Screen Background','discy'),
		'id'        => 'full_screen_background',
		'type'      => 'checkbox',
		'condition' => 'background_type:is(custom_background)'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Typography','discy'),
		'id'   => 'typography',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		"name"    => esc_html__('Main font','discy'),
		"id"      => "main_font",
		"type"    => "typography",
		'std'     => array("face" => "Default font","color" => "","style" => "","size" => 9),
		'options' => array("color" => false,"styles" => false,"sizes" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('Second font','discy'),
		"id"      => "second_font",
		"type"    => "typography",
		'std'     => array("face" => "Default font","color" => "","style" => "","size" => 9),
		'options' => array("color" => false,"styles" => false,"sizes" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('General Typography','discy'),
		"id"      => "general_typography",
		"type"    => "typography",
		'options' => array('faces' => false)
	);
	
	$options[] = array(
		'name' => esc_html__('General link color','discy'),
		"id"   => "general_link_color",
		"type" => "color"
	);
	
	$options[] = array(
		"name"    => esc_html__('H1','discy'),
		"id"      => "h1",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('H2','discy'),
		"id"      => "h2",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('H3','discy'),
		"id"      => "h3",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('H4','discy'),
		"id"      => "h4",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('H5','discy'),
		"id"      => "h5",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		"name"    => esc_html__('H6','discy'),
		"id"      => "h6",
		"type"    => "typography",
		'options' => array('faces' => false,"color" => false)
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name'    => esc_html__('Social Settings','discy'),
		'id'      => 'social',
		'icon'    => 'share',
		'type'    => 'heading',
		'std'     => 'social',
		'options' => array(
			"social"          => esc_html__('Social Setting','discy'),
			"add_sort_social" => esc_html__('Add & sort social','discy'),
			"social_api"      => esc_html__('Social media API','discy')
		)
	);
	
	$options[] = array(
		'name' => esc_html__('Social Setting','discy'),
		'id'   => 'social',
		'type' => 'heading-2'
	);
	
	$social = array(
		array('name' => esc_html__('Facebook','discy'),"value" => "facebook","icon" => "facebook","default" => "yes"),
		array('name' => esc_html__('Twitter','discy'),"value" => "twitter","icon" => "twitter","default" => "yes"),
		array('name' => esc_html__('Linkedin','discy'),"value" => "linkedin","icon" => "linkedin","default" => "yes"),
		array('name' => esc_html__('Dribbble','discy'),"value" => "dribbble","icon" => "dribbble","default" => "yes"),
		array('name' => esc_html__('Youtube','discy'),"value" => "youtube","icon" => "play","default" => "yes"),
		array('name' => esc_html__('Vimeo','discy'),"value" => "vimeo","icon" => "vimeo","default" => "yes"),
		array('name' => esc_html__('Skype','discy'),"value" => "skype","icon" => "skype","default" => "yes"),
		//array('name' => esc_html__('Flickr','discy'),"value" => "flickr","icon" => "flickr","default" => "yes"),
		//array('name' => esc_html__('Soundcloud','discy'),"value" => "soundcloud","icon" => "soundcloud","default" => "yes"),
		array('name' => esc_html__('Instagram','discy'),"value" => "instagram","icon" => "instagram","default" => "yes"),
		array('name' => esc_html__('Pinterest','discy'),"value" => "pinterest","icon" => "pinterest","default" => "yes"),
		array('name' => esc_html__('Rss','discy'),"value" => "rss","icon" => "rss","default" => "yes")
	);
	
	foreach ($social as $key => $value) {
		if ($value["value"] != "rss") {
			$options[] = array(
				'name' => sprintf(esc_html__('%s URL','discy'),esc_html($value["name"])),
				'desc' => sprintf('Type the %s URL from here.',esc_html($value["name"])),
				'id'   => $value["value"].'_icon_h',
				'std'  => '#',
				'type' => 'text'
			);
		}else {
			$options[] = array(
				'name' => esc_html__('Rss enable or disable','discy'),
				'id'   => 'rss_icon_h',
				'std'  => 'on',
				'type' => 'checkbox'
			);
			
			$options[] = array(
				'name'      => esc_html__('RSS URL if you want change the default URL','discy'),
				'desc'      => esc_html__('Type the RSS URL if you want change the default URL or leave it empty to enable the default URL.','discy'),
				'id'        => 'rss_icon_h_other',
				'condition' => 'rss_icon_h:not(0)',
				'type'      => 'text'
			);
		}
	}
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Add a new social item','discy'),
		'id'   => 'add_sort_social',
		'type' => 'heading-2'
	);
	
	$elements = array(
		array(
			"type" => "text",
			"id"   => "name",
			"name" => esc_html__('Name','discy')
		),
		array(
			"type" => "text",
			"id"   => "url",
			"name" => esc_html__('URL','discy')
		),
		array(
			"type" => "text",
			"id"   => "icon",
			"name" => sprintf(esc_html__('Icon (use %1$s entypo %2$s like: facebook)','discy'),'<a href="https://2code.info/demo/themes/Discy/entypo/" target="_blank">','</a>')
		)
	);
	
	$options[] = array(
		'id'      => "add_social",
		'type'    => "elements",
		'button'  => esc_html__('Add Custom Social','discy'),
		'options' => $elements,
		'title'   => "name",
		'addto'   => "sort_social"
	);
	
	$options[] = array(
		'id'      => "sort_social",
		'std'     => $social,
		'type'    => "sort",
		'options' => $social,
		'delete'  => "yes",
		'getthe'  => $elements
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Social media API','discy'),
		'id'   => 'social_api',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Facebook app id.','discy'),
		'id'   => 'facebook_app_id',
		'type' => 'text'
	);
	
	// $options[] = array(
	// 	'name' => esc_html__('Soundcloud client id.','discy'),
	// 	'desc' => esc_html__('Type here the Soundcloud client id.','discy'),
	// 	'id'   => 'soundcloud_client_id',
	// 	'type' => 'text'
	// );
	
	$options[] = array(
		'name' => esc_html__('Behance access token.','discy'),
		'desc' => esc_html__('Type here the Behance access token.','discy'),
		'id'   => 'behance_api_key',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Google API.','discy'),
		'desc' => esc_html__('Type here the Google API.','discy'),
		'id'   => 'google_api',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Instagram session.','discy'),
		'desc' => esc_html__('Type here the Instagram session.','discy'),
		'id'   => 'instagram_sessionid',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => sprintf(esc_html__('Dribbble app data (Make app from: https://dribbble.com/account/applications/new), At Callback URL add %1$s this link %2$s','discy'),'<a href="'.admin_url('admin.php?page=options&api=dribbble').'">','</a>'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('Dribbble Client ID.','discy'),
		'id'   => 'dribbble_client_id',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Dribbble Client Secret.','discy'),
		'id'   => 'dribbble_client_secret',
		'type' => 'text'
	);
	
	$dribbble_client_id = discy_options('dribbble_client_id');
	$options[] = array(
		'name' => '<a href="https://dribbble.com/oauth/authorize?client_id='.$dribbble_client_id.'" target="_blank">'.esc_html__('Get the access token from here.','discy').'</a>',
		'type' => 'info'
	);
	
	$options[] = array(
		'id'   => 'dribbble_access_token',
		'type' => 'hidden'
	);
	
	$options[] = array(
		'name' => esc_html__('Twitter app data.','discy'),
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('Twitter consumer key','discy'),
		'id'   => 'twitter_consumer_key',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Twitter consumer secret','discy'),
		'id'   => 'twitter_consumer_secret',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Envato token.','discy'),
		'type' => 'info'
	);

	$options[] = array(
		'name' => esc_html__('Envato token','discy'),
		'id'   => 'envato_token',
		'type' => 'text'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising','discy'),
		'id'   => 'advertising',
		'icon' => 'admin-post',
		'type' => 'heading'
	);
	
	$options[] = array(
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising at 404 pages enable or disable','discy'),
		'id'   => 'adv_404',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Do you need to show the advertising on custom pages?','discy'),
		'id'   => 'custom_ads_show',
		'type' => 'checkbox'
	);

	$options[] = array(
		'type'      => 'heading-2',
		'condition' => 'custom_ads_show:not(0)',
		'div'       => 'div'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising work on?','discy'),
		'id'      => 'adv_work_on',
		'std'     => 'custom_image',
		'type'    => 'multicheck',
		'options' => array(
			'home'          => esc_html__('Home page','discy'),
			'pages'         => esc_html__('Pages','discy'),
			'posts'         => esc_html__('Posts','discy'),
			'questions'     => esc_html__('Questions','discy'),
			'groups'        => esc_html__('Groups','discy'),
			'post_type'     => esc_html__('All other custom post types','discy'),
			'q_categories'  => esc_html__('Question Categories','discy'),
			'q_tags'        => esc_html__('Question Tags','discy'),
			'categories'    => esc_html__('Post Categories','discy'),
			'tags'          => esc_html__('Post Tags','discy'),
			'main_profile'  => esc_html__('Main profile page','discy'),
			'other_profile' => esc_html__('Other profile pages','discy'),
		),
		'std'     => array('home' => 'home','posts' => 'posts','questions' => 'questions','pages' => 'pages','groups' => 'groups','post_type' => 'post_type','q_categories' => 'q_categories','q_tags' => 'q_tags','categories' => 'categories','tags' => 'tags','main_profile' => 'main_profile'),
	);

	$options[] = array(
		'name' => esc_html__('Put here the exclude pages, questions, posts, and groups ids','discy'),
		'id'   => 'ads_exclude_pages',
		'type' => 'text'
	);

	$options[] = array(
		'name' => esc_html__('Put here the exclude question categories, post categories, question tag, and post tags ids','discy'),
		'id'   => 'ads_exclude_taxes',
		'type' => 'text'
	);

	$options[] = array(
		'name' => esc_html__('Put here the exclude user ids','discy'),
		'id'   => 'ads_exclude_users',
		'type' => 'text'
	);

	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising after header','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'header_adv_type_1',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'header_adv_img_1',
		'condition' => 'header_adv_type_1:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'header_adv_href_1',
		'std'       => '#',
		'condition' => 'header_adv_type_1:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'header_adv_link_1',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'header_adv_type_1:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'header_adv_code_1',
		'condition' => 'header_adv_type_1:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising in post or question','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'share_adv_type',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'share_adv_img',
		'condition' => 'share_adv_type:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'share_adv_href',
		'std'       => '#',
		'condition' => 'share_adv_type:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'share_adv_link',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'share_adv_type:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'share_adv_code',
		'condition' => 'share_adv_type:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising after left menu','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'left_menu_adv_type',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'left_menu_adv_img',
		'condition' => 'left_menu_adv_type:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'left_menu_adv_href',
		'std'       => '#',
		'condition' => 'left_menu_adv_type:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'left_menu_adv_link',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'left_menu_adv_type:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'left_menu_adv_code',
		'condition' => 'left_menu_adv_type:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advertising after content','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'content_adv_type',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'content_adv_img',
		'condition' => 'content_adv_type:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'content_adv_href',
		'std'       => '#',
		'condition' => 'content_adv_type:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'content_adv_link',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'content_adv_type:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'content_adv_code',
		'condition' => 'content_adv_type:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Between questions or posts','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Display after x posts or questions','discy'),
		'id'   => 'between_questions_position',
		'std'  => '2',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Repeat adv?','discy'),
		'desc' => esc_html__('Select ON to enable repeat advertising.','discy'),
		'id'   => 'between_adv_type_repeat',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'between_adv_type',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'between_adv_img',
		'condition' => 'between_adv_type:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'between_adv_href',
		'std'       => '#',
		'condition' => 'between_adv_type:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'between_adv_link',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'between_adv_type:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'between_adv_code',
		'condition' => 'between_adv_type:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Between comments or answers','discy'),
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Display after x comments or answers','discy'),
		'id'   => 'between_comments_position',
		'std'  => '2',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Repeat adv?','discy'),
		'desc' => esc_html__('Select ON to enable repeat advertising.','discy'),
		'id'   => 'between_comments_adv_type_repeat',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name'    => esc_html__('Advertising type','discy'),
		'id'      => 'between_comments_adv_type',
		'std'     => 'custom_image',
		'type'    => 'radio',
		'options' => array("display_code" => esc_html__("Display code","discy"),"custom_image" => esc_html__("Custom Image","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Image URL','discy'),
		'desc'      => esc_html__('Upload a image, or enter URL to an image if it is already uploaded.','discy'),
		'id'        => 'between_comments_adv_img',
		'condition' => 'between_comments_adv_type:is(custom_image)',
		'type'      => 'upload'
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising URL','discy'),
		'id'        => 'between_comments_adv_href',
		'std'       => '#',
		'condition' => 'between_comments_adv_type:is(custom_image)',
		'type'      => 'text'
	);

	$options[] = array(
		'name'      => esc_html__('Open the page in same page or a new page?','discy'),
		'id'        => 'between_comments_adv_link',
		'std'       => "new_page",
		'type'      => 'select',
		'condition' => 'between_comments_adv_type:is(custom_image)',
		'options'   => array("same_page" => esc_html__("Same page","discy"),"new_page" => esc_html__("New page","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Advertising Code html (Ex: Google ads)','discy'),
		'id'        => 'between_comments_adv_code',
		'condition' => 'between_comments_adv_type:not(custom_image)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	if (has_wpqa() && wpqa_plugin_version < '4.8') {
		$email_settings = array(
			"general_mail"   => esc_html__('General setting','discy'),
			"users_mails"    => esc_html__('Users mails','discy'),
			"payments_mails" => esc_html__('Payments mails','discy'),
			"posts_mails"    => esc_html__('Posts and questions mails','discy'),
			"groups_mails"   => esc_html__('Groups mails','discy'),
			"comments_mails" => esc_html__('Comments mails','discy'),
			"other_mails"    => esc_html__('Other mails','discy'),
		);

		$options[] = array(
			'name'    => esc_html__('Mail settings','discy'),
			'id'      => 'mails_settings',
			'type'    => 'heading',
			'icon'    => 'email',
			'std'     => 'general_mail',
			'options' => $email_settings
		);
		
		$options[] = array(
			'name' => esc_html__('General setting','discy'),
			'id'   => 'general_mail',
			'type' => 'heading-2'
		);

		$options[] = array(
			'name'    => esc_html__('Email template style','discy'),
			'id'      => 'email_style',
			'std'     => 'style_1',
			'type'    => 'radio',
			'options' => array("style_1" => "Style 1","style_2" => "Style 2")
		);
		
		$options[] = array(
			'name' => esc_html__("Custom logo for mail template","discy"),
			'desc' => esc_html__("Upload your custom logo for mail template","discy"),
			'id'   => 'logo_email_template',
			'std'  => $imagepath_theme."logo.png",
			'type' => 'upload'
		);
		
		$options[] = array(
			'name'      => esc_html__('Background Color for the mail template','discy'),
			'id'        => 'background_email',
			'condition' => 'email_style:not(style_2)',
			'type'      => 'color',
			'std'       => '#272930'
		);

		$options[] = array(
			'name' => esc_html__('SMTP mail enable or disable','discy'),
			'id'   => 'mail_smtp',
			'type' => 'checkbox'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'mail_smtp:not(0)',
			'div'       => 'div'
		);

		$options[] = array(
			'name' => esc_html__('SMTP mail host','discy'),
			'id'   => 'mail_host',
			'type' => 'text',
		);

		$options[] = array(
			'name' => esc_html__('SMTP mail port','discy'),
			'id'   => 'mail_port',
			'type' => 'text',
		);

		$options[] = array(
			'name' => esc_html__('SMTP mail username','discy'),
			'id'   => 'mail_username',
			'type' => 'text',
		);

		$options[] = array(
			'name' => esc_html__('SMTP mail password','discy'),
			'id'   => 'mail_password',
			'type' => 'password',
		);

		$options[] = array(
			'name'    => esc_html__('SMTP mail secure','discy'),
			'id'      => 'mail_secure',
			'std'     => 'ssl',
			'type'    => 'radio',
			'options' => array("ssl" => "SSL","tls" => "TLS","none" => esc_html__("No Encryption","discy"))
		);
		
		$options[] = array(
			'name'  => esc_html__('SMTP Authentication','discy'),
			'id'    => 'smtp_auth',
			'std'   => 'on',
			'type'  => 'checkbox'
		);
		
		$options[] = array(
			'name'  => esc_html__('Disable SSL Certificate Verification','discy'),
			'id'    => 'disable_ssl',
			'type'  => 'checkbox'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'mail_smtp:not(on)',
			'div'       => 'div'
		);

		$parse = parse_url(get_site_url());
		
		$options[] = array(
			'name' => esc_html__("Add your email for mail template","discy"),
			'desc' => esc_html__("Add it professional email, like no_reply@2code.info","discy"),
			'id'   => 'email_template',
			'std'  => "no_reply@".$parse['host'],
			'type' => 'text'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__("Add your email to receive the different mails","discy"),
			'id'   => 'email_template_to',
			'std'  => get_bloginfo("admin_email"),
			'type' => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Mail footer enable or disable','discy'),
			'id'   => 'active_footer_email',
			'std'  => 'on',
			'type' => 'checkbox'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'active_footer_email:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Social for the mail in the footer enable or disable','discy'),
			'id'   => 'social_footer_email',
			'std'  => 'on',
			'type' => 'checkbox'
		);
		
		$options[] = array(
			'name' => esc_html__("Add your copyrights for your mail templates","discy"),
			'id'   => 'copyrights_for_email',
			'std'  => '&copy; '.date('Y').' Discy. All Rights Reserved<br>With Love by <a href="https://2code.info/" target="_blank">2code</a>.',
			'type' => 'textarea'
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at the all templates</h4>
			<p>[%blogname%] - The site title.</p>
			<p>[%site_url%] - The site URL.</p>
			<p>[%messages_url%] - The messages URL page.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work for the custom email template only</h4>
			<p>[%user_login%] - The user login name.</p>
			<p>[%user_name%] - The user name.</p>
			<p>[%user_nicename%] - The user nice name.</p>
			<p>[%display_name%] - The user display name.</p>
			<p>[%user_email%] - The user email.</p>
			<p>[%user_profile%] - The user profile URL.</p>',
		);
		
		$roles_user_only = $new_roles;
		unset($roles_user_only["wpqa_under_review"]);
		unset($roles_user_only["ban_group"]);
		unset($roles_user_only["activation"]);
		
		$options[] = array(
			'name'    => esc_html__('Choose the roles or users for the custom mail','discy'),
			'desc'    => esc_html__('Choose from here which roles or users you want to send the custom mail.','discy'),
			'id'      => 'mail_groups_users',
			'options' => array(
				'groups' => esc_html__('Roles','discy'),
				'users'  => esc_html__('Users','discy'),
			),
			'std'     => 'groups',
			'type'    => 'radio'
		);

		$options[] = array(
			'name'      => esc_html__("Choose the roles you need to send the custom mail for them.","discy"),
			'id'        => 'custom_mail_groups',
			'condition' => 'mail_groups_users:not(users)',
			'type'      => 'multicheck',
			'options'   => $new_roles,
			'std'       => array('administrator' => 'administrator','editor' => 'editor','contributor' => 'contributor','subscriber' => 'subscriber','author' => 'author'),
		);

		$options[] = array(
			'name'      => esc_html__('Specific user ids','discy'),
			'id'        => 'mail_specific_users',
			'condition' => 'mail_groups_users:is(users)',
			'type'      => 'text'
		);
		
		$options[] = array(
			'name' => esc_html__('Custom image for the custom mail','discy'),
			'id'   => 'custom_image_mail',
			'type' => 'upload'
		);

		$options[] = array(
			'name' => esc_html__('Custom mail title','discy'),
			'id'   => 'title_custom_mail',
			'std'  => 'Welcome',
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Custom mail template','discy'),
			'id'       => 'email_custom_mail',
			'std'      => "<p>Hi [%display_name%]</p><p>Welcome to our site.</p><p>[%blogname%]</p><p><a href='[%site_url%]'>[%site_url%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'name' => esc_html__('You must save your options before send the message.','discy'),
			'type' => 'info'
		);

		$options[] = array(
			'name' => '<a href="#" class="button button-primary send-custom-mail">'.esc_html__('Send the custom mail','discy').'</a>',
			'type' => 'info'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Users mails','discy'),
			'id'   => 'users_mails',
			'type' => 'heading-2'
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work for all next templates</h4>
			<p>[%user_login%] - The user login name.</p>
			<p>[%user_name%] - The user name.</p>
			<p>[%user_nicename%] - The user nice name.</p>
			<p>[%display_name%] - The user display name.</p>
			<p>[%user_email%] - The user email.</p>
			<p>[%user_profile%] - The user profile URL.</p>
			<p>[%display_name_sender%] - The user display name.</p>
			<p>[%user_profile_sender%] - The user profile URL.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variable works at Reset password and Confirm mail</h4>
			<p>[%confirm_link_email%] - Confirm mail for the user to reset the password at reset password template and at the confirm mail template is confirm mail to active the user.</p>',
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'confirm_email:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Confirm mail title','discy'),
			'id'   => 'title_confirm_link',
			'std'  => "Confirm account",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Confirm mail template','discy'),
			'id'       => 'email_confirm_link',
			'std'      => "<p>Hi there</p><p>Your registration has been successful! To confirm your account, kindly click on 'Activate' below.</p><p><a href='[%confirm_link_email%]'>Activate</a></p><p>If the link above does not work, Please use your browser to go to:</p>[%confirm_link_email%]</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'name' => esc_html__('Confirm mail 2 title','discy'),
			'id'   => 'title_confirm_link_2',
			'std'  => "Confirm account",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Confirm mail 2 template','discy'),
			'id'       => 'email_confirm_link_2',
			'std'      => "<p>Hi there</p><p>This is the link to activate your membership</p><p><a href='[%confirm_link_email%]'>Activate</a></p><p>If the link above does not work, Please use your browser to go to:</p>[%confirm_link_email%]</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'send_welcome_mail:not(0)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('New welcome mail title','discy'),
			'id'   => 'title_welcome_mail',
			'std'  => 'Welcome',
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New welcome mail template','discy'),
			'id'       => 'email_welcome_mail',
			'std'      => "<p>Hi [%display_name%]</p><p>Welcome to our site.</p><p>[%blogname%]</p><p><a href='[%site_url%]'>[%site_url%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'user_review:not(0),send_email_users_review:not(0)',
			'type'      => 'heading-2'
		);

		$options[] = array(
			'name' => esc_html__('New user for review title','discy'),
			'id'   => 'title_review_user',
			'std'  => "New user for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New user for review template','discy'),
			'id'       => 'email_review_user',
			'std'      => "<p>Hi there</p><p>There is a new user for the review named [%user_name%]</p><p><a href='[%users_link%]'>Review him</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'div'       => 'div',
			'condition' => 'user_review:not(0)',
			'type'      => 'heading-2'
		);
		
		$options[] = array(
			'name' => esc_html__('Approve user title','discy'),
			'id'   => 'title_approve_user',
			'std'  => "Confirm account",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Approve user template','discy'),
			'id'       => 'email_approve_user',
			'std'      => "<p>Hi there</p><p>The admin was activated your account.</p><p><a href='[%site_url%]'>[%blogname%]</a></p><p>[%site_url%]</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Reset password title','discy'),
			'id'   => 'title_new_password',
			'std'  => "Reset your password",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Reset password template','discy'),
			'id'       => 'email_new_password',
			'std'      => "<p>Someone requested that the password be reset for the following account:</p><p>Username: '[%display_name%]' ([%user_login%]).</p><p>If this was a mistake, just ignore this mail and nothing will happen.</p><p>To reset your password, visit the following address:</p><p><a href='[%confirm_link_email%]'>Click here to reset your password</a></p><p>If the link above does not work, Please use your browser to go to:</p>[%confirm_link_email%]",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variable works at this template only</h4>
			<p>[%reset_password%] - The user password.</p>',
		);
		
		$options[] = array(
			'name' => esc_html__('Reset password 2 title','discy'),
			'id'   => 'title_new_password_2',
			'std'  => "Reset your password",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Reset password 2 template','discy'),
			'id'       => 'email_new_password_2',
			'std'      => "<p>You are: [%display_name%] ([%user_login%])</p><p>The New Password: [%reset_password%]</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'report_users:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Report user title','discy'),
			'id'   => 'title_report_user',
			'std'  => "Report User",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Report user template','discy'),
			'id'       => 'email_report_user',
			'std'      => "<p>Hi there</p><p>Abuse has been reported on the use of the following user</p><p><a href='[%user_profile_sender%]'>[%display_name_sender%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Payments mails','discy'),
			'id'   => 'payments_mails',
			'type' => 'heading-2'
		);

		$options[] = array(
			'name'      => esc_html__('Note: if you need this mail template, From Discy Settings/Payment settings/Activate one of the payments functions.','discy'),
			'condition' => 'buy_points_payment:is(0),buy_points_payment:is(0),pay_ask:is(0),pay_to_sticky:is(0)',
			'type'      => 'info'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'operator'  => 'or',
			'condition' => 'buy_points_payment:not(0),buy_points_payment:not(0),pay_ask:not(0),pay_to_sticky:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at this template only</h4>
			<p>[%item_price%] - Show the item price.</p>
			<p>[%item_name%] - Show the item name.</p>
			<p>[%item_currency%] - Show the item currency.</p>
			<p>[%payer_email%] - Show the payer email.</p>
			<p>[%first_name%] - Show the payer first name.</p>
			<p>[%last_name%] - Show the payer last name.</p>
			<p>[%item_transaction%] - Show the transaction id.</p>
			<p>[%date%] - Show the payment date.</p>
			<p>[%time%] - Show the payment time.</p>',
		);
		
		$options[] = array(
			'name' => esc_html__('New payment title','discy'),
			'id'   => 'title_new_payment',
			'std'  => "Instant Payment Notification - Received Payment",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New payment template','discy'),
			'id'       => 'email_new_payment',
			'std'      => "<p>An instant payment notification was successfully received</p><p>With [%item_price%] [%item_currency%]</p><p>From [%payer_email%] [%first_name%] - [%last_name%] on [%date%] at [%time%]</p><p>The item transaction id [%item_transaction%]</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Posts and questions mails','discy'),
			'id'   => 'posts_mails',
			'type' => 'heading-2'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'active_message:not(0),send_email_message:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at Send message template and New questions template to show the details for the received user</h4>
			<p>[%user_login%] - The user login name.</p>
			<p>[%user_name%] - The user name.</p>
			<p>[%user_nicename%] - The user nice name.</p>
			<p>[%display_name%] - The user display name.</p>
			<p>[%user_email%] - The user email.</p>
			<p>[%user_profile%] - The user profile URL.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at Send message template and New questions template to show the details for the sender user</h4>
			<p>[%user_login_sender%] - The user login name.</p>
			<p>[%user_name_sender%] - The user name.</p>
			<p>[%user_nicename_sender%] - The user nice name.</p>
			<p>[%display_name_sender%] - The user display name.</p>
			<p>[%user_email_sender%] - The user email.</p>
			<p>[%user_profile_sender%] - The user profile URL.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variable works at this template only</h4>
			<p>[%messages_title%] - Show the message title.</p>',
		);
		
		$options[] = array(
			'name' => esc_html__('Send message title','discy'),
			'id'   => 'title_new_message',
			'std'  => "New message",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Send message template','discy'),
			'id'       => 'email_new_message',
			'std'      => "<p>Hi there</p><p>There is a new message</p><p><a href='[%messages_url%]'>[%messages_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'operator'  => 'or',
			'condition' => 'send_email_new_question:not(0),send_email_draft_questions:not(0),send_email_draft_posts:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'question_schedules:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Recent questions as schedules title','discy'),
			'id'   => 'title_question_schedules',
			'std'  => "Recent questions",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Recent questions as schedules template','discy'),
			'id'       => 'email_question_schedules',
			'std'      => "<p>Hi there</p><p>There are new questions</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'post_schedules:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Recent posts as schedules title','discy'),
			'id'   => 'title_post_schedules',
			'std'  => "Recent posts",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Recent posts as schedules template','discy'),
			'id'       => 'email_post_schedules',
			'std'      => "<p>Hi there</p><p>There are new posts</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name'      => esc_html__('Content after schedules mails for the recent posts and recent questions','discy'),
			'id'        => 'schedule_content_post',
			'condition' => 'post_schedules:not(0),question_schedules:not(0)',
			'operator'  => 'or',
			'std'       => "<p>[%blogname%]</p><p>[%site_url%]</p>",
			'type'      => 'editor',
			'settings'  => $wp_editor_settings
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work for all next templates</h4>
			<p>[%post_title%] - Show the post title.</p>
			<p>[%post_link%] - Show the post link.</p>
			<p>[%the_author_post%] - Show the post author.</p>',
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_new_post:not(0),send_email_new_post_both:not(0)',
			'operator'  => 'or',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New post title','discy'),
			'id'   => 'title_new_posts',
			'std'  => "New post",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New post template','discy'),
			'id'       => 'email_new_posts',
			'std'      => "<p>Hi there</p><p>There is a new post</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_new_question:not(0),send_email_new_question_both:not(0)',
			'operator'  => 'or',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New question title','discy'),
			'id'   => 'title_new_questions',
			'std'  => "New question",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New question template','discy'),
			'id'       => 'email_new_questions',
			'std'      => "<p>Hi there</p><p>There is a new question</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_draft_questions:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New question for review title','discy'),
			'id'   => 'title_new_draft_questions',
			'std'  => "New question for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New question for review template','discy'),
			'id'       => 'email_draft_questions',
			'std'      => "<p>Hi there</p><p>There is a new question for the review</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_draft_posts:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New post for review title','discy'),
			'id'   => 'title_new_draft_posts',
			'std'  => "New post for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New post for review template','discy'),
			'id'       => 'email_draft_posts',
			'std'      => "<p>Hi there</p><p>There is a new post for the review</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'active_reports:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Report question title','discy'),
			'id'   => 'title_report_question',
			'std'  => "Report Question",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Report question template','discy'),
			'id'       => 'email_report_question',
			'std'      => "<p>Hi there</p><p>Abuse has been reported on the use of the following question</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);

		$options[] = array(
			'name' => esc_html__('Groups mails','discy'),
			'id'   => 'groups_mails',
			'type' => 'heading-2'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'operator'  => 'or',
			'condition' => 'send_email_draft_groups:not(0),send_email_draft_group_posts:not(0)',
			'div'       => 'div'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_draft_groups:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New group for review title','discy'),
			'id'   => 'title_new_draft_groups',
			'std'  => "New group for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New group for review template','discy'),
			'id'       => 'email_draft_groups',
			'std'      => "<p>Hi there</p><p>There is a new group for the review</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_draft_group_posts:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('New post on the group for review title','discy'),
			'id'   => 'email_draft_group_posts',
			'std'  => "New post on the group for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New post on the group for review template','discy'),
			'id'       => 'title_new_draft_group_posts',
			'std'      => "<p>Hi there</p><p>There is a new post on the group for the review</p><p><a href='[%post_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Comments mails','discy'),
			'id'   => 'comments_mails',
			'type' => 'heading-2'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'operator'  => 'or',
			'condition' => 'active_reports:not(0),ask_question_items:has(remember_answer),question_follow:not(0),send_email_draft_comments:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at Send message template and New questions template to show the details for the received user</h4>
			<p>[%user_login%] - The user login name.</p>
			<p>[%user_name%] - The user name.</p>
			<p>[%user_nicename%] - The user nice name.</p>
			<p>[%display_name%] - The user display name.</p>
			<p>[%user_email%] - The user email.</p>
			<p>[%user_profile%] - The user profile URL.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at Notified answer template and Follow question template to show the details for the sender user</h4>
			<p>[%user_login_sender%] - The user login name.</p>
			<p>[%user_name_sender%] - The user name.</p>
			<p>[%user_nicename_sender%] - The user nice name.</p>
			<p>[%display_name_sender%] - The user display name.</p>
			<p>[%user_email_sender%] - The user email.</p>
			<p>[%user_profile_sender%] - The user profile URL.</p>',
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work for all next templates</h4>
			<p>[%post_title%] - Show the post title.</p>
			<p>[%post_link%] - Show the post link.</p>
			<p>[%the_author_post%] - Show the post author.</p>',
		);
		
		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at Report answer, Notified answer and Follow question</h4>
			<p>[%answer_url%] - Show the answer link.</p>
			<p>[%the_name%] - Show the answer author.</p>',
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'active_reports:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Report answer title','discy'),
			'id'   => 'title_report_answer',
			'std'  => "Report Answer",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Report answer template','discy'),
			'id'       => 'email_report_answer',
			'std'      => "<p>Hi there</p><p>Abuse has been reported on the use of the following comment</p><p><a href='[%answer_url%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'ask_question_items:has(remember_answer)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Notified answer title','discy'),
			'id'   => 'title_notified_answer',
			'std'  => "Answer to your question",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Notified answer template','discy'),
			'id'       => 'email_notified_answer',
			'std'      => "<p>Hi there</p><p>We would tell you [%the_author_post%] That the new post was added on a common theme by [%the_name%] Entitled [%the_name%] [%post_title%]</p><p>Click on the link below to go to the topic</p><p><a href='[%answer_url%]'>[%post_title%]</a></p><p>There may be more of Posts and we hope the answer to encourage members and get them to help.</p><p>Accept from us Sincerely</p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name'     => esc_html__('Notified reply on the answer title','discy'),
			'id'       => 'title_notified_reply',
			'std'      => "Reply to your answer",
			'type'     => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Notified reply on the answer template','discy'),
			'id'       => 'email_notified_reply',
			'std'      => "<p>Hi there</p><p>There is a new reply to your following answer</p><p><a href='[%answer_link%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'question_follow:not(0)',
			'div'       => 'div'
		);
		
		$options[] = array(
			'name' => esc_html__('Follow question title','discy'),
			'id'   => 'title_follow_question',
			'std'  => "New answer on your following question",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('Follow question template','discy'),
			'id'       => 'email_follow_question',
			'std'      => "<p>Hi there</p><p>There is a new answer to your following question</p><p><a href='[%answer_url%]'>[%post_title%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_draft_comments:not(0)',
			'div'       => 'div'
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variable works for this template</h4>
			<p>[%comment_link%] - To review the comment/answer.</p>',
		);
		
		$options[] = array(
			'name' => esc_html__('New comment/answer for review title','discy'),
			'id'   => 'title_new_draft_comments',
			'std'  => "New comment for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New comment/answer for review template','discy'),
			'id'       => 'email_draft_comments',
			'std'      => "<p>Hi there</p><p>There is a new comment for the review on this post [%post_title%]</p><p><a href='[%comment_link%]'>Review it</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
		
		$options[] = array(
			'name' => esc_html__('Other mails','discy'),
			'id'   => 'other_mails',
			'type' => 'heading-2'
		);

		$options[] = array(
			'name'      => esc_html__('Note: if you need this mail template, From Discy Settings/Question settings/Questions category settings/Activate the users to request a new category && Send mail when the category needs a review.','discy'),
			'operator'  => 'or',
			'condition' => 'send_email_add_category:is(0),allow_user_to_add_category:is(0)',
			'type'      => 'info'
		);
		
		$options[] = array(
			'type'      => 'heading-2',
			'condition' => 'send_email_add_category:not(0),allow_user_to_add_category:not(0)',
			'div'       => 'div'
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at this template only</h4>
			<p>[%category_link%] - Review the categories link.</p>
			<p>[%category_name%] - The category name.</p>',
		);

		$options[] = array(
			'name' => esc_html__('New category for review title','discy'),
			'id'   => 'title_add_category',
			'std'  => "New category for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New category for review template','discy'),
			'id'       => 'email_add_category',
			'std'      => "<p>Hi there</p><p>There is a new category for the review</p><p><a href='[%category_link%]'>[%category_name%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);
		
		$options[] = array(
			'type' => 'heading-2',
			'div'  => 'div',
			'end'  => 'end'
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at this template only</h4>
			<p>[%user_login%] - The user login name.</p>
			<p>[%user_name%] - The user name.</p>
			<p>[%user_nicename%] - The user nice name.</p>
			<p>[%display_name%] - The user display name.</p>
			<p>[%user_email%] - The user email.</p>
			<p>[%user_profile%] - The user profile URL.</p>
			<p>[%invitation_link%] - The invitation URL.</p>',
		);

		$options[] = array(
			'name' => esc_html__('New invitation','discy'),
			'id'   => 'title_new_invitation',
			'std'  => "New invitation",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New invitation template','discy'),
			'id'       => 'email_new_invitation',
			'std'      => "<p>Hi there</p><p>There is a new invitation for you from your friend [%display_name%]</p><p><a href='[%invitation_link%]'>Join to [%blogname%] site</a></p><p><a href='[%invitation_link%]'>[%invitation_link%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type'    => 'content',
			'content' => '<h4>Variables work at this template only</h4>
			<p>[%request_link%] - Review the request link.</p>
			<p>[%request_name%] - The request name.</p>',
		);

		$options[] = array(
			'name' => esc_html__('New request for review title','discy'),
			'id'   => 'title_new_request',
			'std'  => "New request for review",
			'type' => 'text'
		);
		
		$options[] = array(
			'name'     => esc_html__('New request for review template','discy'),
			'id'       => 'email_new_request',
			'std'      => "<p>Hi there</p><p>There is a new request for the review</p><p><a href='[%request_link%]'>[%request_name%]</a></p>",
			'type'     => 'editor',
			'settings' => $wp_editor_settings
		);

		$options[] = array(
			'type' => 'heading-2',
			'end'  => 'end'
		);
	}
	
	$options[] = array(
		'name'    => esc_html__('Footer settings','discy'),
		'id'      => 'footer',
		'icon'    => 'tagcloud',
		'type'    => 'heading',
		'std'     => 'footer_general',
		'options' => array(
			"footer_general"  => esc_html__('General setting','discy'),
			"footer_main"     => esc_html__('Main Footer setting','discy'),
			"footer_bottom"   => esc_html__('Bottom footer setting','discy'),
			"footer_sort"     => esc_html__('Sort footer elements','discy')
		)
	);
	
	$options[] = array(
		'name' => esc_html__('General setting','discy'),
		'id'   => 'footer_general',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'    => esc_html__('Footer style','discy'),
		'desc'    => esc_html__('Choose the footer style.','discy'),
		'id'      => 'footer_style',
		'std'     => 'footer',
		'type'    => 'radio',
		'options' => array("footer" => esc_html__("Normal footer","discy"),"sidebar" => esc_html__("After sidebar","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Footer skin','discy'),
		'desc'      => esc_html__('Choose the footer skin.','discy'),
		'id'        => 'footer_skin',
		'std'       => 'dark',
		'type'      => 'radio',
		'condition' => 'footer_style:not(sidebar)',
		'options'   => array("dark" => esc_html__("Dark","discy"),"light" => esc_html__("Light","discy"))
	);
	
	$options[] = array(
		'name'      => esc_html__('Footer menu enable or disable','discy'),
		'id'        => 'active_footer_menu',
		'std'       => 'on',
		'condition' => 'footer_style:not(footer)',
		'type'      => 'checkbox'
	);
	
	$options[] = array(
		'name'      => esc_html__("Choose from here what's menu will show after sidebar.","discy"),
		'id'        => 'footer_menu',
		'type'      => 'select',
		'condition' => 'footer_style:not(footer),active_footer_menu:not(0)',
		'options'   => $menus
	);
	
	$options[] = array(
		'name'      => esc_html__('Copyrights','discy'),
		'desc'      => esc_html__('Put the copyrights of footer.','discy'),
		'id'        => 'footer_copyrights',
		'std'       => '&copy; '.date('Y').' Discy. All Rights Reserved<br>With Love by <a href="https://2code.info/" target="_blank">2code</a>.',
		'operator'  => 'or',
		'condition' => 'footer_style:not(footer),bottom_footer:not(0)',
		'type'      => 'textarea'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Main Footer setting','discy'),
		'id'   => 'footer_main',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'      => esc_html__('The main footer work when you choose the footer style as normal footer.','discy'),
		'condition' => 'footer_style:not(footer)',
		'type'      => 'info'
	);
	
	$options[] = array(
		'type'      => 'heading-2',
		'condition' => 'footer_style:not(sidebar)',
		'div'       => 'div'
	);
	
	$options[] = array(
		'name' => esc_html__('Top footer enable or disable','discy'),
		'id'   => 'top_footer',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'top_footer:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Footer widget icons enable or disable','discy'),
		'id'   => 'footer_widget_icons',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Top footer padding top','discy'),
		"id"   => "top_footer_padding_top",
		"type" => "sliderui",
		"std"  => "0",
		"step" => "1",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'name' => esc_html__('Top footer padding bottom','discy'),
		"id"   => "top_footer_padding_bottom",
		"type" => "sliderui",
		"std"  => "0",
		"step" => "1",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'name'    => esc_html__('Footer Layout','discy'),
		'desc'    => esc_html__('Footer columns Layout.','discy'),
		'id'      => "footer_layout",
		'std'     => "footer_5c",
		'type'    => "images",
		'options' => array(
			'footer_1c' => $imagepath.'footer_1c.jpg',
			'footer_2c' => $imagepath.'footer_2c.jpg',
			'footer_3c' => $imagepath.'footer_3c.jpg',
			'footer_4c' => $imagepath.'footer_4c.jpg',
			'footer_5c' => $imagepath.'footer_5c.jpg')
	);
	
	$footer_elements = array(
		array(
			"type" => "color",
			"id"   => "background_color",
			"name" => esc_html__('Background color','discy')
		),
		array(
			"type"  => "slider",
			"id"    => "padding_top",
			"name"  => esc_html__('Padding top','discy'),
			"std"   => "0",
			"step"  => "1",
			"min"   => "0",
			"max"   => "100",
			"value" => "0"
		),
		array(
			"type"  => "slider",
			"id"    => "padding_bottom",
			"name"  => esc_html__('Padding bottom','discy'),
			"std"   => "0",
			"step"  => "1",
			"min"   => "0",
			"max"   => "100",
			"value" => "0"
		),
		array(
			"type"    => "images",
			"id"      => "layout",
			"name"    => esc_html__('Layout','discy'),
			'std'     => "footer_5c",
			'options' => array(
				'footer_1c' => $imagepath.'footer_1c.jpg',
				'footer_2c' => $imagepath.'footer_2c.jpg',
				'footer_3c' => $imagepath.'footer_3c.jpg',
				'footer_4c' => $imagepath.'footer_4c.jpg',
				'footer_5c' => $imagepath.'footer_5c.jpg')
		),
		array(
			"type"      => "select",
			"id"        => "first_column",
			"name"      => esc_html__('Select first column','discy'),
			'condition' => '[%id%]layout:is(footer_1c),[%id%]layout:is(footer_2c),[%id%]layout:is(footer_3c),[%id%]layout:is(footer_4c),[%id%]layout:is(footer_5c)',
			'operator'  => 'or',
			'options'   => $new_sidebars
		),
		array(
			"type"      => "select",
			"id"        => "second_column",
			"name"      => esc_html__('Select second column','discy'),
			'condition' => '[%id%]layout:is(footer_2c),[%id%]layout:is(footer_3c),[%id%]layout:is(footer_4c),[%id%]layout:is(footer_5c)',
			'operator'  => 'or',
			'options'   => $new_sidebars
		),
		array(
			"type"      => "select",
			"id"        => "third_column",
			"name"      => esc_html__('Select third column','discy'),
			'condition' => '[%id%]layout:is(footer_3c),[%id%]layout:is(footer_4c),[%id%]layout:is(footer_5c)',
			'operator'  => 'or',
			'options'   => $new_sidebars
		),
		array(
			"type"      => "select",
			"id"        => "fourth_column",
			"name"      => esc_html__('Select fourth column','discy'),
			'condition' => '[%id%]layout:is(footer_4c),[%id%]layout:is(footer_5c)',
			'operator'  => 'or',
			'options'   => $new_sidebars
		),
		array(
			"type"      => "select",
			"id"        => "fifth_column",
			"name"      => esc_html__('Select fifth column','discy'),
			'condition' => '[%id%]layout:is(footer_5c)',
			'operator'  => 'or',
			'options'   => $new_sidebars
		),
	);
	
	$options[] = array(
		'id'      => "add_footer",
		'type'    => "elements",
		'button'  => esc_html__('Add a new footer level','discy'),
		'hide'    => "yes",
		'options' => $footer_elements,
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end',
		'div'  => 'div'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Bottom footer setting','discy'),
		'id'   => 'footer_bottom',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'      => esc_html__('The bottom footer work when you choose the footer style as normal footer.','discy'),
		'condition' => 'footer_style:not(footer)',
		'type'      => 'info'
	);
	
	$options[] = array(
		'type'      => 'heading-2',
		'condition' => 'footer_style:not(sidebar)',
		'div'       => 'div'
	);
	
	$options[] = array(
		'name' => esc_html__('Bottom footer enable or disable','discy'),
		'id'   => 'bottom_footer',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'bottom_footer:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Bottom footer padding top','discy'),
		"id"   => "footer_padding_top",
		"type" => "sliderui",
		"std"  => "0",
		"step" => "1",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'name' => esc_html__('Bottom footer padding bottom','discy'),
		"id"   => "footer_padding_bottom",
		"type" => "sliderui",
		"std"  => "0",
		"step" => "1",
		"min"  => "0",
		"max"  => "100"
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end',
		'div'  => 'div'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Sort the footer elements','discy'),
		'id'   => 'footer_sort',
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'name'      => esc_html__('The sort footer elements work when you choose the footer style as normal footer.','discy'),
		'condition' => 'footer_style:not(footer)',
		'type'      => 'info'
	);
	
	$options[] = array(
		'id'        => "sort_footer_elements",
		'condition' => 'footer_style:not(sidebar)',
		'std'       => array(
						array("value" => "top_footer",'name' => esc_html__('Top footer','discy'),"default" => "yes"),
						array("value" => "bottom_footer",'name' => esc_html__('Bottom footer','discy'),"default" => "yes")
					),
		'type'      => "sort",
		'options'   => array(
						array("value" => "top_footer",'name' => esc_html__('Top footer','discy'),"default" => "yes"),
						array("value" => "bottom_footer",'name' => esc_html__('Bottom footer','discy'),"default" => "yes")
					)
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('Advanced settings','discy'),
		'id'   => "advanced_setting",
		'icon' => 'upload',
		'type' => 'heading',
	);
	
	$options[] = array(
		'type' => 'heading-2'
	);
	
	$options[] = array(
		'id'   => 'uniqid_cookie',
		'std'  => (has_wpqa()?wpqa_token(15):rand(1,100000)),
		'type' => 'hidden'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate this option ON only if you have used Ask Me theme before.','discy'),
		'id'   => 'ask_me',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Do you need to activate the views at your site?','discy'),
		'id'   => 'active_post_stats',
		'std'  => 'on',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'div'       => 'div',
		'condition' => 'active_post_stats:not(0)',
		'type'      => 'heading-2'
	);
	
	$options[] = array(
		'name' => esc_html__('Post meta stats field.','discy'),
		'desc' => esc_html__('Change this if you have used a post views plugin before.','discy'),
		'id'   => 'post_meta_stats',
		'std'  => 'post_stats',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('Do you need to activate cache for views at your site?','discy'),
		'id'   => 'cache_post_stats',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'name' => esc_html__('Activate the visits at the site work by cookie','discy'),
		'desc' => esc_html__('Select ON if you want to active the cookie for the visits at the site.','discy'),
		'id'   => 'visit_cookie',
		'type' => 'checkbox'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'div'  => 'div',
		'end'  => 'end'
	);
	
	$options[] = array(
		'name' => esc_html__('User meta avatar field.','discy'),
		'desc' => esc_html__('Change this if you have used a user avatar or social plugin before.','discy'),
		'id'   => 'user_meta_avatar',
		'std'  => 'your_avatar',
		'type' => 'text'
	);
	
	$options[] = array(
		'name' => esc_html__('User meta cover field.','discy'),
		'desc' => esc_html__('Change this if you have used a user cover or social plugin before.','discy'),
		'id'   => 'user_meta_cover',
		'std'  => 'your_cover',
		'type' => 'text'
	);

	$html_content = '<a class="button fixed-site-counts" href="'.admin_url("admin.php?page=options&rows=fixed").'">'.esc_html__("Fixed all the site counts","discy").'</a>';
	$options[] = array(
		'name' => $html_content,
		'type' => 'info'
	);
	
	$options[] = array(
		'name' => esc_html__('If you want to export setting please refresh the page before that','discy'),
		'type' => 'info'
	);

	$options[] = array(
		'name' => '<a href="'.add_query_arg(array('page' => 'options','backup' => 'settings'),admin_url('admin.php')).'" class="button button-primary backup-settings">'.esc_html__('Backup your settings','discy').'</a>',
		'type' => 'info'
	);

	$options[] = array(
		'name'   => esc_html__('Export Setting','discy'),
		'desc'   => esc_html__('Copy this to saved file','discy'),
		'id'     => 'export_setting',
		'export' => $current_options_e,
		'type'   => 'export'
	);

	$options[] = array(
		'name' => esc_html__('Import Setting','discy'),
		'desc' => esc_html__('Put here the import setting','discy'),
		'id'   => 'import_setting',
		'type' => 'import'
	);
	
	$options[] = array(
		'type' => 'heading-2',
		'end'  => 'end'
	);
	
	return $options;
}?>